unit AfDocs;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, CompCadreIma2, StdCtrls, ComCtrls;

type
  TAfficheDocs = class(TForm)
    ImageCar: TCadreImage2;
    TexteCar: TRichEdit;
    PanelInfo: TPanel;
    BAfficherLegendes: TButton;
    AMesure: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BAfficherLegendesClick(Sender: TObject);
    procedure ImageCarMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImageCarMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageCarMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Image:TList; //Array[0..5] of TCadreImage2;
    htIm,largIm:integer;
    procedure IllustreEtats(NomCarD:string);
    procedure AfficheTaxon(NomTaxon:string);
    procedure AfficheTaxonEtCarD(NomTaxon,NomCarD,LEtat:string);
    procedure AfficheCarD(NomTaxon,NomCarD,LEtat:string);
  end;

var
  AfficheDocs: TAfficheDocs;

implementation
uses StructureDonnees,donnees,math,GestionTextes,utils;
{$R *.dfm}

procedure TAfficheDocs.FormCreate(Sender: TObject);
begin
  Image:=TList.Create;
  Image.Add(ImageCar);
  htIm:=ImDocH+19;
  largIm:=ImDocW+14;
  ImageCar.Height:=htIm;
  ImageCar.Width:=largim;
  TexteCar.Width:=largIm;
  TexteCar.Height:=htIm;
  BAfficherLegendes.Caption:=B_AfficherLegende;
  PanelInfo.Visible:=False;
  AMesure.Visible:=False;
  BAfficherLegendes.Visible:=False;
end;
procedure TAfficheDocs.FormDestroy(Sender: TObject);
Var
  UneImage:TCadreImage2;
  i:integer;
begin
  For i:=Image.Count-1 downto 1 do
    begin
      uneImage:=TCadreImage2(Image[i]);
      uneImage.Free;
    end;
  Image.Free;
end;
procedure TAfficheDocs.AfficheTaxon(NomTaxon:string);
Var
  NomTexteCar,NomImageCar:string;
  NumTaxon,w,i:integer;
  trouve:boolean;
  UneImage:TCadreImage2;
  LeStream : TMemoryStream;
begin
  ImageCar.Height:=htIm;
  ImageCar.Width:=largim;
  AMesure.Visible:=False;
  BAfficherLegendes.Visible:=False;
  PanelInfo.Visible:=False;
  NumTaxon:=LaSouscollection.Taxons.GetNumTaxon(NomTaxon);
  if NumTaxon>-1 then
    begin
      NomTexteCar:= LaSousCollection.Taxons.GetTexteCar(NumTaxon,0);
      NomImageCar:= LaSousCollection.Taxons.GetImage(NumTaxon);//.GetImageCar(NumTaxon,0);
      trouve:=false;
      w:=0;
      if FichierInternet(NomTexteCar) then
        begin
          LeStream :=ChargeFichier_el(NomTexteCar,false);
          try
            if LeStream.Size > 0 then
              begin
                ClientHeight:=htIm+2;
                TexteCar.Visible:=true;
                TexteCar.Lines.LoadFromStream(LeStream);
                w:=largIm+2;
                TexteCar.Left:=1;
              end;
          finally
            LeStream.Free;
          end;
        end
      else
        begin
          If FileExists(NomTexteCar) then
            begin
              ClientHeight:=htIm+2;
              TexteCar.Visible:=true;
              TexteCar.Lines.LoadFromFile(NomTexteCar);
              w:=largIm+2;
              TexteCar.Left:=1;
            end;
        end;
      If ExisteFichier(NomImageCar) then
        begin
          if w=0 then TexteCar.Visible:=false;
          ImageCar.Left:=w+1;
          ClientHeight:=htIm+2;
          if PanelInfo.Visible then
            ClientHeight:=ClientHeight+PanelInfo.Height;
          trouve:=true;
          ImageCar.Affiche(NomImageCar,'');
          If imageCar.Echelle.active then
            begin
              AMesure.Visible:=True;
              PanelInfo.Visible:=True;
            end;
          If ImageCar.ADesLegendes then
            begin
              BAfficherLegendes.Visible:=True;
              PanelInfo.Visible:=True;
              if BAfficherLegendes.Caption=B_AfficherLegende then
                ImageCar.EffaceLegendes
              else
                begin
                  ImageCar.EffaceLegendes;
                  ImageCar.AfficheLegendes;
                end;
            end;
          w:=w+largIm+2;
        end;
      ImageCar.Visible:=trouve;
      if trouve then ImageCar.Height:=htIm+2;
      if w>0 then
        begin
          Caption:=LaSousCollection.Taxons.GetNom(NumTaxon);
          ClientWidth:=w+4;
          For i:=Image.Count-1 downto 1 do
            begin
              UneImage:=TCadreImage2(Image[i]);
              UneImage.Free;
              Image.Delete(i);
            end;
          Show;
        end;
    end;
end;
procedure TAfficheDocs.IllustreEtats(NomCarD:string);
Var
  //NomTexteCar,NomImageCar:string;
  NumCarD,i,prem:integer; //,w
  //trouve:boolean;
  UnCarD:TCaractD;
  ListeDocs:TStringList;
  CopieListe:TStringList;
  NbDocs:integer;
  NomDoc:string;
  TexteCom:string;
  UneImage:TCadreImage2;
begin
  ImageCar.Height:=htIm;
  ImageCar.Width:=largim;
  NumCarD:=LaSouscollection.Caracteres.GetNumCarD(NomCarD);
  UnCarD:=LaSouscollection.LeCarD(NomCarD);
  AMesure.Visible:=False;
  BAfficherLegendes.Visible:=False;
  PanelInfo.Visible:=False;
  if (UnCarD<>Nil)and (NumCarD>-1) then
    begin
      ListeDocs:=UnCarD.ListeDocEtats;
      CopieListe:=TStringList.Create;
      for i:=0 to ListeDocs.Count-1 do
        if trim(ListeDocs.Strings[i])<>'' then
          begin
            NomDoc:=LaSouscollection.Caracteres.GetDocEtat(NumCarD,i);
            if ExisteFichier(NomDoc) then
              CopieListe.Add(NomDoc);
          end
        else CopieListe.Add('');
      For i:=CopieListe.Count-1 Downto 0 do
        if trim(CopieListe[i])='' then CopieListe.Delete(i)
        else break;
      prem:=CopieListe.Count;
      For i:=0 to CopieListe.Count-1 do
        if trim(CopieListe[i])<>'' then
          begin
            prem:=i;
            break;
          end;
      if (CopieListe.Count-prem)>0 then
        begin
          Caption:=UnCarD.Nom;
          Textecar.Visible:=false;
          //if CopieListe.Count>1 then
            TexteCom:=UnCarD.Nom+' = '+UnCarD.ListeEtats[prem];
          //else TexteCom:=UnCarD.Nom;
          ImageCar.Affiche(CopieListe[prem],texteCom);
          imageCar.Refresh;
          If imageCar.Echelle.active then
            begin
              AMesure.Visible:=True;
              PanelInfo.Visible:=True;
            end;
          If ImageCar.ADesLegendes then
            begin
              BAfficherLegendes.Visible:=True;
              PanelInfo.Visible:=True;
              if BAfficherLegendes.Caption=B_AfficherLegende then
                ImageCar.EffaceLegendes
              else
                begin
                  ImageCar.EffaceLegendes;
                  ImageCar.AfficheLegendes;
                end;
            end;

          NbDocs:=1;
          for i:= prem+1 to CopieListe.Count-1 do
            if (trim(CopieListe[i])<>'') and(UnCarD.ListeEtats[i]<>'?') then
              begin
                TexteCom:=UnCarD.Nom+' = '+UnCarD.ListeEtats[i];
                if Image.Count<(NbDocs+1) then
                  begin
                    UneImage:=TCadreImage2.Create(Self);
                    UneImage.Parent:=Self;
                    UneImage.Width:=largIm;
                    UneImage.Height:=htIm;
                    Image.Add(UneImage);
                  end
                else
                  begin
                    UneImage:=TCadreImage2(Image.Items[i]);
                  end;
                UneImage.Affiche(CopieListe[i],texteCom);
                If UneImage.Echelle.active then
                  begin
                    UneImage.OnMouseDown:=ImageCarMouseDown;
                    UneImage.OnMouseUp:=ImageCarMouseUp;
                    UneImage.OnMouseMove:=ImageCarMouseMove;
                    AMesure.Visible:=True;
                    PanelInfo.Visible:=True;
                  end;
                If UneImage.ADesLegendes then
                  begin
                    BAfficherLegendes.Visible:=True;
                    PanelInfo.Visible:=True;
                    if BAfficherLegendes.Caption=B_AfficherLegende then
                      UneImage.EffaceLegendes
                    else
                      begin
                        UneImage.EffaceLegendes;
                        UneImage.AfficheLegendes;
                      end;
                  end;
                inc(NbDocs);
              end;
          for i:=Image.Count-1 downto NbDocs do
            begin
              UneImage:=TCadreImage2(Image.Items[i]);
              UneImage.Free;
              Image.Delete(i);
            end;
          NbDocs:=Image.Count;
          ClientHeight:=((NbDocs+1) div 2)*(htIm+2)+4;
          if PanelInfo.Visible then
            ClientHeight:=ClientHeight+PanelInfo.Height;
          if NbDocs=1 then ClientWidth:=largIm+2 else ClientWidth:=2*largIm+4;

          for i:=0 to NbDocs-1 do
            begin
              UneImage:=TCadreImage2(Image.Items[i]);
              UneImage.Left:=1+(i mod 2)*(largIm+1);
              UneImage.Top:=1+(i div 2)*(htIm+1);
            end;
          Show;
        end
      else
        Close;
    end
  else
    Close;
end;
procedure TAfficheDocs.AfficheTaxonEtCarD(NomTaxon,NomCarD,LEtat:string);
var
  NomTexteCar,NomImageCar:string;
  NumCarD,w,i,NumCaract:integer;
  UnCarD:TCaractD;
  NumTaxon:integer;
  trouve:boolean;
  UneImage:TCadreImage2;
  NbDocs:integer;
  TexteCom:string;
  LeStream : TMemoryStream;
begin
  ImageCar.Height:=htIm;
  ImageCar.Width:=largim;
  NumTaxon:=LaSouscollection.Taxons.GetNumTaxon(NomTaxon);
  AMesure.Visible:=False;
  BAfficherLegendes.Visible:=False;
  PanelInfo.Visible:=False;
  if NumTaxon>-1 then
    begin
      NomTexteCar:= LaSousCollection.Taxons.GetTexteCar(NumTaxon,0);
      NomImageCar:= LaSousCollection.Taxons.GetImageCar(NumTaxon,0);
      trouve:=false;
      w:=0;
      if FichierInternet(NomTexteCar) then
        begin
          LeStream :=ChargeFichier_el(NomTexteCar,false);
          try
            if LeStream.Size > 0 then
              begin
                ClientHeight:=htIm+2;
                TexteCar.Visible:=true;
                TexteCar.Lines.LoadFromStream(LeStream);
                w:=largIm+2;
                TexteCar.Left:=1;
              end;
          finally
            LeStream.Free;
          end;
        end
      else
        begin
          If FileExists(NomTexteCar) then
            begin
              ClientHeight:=htIm+2;
              TexteCar.Visible:=true;
              TexteCar.Lines.LoadFromFile(NomTexteCar);
              w:=largIm+2;
              TexteCar.Left:=1;
            end;
        end;
      If ExisteFichier(NomImageCar) then
        begin
          if w=0 then TexteCar.Visible:=false;
          ImageCar.Left:=w+1;
          ClientHeight:=htIm+2;
          if PanelInfo.Visible then
            ClientHeight:=ClientHeight+PanelInfo.Height;
          trouve:=true;
          ImageCar.Affiche(NomImageCar,'');
          w:=w+largIm+2;
          If imageCar.Echelle.active then
            begin
              AMesure.Visible:=True;
              PanelInfo.Visible:=True;
            end;
          If ImageCar.ADesLegendes then
            begin
              BAfficherLegendes.Visible:=True;
              PanelInfo.Visible:=True;
              if BAfficherLegendes.Caption=B_AfficherLegende then
                ImageCar.EffaceLegendes
              else
                begin
                  ImageCar.EffaceLegendes;
                  ImageCar.AfficheLegendes;
                end;
            end;
        end;
      ImageCar.Visible:=trouve;
      if trouve then
        begin
          ImageCar.Height:=htIm+2;
          NbDocs:=1;
        end
      else NbDocs:=0;
      NumCarD:=LaSouscollection.Caracteres.GetNumCarD(NomCarD);
      UnCarD:=LaSousCollection.LeCarD(NomCarD);
      if (UnCarD<>Nil)and(NumCarD>-1) then
        begin
          NumCaract:= LaSousCollection.Caracteres.GetNumCarParent(NumCarD);
          if NumCaract>-1 then
            begin
              NomImageCar:=LaSousCollection.Taxons.GetImageCar(NumTaxon,NumCaract);
              if ExisteFichier(NomImageCar) then
                begin
                  TexteCom:=UnCarD.Nom+' = '+LEtat;
                  if Image.Count<(NbDocs+1) then
                    begin
                      UneImage:=TCadreImage2.Create(Self);
                      UneImage.Parent:=Self;
                      UneImage.Width:=largIm;
                      UneImage.Height:=htIm;
                      Image.Add(UneImage);
                    end
                  else UneImage:=TCadreImage2(Image.Items[NbDocs]);
                  UneImage.Affiche(NomImageCar,texteCom);
                  If UneImage.Echelle.active then
                    begin
                      UneImage.OnMouseDown:=ImageCarMouseDown;
                      UneImage.OnMouseUp:=ImageCarMouseUp;
                      UneImage.OnMouseMove:=ImageCarMouseMove;
                      AMesure.Visible:=True;
                      PanelInfo.Visible:=True;
                    end;
                  If UneImage.ADesLegendes then
                    begin
                      BAfficherLegendes.Visible:=True;
                      PanelInfo.Visible:=True;
                      if BAfficherLegendes.Caption=B_AfficherLegende then
                        UneImage.EffaceLegendes
                      else
                        begin
                          UneImage.EffaceLegendes;
                          UneImage.AfficheLegendes;
                        end;
                    end;
                  inc(NbDocs);

                  if (w=0) then UneImage.Left:=1
                  else UneImage.Left:=largIm+3;
                  if (w>largIm+4) then
                    begin
                      UneImage.Top:=htIm+3;
                      ClientHeight:=2*htIm+8;
                      if PanelInfo.Visible then
                        ClientHeight:=ClientHeight+PanelInfo.Height;
                    end
                  else
                    begin
                      UneImage.Top:=1;
                      ClientHeight:=htIm+4;
                      if PanelInfo.Visible then
                        ClientHeight:=ClientHeight+PanelInfo.Height;
                    end;
                  UneImage.visible:=True;
                end;
            end;
        end;

      if w>0 then
        begin
          Caption:=LaSousCollection.Taxons.GetNom(NumTaxon);
          For i:=Image.Count-1 downto max(1,NbDocs) do
            begin
              UneImage:=TCadreImage2(Image[i]);
              UneImage.Free;
              Image.Delete(i);
            end;
          Show;
        end; 
    end;
end;
procedure TAfficheDocs.AfficheCarD(NomTaxon,NomCarD,LEtat:string);
var
  NomTexteCar,NomImageCar:string;
  NumCarD,w,i,NumCaract:integer;
  UnCarD:TCaractD;
  NumTaxon:integer;
  //trouve:boolean;
  UneImage:TCadreImage2;
  NbDocs:integer;
  TexteCom:string;
  imgb:boolean;
  LeStream : TMemoryStream;
begin
  ImageCar.Height:=htIm;
  ImageCar.Width:=largim;
  NumTaxon:=LaSouscollection.Taxons.GetNumTaxon(NomTaxon);
  PanelInfo.Visible:=False;
  AMesure.Visible:=False;
  BAfficherLegendes.Visible:=False;
  if NumTaxon>-1 then
    begin
      NumCarD:=LaSouscollection.Caracteres.GetNumCarD(NomCarD);
      UnCarD:=LaSousCollection.LeCarD(NomCarD);
      w:=0;
      NbDocs:=0;
      if (UnCarD<>Nil)and(NumCarD>-1) then
        begin
          NumCaract:= LaSousCollection.Caracteres.GetNumCarParent(NumCarD);
          if NumCaract>-1 then
            begin
              NomTexteCar:= LaSousCollection.Taxons.GetTexteCar(NumTaxon,NumCaract);
              if FichierInternet(NomTexteCar) then
                begin
                  LeStream :=ChargeFichier_el(NomTexteCar,false);
                  try
                    if LeStream.Size > 0 then
                      begin
                        ClientHeight:=htIm+2;
                        TexteCar.Visible:=true;
                        TexteCar.Lines.LoadFromStream(LeStream);
                        w:=largIm+2;
                        TexteCar.Left:=1;
                      end
                    else TexteCar.Visible:=false;
                  finally
                    LeStream.Free;
                  end;
                end
              else
                begin
                  If FileExists(NomTexteCar) then
                    begin
                      ClientHeight:=htIm+2;
                      TexteCar.Visible:=true;
                      TexteCar.Lines.LoadFromFile(NomTexteCar);
                      w:=largIm+2;
                      TexteCar.Left:=1;
                    end
                  else TexteCar.Visible:=false;
                end;
              NomImageCar:=LaSousCollection.Taxons.GetImageCarBig(NumTaxon,NumCaract);
              if ExisteFichier(NomImageCar) then
                imgb:=True
              else
                begin
                  imgb:=false;
                  NomImageCar:=LaSousCollection.Taxons.GetImageCar(NumTaxon,NumCaract);
                end;
                
              if ExisteFichier(NomImageCar) then
                begin
                  TexteCom:=UnCarD.Nom+' = '+LEtat;
                  if Image.Count<(NbDocs+1) then
                    begin
                      UneImage:=TCadreImage2.Create(Self);
                      UneImage.Parent:=Self;
                      UneImage.Width:=largIm;
                      UneImage.Top:=1;
                      Image.Add(UneImage);
                    end
                  else UneImage:=TCadreImage2(Image.Items[NbDocs]);
                  if imgb then
                    begin
                      UneImage.Height:=ImDocBH+19;
                    end
                  else
                    UneImage.Height:=htIm;
                  UneImage.Affiche(NomImageCar,texteCom);
                  If UneImage.Echelle.active then
                    begin
                      UneImage.OnMouseDown:=ImageCarMouseDown;
                      UneImage.OnMouseUp:=ImageCarMouseUp;
                      UneImage.OnMouseMove:=ImageCarMouseMove;
                      AMesure.Visible:=True;
                      PanelInfo.Visible:=True;
                    end;
                  If UneImage.ADesLegendes then
                    begin
                      BAfficherLegendes.Visible:=True;
                      PanelInfo.Visible:=True;
                      if BAfficherLegendes.Caption=B_AfficherLegende then
                        UneImage.EffaceLegendes
                      else
                        begin
                          UneImage.EffaceLegendes;
                          UneImage.AfficheLegendes;
                        end;
                    end;
                  UneImage.Top:=1;
                  ClientHeight:=UneImage.Height+2;
                  if PanelInfo.Visible then
                    ClientHeight:=ClientHeight+PanelInfo.Height;
                  inc(NbDocs);
                  if (w=0) then UneImage.Left:=1
                  else UneImage.Left:=largIm+3;
                  w:=w+largIm+2;  
                  UneImage.visible:=True;
                end;
            end
          else
            AfficheTaxon(NomTaxon);
        end;
      if w>0 then
        begin
          Caption:=LaSousCollection.Taxons.GetNom(NumTaxon);
          For i:=Image.Count-1 downto max(1,NbDocs) do
            begin
              UneImage:=TCadreImage2(Image[i]);
              UneImage.Free;
              Image.Delete(i);
            end;
          ClientWidth:=w;
          Show;
        end;
    end;
end;

procedure TAfficheDocs.BAfficherLegendesClick(Sender: TObject);
Var
  i:integer;
  UneImage:TCadreImage2;//(Image.Items[NbDocs])
begin
  for i:=0 to Image.Count-1 do
    begin
      UneImage:=TCadreImage2(Image.Items[i]);
      if UneImage.Visible and UneImage.ADesLegendes then
        UneImage.AfficheLegendes;
      if UneImage.LegendesAffichees then
        BAfficherLegendes.Caption:=B_MasquerLegende//'Masquer les lgendes'
      else
        BAfficherLegendes.Caption:=B_AfficherLegende;//'Afficher les lgendes';
    end;
end;

procedure TAfficheDocs.ImageCarMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
Var
  UneImage:TCadreImage2;
begin
  UneImage:=(Sender as TCadreImage2);
  If (UneImage<>Nil) and UneImage.Echelle.active then
    AMesure.Text:=UneImage.Mesure;
end;

procedure TAfficheDocs.ImageCarMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var
  UneImage:TCadreImage2;
begin
  UneImage:=(Sender as TCadreImage2);
  If (UneImage<>Nil) and UneImage.Echelle.active then
    AMesure.Text:=UneImage.Mesure;
end;

procedure TAfficheDocs.ImageCarMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  AMesure.Text:='';
end;

end.
