unit PhylObs;

// DL 17/07/01 modif FormClose pour corriger bug sur ouverture successive de 2
//             fichiers d'images diffrents

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, BarreIc, jpeg, ComCtrls, CompCadreIma2,StructureDonnees,Donnees;

type
  TFormObs = class(TForm)
    NomEsp: TLabel;
    NomCar: TLabel;
    TexteCar: TRichEdit;
    ImageEsp: TCadreImage2;
    ImageCar: TCadreImage2;
    RectFoc: TShape;
    MemoCopie: TMemo;
    BoutonDater: TButton;
    AMesure: TEdit;
    BAfficherLegendes: TButton;
    AMesureEsp: TEdit;
    procedure AfficheEspece(NumEsp:integer);
    procedure AfficheCaract(NumEsp,NumCar:integer);
    procedure FormCreate(Sender: TObject);
    procedure ImageClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure TexteCarMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ACopier(Sender: TObject);
    procedure BoutonDaterClick(Sender: TObject);
    procedure ImageCarMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImageCarMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageCarMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BAfficherLegendesClick(Sender: TObject);
  private
    { Dclarations prives }
    FSelection:TStringList;     // Pour compatibilit avec PhylComp et PhylChoi
    function GetSelection: TStringList;
    function GetTaxon:TTaxon;
    procedure ChargeLangue;

  public
    { Dclarations publiques }
    property Selection:TStringList read GetSelection;
    property TaxonSelect:TTaxon read GetTaxon;
    procedure ChargeDoc(NomDoc:string);
    procedure EffacerBoutons;
    procedure AjusterBoutons;
  end;

var
  FormObs: TFormObs;

implementation

uses PhylMain, BarreCar,PhylBig, PhylGlo, PhylDef,utils,PhylDaterObs,phylOrganiserObs,GestionTextes;
{$R *.DFM}

function TFormObs.GetTaxon:TTaxon;
Var
  NumTaxon:integer;
begin
  Result:=nil;
  if selection.Count>0 then
    begin
      NumTaxon:=LaSousCollection.Taxons.GetNumTaxon(Selection[0]);
      if NumTaxon>-1 then
        Result:=TTaxon(LaSousCollection.Taxons.Items[NumTaxon]);
    end;
end;
procedure TFormObs.ChargeDoc(NomDoc:string);
Var
  Ext:string;
  LeStream : TMemoryStream;
  JPEGImage:TJPEGImage;
  Chaine : string;
  RepTemp:String;
  //larg,haut:integer;
begin
  Ext:=UpperCase(ExtraitExtension(NomDoc));
  MemoCopie.Visible:=False;
  TexteCar.Visible:=false;
  ImageCar.Visible:=false;
  EffacerBoutons;
  if FichierInternet(CheminCaract) then
    begin
      Chaine:=CheminCaract+TaxonSelect.Image;
      if Chaine[Length(Chaine)] <> '/' then
        Chaine:=Chaine+'/'+NomDoc
      else
        Chaine:=Chaine+NomDoc;
      LeStream :=ChargeFichier_el(Chaine,false);
      try
        if (Ext='.TXT') then
          begin
            TexteCar.Lines.LoadFromStream(LeStream);
            TexteCar.Visible:=True;
          end
        else if (Ext='.RTF') then
          begin
            TexteCar.Lines.LoadFromStream(LeStream);
            TexteCar.Visible:=True;
          end
        else if (Ext='.JPG') then
          begin
            ImageCar.Top:=ImageEsp.Top;
            ImageCar.Height:=2*HauteurPetiteImage;
            JPEGImage:=TJPEGImage.Create;
            try
            JPEGImage.LoadFromStream(LeStream);
            if (JPEGImage.Width<=ImDocW) and (JPEGImage.Height<=ImDocBH) then
              begin
                ImageCar.AfficheStream(LeStream,Ext,'');
                ImageCar.Visible:=True;
                AjusterBoutons;
             end
            else
              begin
                RepTemp:=GetTempDir;
                LeStream.SaveToFile(RepTemp+NomDoc);
                chargeFichierWin(Handle,RepTemp+NomDoc);
              end;
            finally
              JPEGImage.Free;
            end;
          end
        else if Ext<>'' then
          begin
            RepTemp:=GetTempDir;
            LeStream.SaveToFile(RepTemp+NomDoc);
            chargeFichierWin(Handle,RepTemp+NomDoc);
          end;
      finally
        LeStream.Free;
      end
    end
  else
    begin
      NomDoc:=CheminCaract+TaxonSelect.Image+'\'+NomDoc;
      If Not FileExists(NomDoc) then exit;
      if (Ext='.TXT') then
        begin
          TexteCar.Lines.LoadFromFile(NomDoc);
          TexteCar.Visible:=True;
          //MemoCopie.Lines.LoadFromFile(NomDoc);
          //MemoCopie.Visible:=True;
        end
      else if (Ext='.RTF') then
        begin
          TexteCar.Lines.LoadFromFile(NomDoc);
          TexteCar.Visible:=True;
          //MemoCopie.Lines.Clear;
          //MemoCopie.Lines.AddStrings(TexteCar.Lines);
          //MemoCopie.Visible:=true;
        end
      else if (Ext='.JPG') then
        begin
          ImageCar.Top:=ImageEsp.Top;
          ImageCar.Height:=2*HauteurPetiteImage;
          JPEGImage:=TJPEGImage.Create;
          JPEGImage.LoadFromFile(NomDoc);
          if (JPEGImage.Width<=ImDocW) and (JPEGImage.Height<=ImDocBH) then
            begin
              ImageCar.Affiche(NomDoc,'');
              ImageCar.Visible:=True;
              AjusterBoutons;
           end
          else chargeFichierWin(Handle,NomDoc);
          JPEGImage.Free;
        end
      else if Ext<>'' then chargeFichierWin(Handle,NomDoc);
    end;
end;

procedure TFormObs.FormCreate(Sender: TObject);
begin
    ChargeLangue;
   FormPrinc.Fille(Self);
   Self.Visible:=false;
   with ImageEsp do
   begin
      Width:=LargeurPetiteImage;
      Height:=HauteurPetiteImage;
      Tag:=-1;
   end;
   with ImageCar do
   begin
      Visible:=false;
      //Left:=ImageEsp.Left+ImageEsp.Width+50;
      Width:=ImageEsp.Width;
      Left:=Self.Width-Width-5;
      Tag:=-1; // numero du car courant, 0 correspond au 1er caractre
   end;
   with TexteCar do
   begin
      Visible:=false;
      Top:=ImageEsp.Top;
      Left:=ImageCar.Left;
      Width:=ImageCar.Width;
   end;
   with MemoCopie do
   begin
      Visible:=false;
      Top:=ImageEsp.Top;
      Left:=ImageCar.Left;
      Width:=ImageCar.Width;
   end;
  BAfficherLegendes.Top:=ImageCar.Top+BAfficherLegendes.Height+5;
  BAfficherLegendes.Left:=ImageCar.Left-BAfficherLegendes.Width-5;
  AMesure.Left:=ImageCar.Left-AMesure.Width-5;
  AMesure.Top:=BAfficherLegendes.Top+BAfficherLegendes.Height+5;
  AMesureEsp.Left:=NomEsp.Left+5;
  AMesureEsp.Top:=NomEsp.Top+NomEsp.Height+2;
  EffacerBoutons;

   FSelection:=TStringList.Create; 
end;

procedure TFormObs.FormPaint(Sender: TObject);
begin
//Barre d'icones en bas  gauche
  with BarreIcones do
  begin
     Parent:=Self;
//     if Screen.Height=480 then Top:=400 else Top:=410;
     Left:=0;
     Top:=Self.ClientHeight-Height-10;
     Show;
  end;   
// Barre des caractres  ct, en haut JFM 05/08
  with BarreCaract do
  begin
     Parent:=Self;
     if Parent.Height<610 then Top:=BarreIcones.Top+40
     else Top:=BarreIcones.Top;//  + BarreIcones.Height - Height;
     Left:= BarreIcones.Left + BarreIcones.Width + 10;
     Show;
  end;
  BoutonDater.Top:=BarreCaract.Top+BarreCaract.Height+10;
  BoutonDater.Left:=BarreCaract.Left+30;
  //BoutonDater.Visible:=(Pos('N',LaSousCollection.Exclusions)=0);
  BoutonDater.Visible:=False;

end;

procedure TFormObs.AfficheEspece(NumEsp:integer);
var
  NumCar: integer;
  NomImageTaxon: string;
  NomTaxon:string;
  LeStream : TMemoryStream;
begin
  NomImageTaxon:= LaSousCollection.Taxons.GetImage(NumEsp);
  if EnLigne then
    begin
      LeStream := ChargeFichier_el(NomImageTaxon,false);
      try
        if LeStream.Size > 0 then
          begin
            NomTaxon:=LaSousCollection.Taxons.GetNom(NumEsp);
            if LaSousCollection.EstFossile(NumEsp) then
              begin
                NomTaxon:=NomTaxon+' F '+LaSousCollection.AgesStr(NumEsp);
                NomEsp.Font.color:=$A0A0FF;//$9292FF;//$3131FF;//clRed;
              end
            else if LaSousCollection.EstExterne(NumEsp) then NomEsp.Font.color:=clSkyBlue
            else NomEsp.Font.color:=clWhite;
            ImageEsp.AfficheStream(LeStream,ExtraitExtension(NomImageTaxon),'');
            ImageEsp.Visible:=true;
          end
        else
          begin
            ImageEsp.Visible:=false;
            ShowMessage(M_Lefichier+ NomImageTaxon +L_NexistePas);
          end;
      finally
        LeStream.Free;
      end;
    end
  else
    begin
      if FileExists(NomImageTaxon) then
        begin
          NomTaxon:=LaSousCollection.Taxons.GetNom(NumEsp);
          if LaSousCollection.EstFossile(NumEsp) then
            begin
              NomTaxon:=NomTaxon+' F '+LaSousCollection.AgesStr(NumEsp);
              NomEsp.Font.color:=$A0A0FF;//$9292FF;//$3131FF;//clRed;
            end
          else if LaSousCollection.EstExterne(NumEsp) then NomEsp.Font.color:=clSkyBlue
          else NomEsp.Font.color:=clWhite;
          ImageEsp.Affiche(NomImageTaxon,'');
          ImageEsp.Visible:=true;
        end
      else
        begin
          ImageEsp.Visible:=false;
          ShowMessage(M_Lefichier+ NomImageTaxon +L_NexistePas);
        end;
    end;
  NomEsp.Caption:=NomTaxon;
  ImageEsp.Tag:=NumEsp;
  NumCar:=ImageCar.Tag;

  BarreCaract.AjusteListes;
  if NumCar<>-1 then
    AfficheCaract(NumEsp,NumCar)
  else
    BarreCaract.ComboCarChange(BarreCaract.ComboCar);
  AjusterBoutons;
end;

procedure TFormObs.AfficheCaract(NumEsp,NumCar:integer);
// affiche un texte et ventuellement une petite image
// ou une grande image s'il n'y a pas de texte
var
  NomTexteCar:string;
  NomImageCar:string;
  NomImageCarBig:string;
  DonneeAbsente,GimgAbsente : Boolean;
  LeStream : TMemoryStream;
begin
  if ImageEsp.Tag=-1 then exit;
  DonneeAbsente := True;
  GimgAbsente :=True;
  NomTexteCar:= LaSousCollection.Taxons.GetTexteCar(NumEsp,NumCar);
  NomImageCar:= LaSousCollection.Taxons.GetImageCar(NumEsp,NumCar);
  NomImageCarBig:= LaSousCollection.Taxons.GetImageCarBig(NumEsp,NumCar);
  TexteCar.Visible:=False;
  MemoCopie.Visible:=false;
  ImageCar.Visible:=false;
  EffacerBoutons;
  if FichierInternet(NomTexteCar) then
    begin
      LeStream := ChargeFichier_el(NomTexteCar,False);
      Try
        if LeStream.Size > 0 then
          begin
            TexteCar.Lines.Clear; // Affichage du texte
            TexteCar.Height:=HauteurPetiteImage;
            TexteCar.Lines.LoadFromStream(LeStream);
            TexteCar.Visible:=true;
            MemoCopie.Visible:=false;
            DonneeAbsente := False;
            TexteCar.Refresh;
          end;
      finally
        LeStream.Free;
      end;
      if DonneeAbsente then
        begin
          LeStream := ChargeFichier_el(NomImageCarBig,False);
          try
            if LeStream.Size > 0 then
              begin
                ImageCar.Top:=ImageEsp.Top;  // Affichage d'une grande image
                ImageCar.Height:=2*HauteurPetiteImage;
                ImageCar.AfficheStream(LeStream,ExtraitExtension(NomImageCarBig),'');
                ImageCar.Visible:=True;
                GimgAbsente :=False;
                AjusterBoutons;
              end;
          finally
            LeStream.Free;
          end;
        end;
      if GimgAbsente then
        begin
          LeStream := ChargeFichier_el(NomImageCar,False);
          try
            if LeStream.Size > 0 then
              begin
                if DonneeAbsente then
                  begin
                    ImageCar.Top:=ImageEsp.Top; // Affichage d'une petite image seule
                    ImageCar.Height:=2*HauteurPetiteImage;
                  end
                else
                  begin  // Affichage d'une petite image  en-dessous
                    ImageCar.Top:=TexteCar.Top+TexteCar.Height;
                    ImageCar.Height:=HauteurPetiteImage;
                  end;
                ImageCar.AfficheStream(LeStream,ExtraitExtension(NomImageCar),'');;
                DonneeAbsente := False;
                ImageCar.Visible:=True;
                AjusterBoutons;
              end;
          finally
            LeStream.Free;
          end;
        end;
      if DonneeAbsente then
        DonneeAbsente := GimgAbsente;
    end
  else
    begin
      if FileExists(NomTexteCar) then
        begin
          // Affichage du texte
          TexteCar.Lines.Clear;
          TexteCar.Height:=HauteurPetiteImage;
          TexteCar.Lines.LoadFromFile(NomTexteCar);
          TexteCar.Visible:=true;
          MemoCopie.Visible:=false;
          DonneeAbsente := False;

          TexteCar.Refresh;
          //MemoCopie.Lines.Clear;
          //MemoCopie.Lines.AddStrings(TexteCar.Lines);
          //MemoCopie.Visible:=true;
          if FileExists(NomImageCar) then
            begin
              // Affichage d'une petite image  en-dessous
              ImageCar.Top:=TexteCar.Top+TexteCar.Height;
              ImageCar.Height:=HauteurPetiteImage;
              ImageCar.Affiche(NomImageCar,'');
              ImageCar.Visible:=True;
              AjusterBoutons;
            end
          else
            begin
              ImageCar.Visible:=false;
            end;
        end
      else
        begin
          TexteCar.Visible:=false;
          MemoCopie.Visible:=false;
          NomImageCarBig:= LaSousCollection.Taxons.GetImageCarBig(NumEsp,NumCar);
          if FileExists(NomImageCarBig) then
            begin // Affichage d'une grande image
              ImageCar.Top:=ImageEsp.Top;
              ImageCar.Height:=2*HauteurPetiteImage;
              ImageCar.Affiche(NomImageCarBig,'');
              ImageCar.Visible:=True;
              AjusterBoutons;
              DonneeAbsente := False;
            end
          else if FileExists(NomImageCar) then
            begin
              // Affichage d'une petite image dans le grand cadre
              ImageCar.Top:=ImageEsp.Top;
              ImageCar.Height:=2*HauteurPetiteImage;
              ImageCar.Affiche(NomImageCar,'');
              ImageCar.Visible:=True;
              AjusterBoutons;
              DonneeAbsente := False;
            end;
        end;
    end;
  if DonneeAbsente then
    begin                // texte indiquant l'absence de donnee
      ImageCar.Visible:=false;
      EffacerBoutons;
      TexteCar.Text:=MsgDonneeAbsente;
      TexteCar.Visible:=false;
      MemoCopie.Lines.Clear;
      MemoCopie.Lines.Add(MsgDonneeAbsente);
      MemoCopie.Visible:=true;
    end;
  ImageCar.Tag:=NumCar;
end;

procedure TFormObs.ImageClick(Sender: TObject);   // supprimer et remplacer par une autre fentre
begin
  Application.CreateForm(TFormBig, FormBig);
  FormBig.Parent:=Self;
  FormBig.AgrandirImage(Sender);
end;

procedure TFormObs.TexteCarMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Terme:string;
begin
  Terme:= TRichEdit(Sender).SelText;
  if Terme <> '' then FormDefinition.AfficheDefinition(Terme);
end;

function TFormObs.GetSelection: TStringList;
begin
  FSelection.Clear;
  if (Assigned(LaSousCollection.Taxons)) and (ImageEsp.Tag <> -1) then FSelection.Add(LaSousCollection.Taxons.GetNom(ImageEsp.Tag));
  GetSelection:=FSelection;
end;

procedure TFormObs.FormShow(Sender: TObject);
begin
  //FormPrinc.Observer1.Enabled:=false;  // jfr modifie 16 octobre 2001
  BarreIcones.Show;
end;

procedure TFormObs.FormHide(Sender: TObject);
begin
   //FormPrinc.Observer1.Enabled:=true;   // jfr modifie 16 octobre 2001
   BarreIcones.Hide;
end;

procedure TFormObs.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   ImageEsp.Tag:=-1;
   ImageCar.Tag:=-1;
   ImageCar.Visible:=false;
   ImageEsp.Visible:=false;
   FSelection.Clear;
   RectFoc.Visible:=False;
end;

procedure TFormObs.ACopier(Sender: TObject);
begin
  ControleACopier:=(Sender as TwinControl);
  RectFoc.Visible:=True;
  RectFoc.Left:=ControleACopier.Left-3;
  RectFoc.Top:=ControleACopier.Top-3;
  RectFoc.Width:=ControleACopier.Width+6;
  RectFoc.Height:=ControleACopier.Height+6;
end;

procedure TFormObs.BoutonDaterClick(Sender: TObject);
Var
  Cond1:boolean;
begin
  Cond1:=LaSousCollection.AvecFossiles(False);
  if (Cond1 and (Pos('D',LaSousCollection.Exclusions)=0)) then
    begin
      If FormDaterObs=Nil then
        Application.CreateForm(TFormDaterObs,FormDaterObs);
      FormDaterObs.Top:=0;
      FormDaterObs.Left:=0;
      if (Not FormDaterObs.DejaOuverte) then
        begin
          FormDaterObs.Height:=Screen.WorkAreaHeight;//BarreIcones.Top+Top+44;//FormPrinc.Height;
          FormDaterObs.Width:=Screen.WorkAreaWidth;
          FormDaterObs.InitialiseListeDocs;
          FormDaterObs.ChargeTabGrid;
        end;
      If ImageEsp.Tag>-1 then
        FormDaterObs.NumTaxonAff:=ImageEsp.Tag;
      If ImageCar.Tag>-1 then
        FormDaterObs.NumCarAff:=ImageCar.Tag;

      FormDaterObs.ShowModal;
    end
  else
    begin
      If FormOrganiserObs=Nil then
        Application.CreateForm(TFormOrganiserObs,FormOrganiserObs);
      FormOrganiserObs.Top:=0;
      FormOrganiserObs.Left:=0;
      if (Not FormOrganiserObs.DejaOuverte) then
        begin
          FormOrganiserObs.Height:=Screen.WorkAreaHeight;//BarreIcones.Top+Top+44;//FormPrinc.Height;
          FormOrganiserObs.Width:=ImageCar.Left;
          FormOrganiserObs.InitialiseListeDocs;
          FormOrganiserObs.ChargeTabGrid;
        end;
      If ImageEsp.Tag>-1 then
        FormOrganiserObs.NumTaxonAff:=ImageEsp.Tag;
      If ImageCar.Tag>-1 then
        FormOrganiserObs.NumCarAff:=ImageCar.Tag;

      FormOrganiserObs.ShowModal;
    end;
end;
procedure TFormObs.ChargeLangue;
begin
  Caption:=C_FormPrincObserver; // Observer
  BoutonDater.Caption:=C_FormPrincOrganiser; // Organiser
  BAfficherLegendes.Caption:=B_AfficherLegende;
end;

procedure TFormObs.ImageCarMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  If ImageCar.Echelle.active then
    AMesure.Text:=ImageCar.Mesure;
end;

procedure TFormObs.ImageCarMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If ImageCar.Echelle.active then
    AMesure.Text:=ImageCar.Mesure;
end;

procedure TFormObs.ImageCarMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  AMesure.Text:='';
end;

procedure TFormObs.BAfficherLegendesClick(Sender: TObject);
begin
  if ImageCar.Visible and ImageCar.ADesLegendes then
    ImageCar.AfficheLegendes;
  if ImageCar.LegendesAffichees then
    BAfficherLegendes.Caption:=B_MasquerLegende//'Masquer les lgendes'
  else
    BAfficherLegendes.Caption:=B_AfficherLegende;//'Afficher les lgendes';
end;
procedure TFormObs.EffacerBoutons;
begin
  BAfficherLegendes.Visible:=False;
  AMesure.Visible:=False;
  AMesureEsp.Visible:=False;
end;
procedure TFormObs.AjusterBoutons;
begin
  EffacerBoutons;
  if ImageCar.Visible then
    begin
      If ImageCar.ADesLegendes then
        begin
          BAfficherLegendes.Visible:=True;
          ImageCar.EffaceLegendes;
          if BAfficherLegendes.Caption=B_MasquerLegende then
            ImageCar.AfficheLegendes;
        end;
      If ImageCar.Echelle.active then
        AMesure.Visible:=True;
    end;
  if ImageEsp.Visible then
    begin
      AMesureEsp.Visible:=ImageEsp.Echelle.active;
      If ImageEsp.ADesLegendes then
        begin
          BAfficherLegendes.Visible:=True;
          ImageEsp.EffaceLegendes;
          if BAfficherLegendes.Caption=B_MasquerLegende then
            ImageEsp.AfficheLegendes;
        end;
    end;
end;
end.
