unit dessins;
interface

uses Windows, Classes,Sysutils, Graphics,Math, Controls,Str_Echelles,GR32_Image,
GR32_Layers,GR32,GR32_Filters,GR32_Blend,GR32_Polygons,GR32_OrdinalMaps; //,GR32_ByteMaps

type
  TTableauEntiers=Array of integer;
  TTableaudeTableauEntier=Array of TTableauEntiers;
  TCat=(ctCrayon,ctTrait,ctRectangleD,ctCercle,ctGomme,ctTxt,ctRemplissage,ctEchelle,ctRepere,ctRempliContour,ctGrille);
  TTypetrait=(trLigne,trFleche,trDoublef);
  TTypetrace=(ttContinu,ttTirete);
  TLien=(lnEt,lnOu,lnXor,lnNon);
  TPointsVoisins=(pvO,pvSO,pvS,pvSE,pvE,pvNE,pvN,pvNO,pvOO,pvOSO,pvSSOO,pvSSO,pvSS,pvSSE,pvSSEE,pvESE,pvEE,pvENE,pvNNEE,pvNNE,pvNN,pvNNO,pvNNOO,pvONO,pvErreur);
  TComposante=(cpBleue,cpVerte,cpRouge,cpAlpha,cpTeinte,cpSaturation,CpLumin,cpTeint2,cpSat2,cpValeur,cpCan1,cpCan2,cpCan3,cpCan4,cpCan5,cpCan6,cpCan7,cpCan8,cpCan9,cpCan10,cpCan11,cpCan12,cpCan13,cpCan14,cpCan15);
  Ttypemarque=(tmRond,tmplus,tmetoile,tmetoile2,tmcarre,tmcercle,tmtri1,tmtri2,tmlosange,tmcroix);
  TRemplis=(teAucun,tePlein,teVertical,teHorizontal,teQuadrillage,teOblique1,teOblique2,teQuadrOblique);
  TCondicoul=Record
    Amin:Byte;
    Amax:Byte;
    Bmin:Byte;
    Bmax:Byte;
    Gmin:Byte;
    Gmax:Byte;
    Rmin:Byte;
    Rmax:Byte;
  end;
 TCondicoulElem=Record
   Lien:TLien;
   Composante:TComposante;
   Relatif:byte;// type de comparaison (non utilis pour l'instant : suppos=0)
                //0 :teste si la composante est entre ValeurMin et ValeurMax;
                //1 : teste si la composante a une diffrence infrieure ou gale  ValeurMin avec ses 4 voisins (test  partir d'un point)
                // ou avec ses voisins dfinis par PointsVoisins;
   ValeurMin:Word; //integer;
   ValeurMax:Word; //integer;
 end;
 TTableaudeCondicoul=array of TCondicoulElem;
 TTableaudeTableaudeCondicoul=array of TTableaudeCondicoul;
  TDessin=Class(TObject)
  private
  public
    cat:Tcat;
    Xd:Smallint;
    Yd:Smallint;
    Xf:Smallint;
    Yf:Smallint;
    XC:Smallint;
    YC:Smallint;
    RC:Smallint;
    ep:byte;
    couleurD:TColor32;
    couleurFD:Tcolor32;
    Alignement:byte;
    Transparent:boolean;
    Rotation:single;
    opaciteD:byte;
    TypetraitD:TTypetrait;
    TypetraceD:TTypetrace;
    TyperemplisD:TRemplis;
    //Fonte:TFont;
    Taillefonte:byte;
    StyleFonte:byte;
    NomFonte:string;
    Texte:TStringList;
    tracel:Tpolygon32;
    precision:byte; //0 :sauvegarde des coordonnes des points en entiers 1: sauvegarde en TFixed ; pour la grille, prcision de RC 0: ne pas diviser; 1:diviser par 10 , 2: diviser par 100...)
    BMRepere:TBitmap32;
    NomUnite:string;
    CoeffECh:single;
    Polycondition:TTableaudeTableaudeCondicoul;
    CoucheTest:byte; //pour les remplissages 0: fond  1:C_Trace...
    PointsVoisinsC:Byte; // voir aussi TPointsVoisins; // non encore utilis
                         // somme de 1:pvO, 2:pvSO, 4:pvS, 8:pvSE, 16:pvE, 32:pvNE, 64:pvN, 128:pvNO
    PointsVoisinsE:Word; // deuxime cercle
                         // somme de 1:pvOO, 2:pvOSO, etc...
    constructor Create;overload;
    destructor Destroy;override;
    function TraceSur(BitmapTest,Bitmap:Tbitmap32):Boolean;
    procedure ColleBitmap(X,Y:integer;transparent:Boolean;Bitmapsc:TBitmap;Bitmapdest:TBitmap32);
    procedure CopieTransp(F: TColor32; var B: TColor32; M: TColor32);
    procedure ajustepaisseur;
    procedure ReadFromStream(Stream:TStream);
    function WriteToStream(Stream:TStream):integer;
  end;
{Const
  NomRemplis=['aucun','plein','vertical','horizontal','quadrillage','oblique1','oblique2','quadrillage oblique'];
  NomTypetrait=['ligne','flche','double flche'];
  NomCat : Array [TCat] of string[11] =['crayon','ligne','rectangle','cercle','gomme','texte','remplissage','repere'];
  NomTypetrace=['continu','tirets'];}
Const
  VersionMsu=1;
Var
  CTypetrait:TTypetrait;
  CTypetrace:TTypetrace;
  CTyperemplis:TRemplis;
  epaisseur:integer;
  largepais:integer;
  Couleur:TColor32;
  CouleurF:TColor32;
  opacite:Word;
  BMepais:TBitmap32;
  ecart_rayures:word;
  CondicoulG:TCondicoul;
  codagemsu:string;
  Textetranf:string;
  SeriePtransf:TArrayOfFixedPoint;
  DrComplique:Boolean;//pour limiter les choix
  DrRemplisCrayon,DrRemplisFond:Boolean;
  //StDessintransf:TstDessin;
  //FonteTransf:TFont;
  TitreTransf:string;
  LeContour:TArrayofPoint;
  Lesinclusions:TArrayOfArrayofPoint;
  LeReste:TArrayOfArrayofPoint;
  CopieCanaux:Array of TBytemap;
  SerieCouleurs:Array [0..9] of TColor32;
  CodageMsuprec:string[3];
  //CanauxCalc:Array of TParser;
  //RefCanaux:Array of Array of integer;
  function RechercheSiCanaux(Polyconditions:TTableaudeTableaudeCondicoul):Boolean;
  function direction(Point1,Point2:TPoint):TPointsVoisins;
  function Voisin(Point:TPoint;voisinage:TPointsVoisins):TPoint;
  function remplitVide(X,Y:integer;Color:Tcolor32;Typeremplis:TRemplis;Condicoul:TCondicoul;Bitmaptest,Bitmaptrav:TBitmap32):integer;
  function remplitSousCondition(X,Y:integer;Color:Tcolor32;Typeremplis:TRemplis;PolyConditions:TTableaudeTableaudeCondicoul;Bitmaptest,Bitmaptrav:TBitmap32):integer;
  function RemplitJusquAuContour(X,Y:integer;Contourext:TArrayOfPoint;Color,ColorS:Tcolor32;Typeremplis:TRemplis;PolyConditions:TTableaudeTableaudeCondicoul;Bitmaptest,Bitmaptrav:TBitmap32):integer;
  function RechercheEmboites(X,Y:integer;Contourext:TArrayOfPoint;Bitmap:TBitmap32;out Xdep,Ydep:integer):TTableauEntiers;
//  procedure LigneContour(X,Y:integer;PolyConditions:TTableaudeTableaudeCondicoul;BytemapTp:TBytemap;Bitmaptest{,Bitmaptrav}:TBitmap32;var Largeurcontour,HauteurContour,NombredePoints,nombretraces:integer);
  function LigneContour(X,Y:integer;Marquer:Boolean;CoulSurf:TColor32;PolyConditions:TTableaudeTableaudeCondicoul;BytemapTp:TBytemap;Bitmaptest,Bitmaptrav:TBitmap32;var Largeurcontour,HauteurContour,NombredePoints,nombretraces:integer):integer;
//  procedure LigneContour(X,Y:integer;PolyConditions:TTableaudeTableaudeCondicoul;BytemapTp:TBytemap;Bitmaptest,Bitmaptrav:TBitmap32;var nombretraces:integer;out LesContours:TArrayOfArrayofPoint);
  procedure MesureBoucle(Boucle:TArrayOfPoint;var largboucle,Longboucle,perimetre:single;out PointLongD,PointLongF,PointLarg1D,PointLarg1F,PointLarg2D,PointLarg2F:TPoint);
  procedure MesureMarqueBoucle(Boucle:TArrayOfPoint;Bitmap:TBitmap32;marquer:boolean;Color:Tcolor32;var largboucle,Longboucle,perimetre:single);
  function verifieContact(Boucle:TArrayOfPoint;w,h:integer):boolean;
  function SimplifieBoucle(var Boucle:TArrayOfPoint):real;// la sortie indique le primtre
  procedure DessinePolyligne(color:TColor32;UnContour:TArrayofPoint;Bitmap:TBitmap32);
  procedure DessinePolyTPoint(color:TColor32;UnContour:TArrayofPoint;Bitmap:TBitmap32);
  procedure DessinePolyTPointmulticol(UnContour:TArrayofPoint;Bitmap:TBitmap32);
  procedure RendTransparent(ColorF:TColor32;Bitmap:TBitmap32);
  procedure RendOpacite(ColorF:TColor32;opacite:integer;Bitmap:TBitmap32);
  function conditionCouleur(Condicoul:TCondicoul;color:Tcolor32):boolean;
  procedure TraceLibre(tracel:Tpolygon32;ep:integer;Color:TColor32;Bitmap:Tbitmap32);
  procedure tracetrait(Xd,Yd,Xf,Yf,ep:integer;Color:TColor32;Typetrait:TTypetrait;Typetrace:TTypetrace;Bitmap:Tbitmap32);
  procedure tracecercle(XC,YC,R,ep:integer;Color:TColor32;Typeremplis:TRemplis;Typetrace:TTypetrace;Bitmap:Tbitmap32);
  procedure TraceGrille(Xd,Yd,RC,ep:integer;precision:byte;CouleurD:TColor32;TypetraceD:TTypetrace;Bitmap:Tbitmap32);
  procedure tracerect(Xd,Yd,Xf,Yf,ep:integer;Color:TColor32;Typeremplis:TRemplis;Typetrace:TTypetrace;Bitmap:Tbitmap32);
  procedure EcritTexte(Font:TFont;Alignement:integer;ColorF:TColor32;Texte:TStringList;Bitmap:TBitmap);
  procedure TraceLegendEch(ep:integer;unite:string;coeff:single;Font:TFont;Color:TColor32;ColorF:TColor32;Bitmap:TBitmap);
  procedure tracerond(ep,nombrerayons:integer;color:Tcolor32;Bitmap:TBitmap32);
  procedure tracemarque(ep:integer;color:Tcolor32;forme:TtypeMarque;Bitmap:TBitmap32);
  function agrandit(UnDessin:TDessin;coeff:single):TDessin;
  function TesteCondicoul(Color:TColor32;ValCanaux:Array of byte;Condition:TCondicoulElem):Boolean;
  function TesteSerieCondicoul(Color:TColor32;ValCanaux:Array of byte;Conditions:TTableaudeCondicoul):Boolean;
  function TestePolyCondicoul(Color:TColor32;ValCanaux:Array of byte;polyConditions:TTableaudeTableaudeCondicoul):Boolean;

  //procedure copieDessin(UnDessin,Modele:TDessin;coeff:single);
  //procedure copieDessin(StDessinSc:TStDessin;FonteDest,FonteSc:TFont;coeff:single;SeriePDest,SeriePSc:TArrayOfFixedPoint;var StDessinDest:TstDessin);
implementation
uses Conv_coul,dialogs,GR32_math;  //
constructor TDessin.Create;
  begin
    inherited Create;
    tracel:=Tpolygon32.Create;
    tracel.Closed:=false;
    precision:=0;
    Texte:=TStringList.Create;
    BMRepere:=TBitmap32.Create;
    BMRepere.SetSize(25,25);
    BMRepere.DrawMode:=dmblend;
    Xd:= 0;
    Yd:= 0;
    Xf:= 0;
    Yf:= 0;
    XC:= 0;
    YC:= 0;
    RC:= 0;
    ep:= 0;
    couleurD:= $FF000000;
    couleurFD:= $FFFFFFFF;
    Alignement:= 0;
    Transparent:= True;
    Rotation:= 0;
    opaciteD:= 0;
    TypetraitD:= trLigne;
    TypetraceD:= ttcontinu;
    TyperemplisD:= teAucun;
    TailleFonte:=10;
    StyleFonte:=0;
    NomFonte:='Arial';
    CoeffEch:=1;
    NomUnite:='';
    CoucheTest:=0;
    PointsVoisinsC:=85; // somme de 1:pvO, 4:pvS, 16:pvE, 64:pvN voir aussi TPointsVoisins; // non encore utilis
    PointsVoisinsE:=0; // deuxime cercle
    with CondicoulG do
      begin
        Amin:=0;
        Amax:=0;
        Bmin:=0;
        Bmax:=255;
        Gmin:=0;
        Gmax:=255;
        Rmin:=0;
        Rmax:=255;
      end;
  end;

destructor TDessin.Destroy;
begin
    inherited Destroy;
    tracel.Free;
    Texte.Free;
    BMRepere.Free;
end;
function TDessin.WriteToStream(Stream:TStream):integer;
var
  buffer:array[0..48] of Char;
  longueur,p:integer;
  nom,textaecrire:string;
  couleurfonte:Tcolor32;
  //taillefonte:byte;
  //stylefonte:byte;
  longueurtexte:word;
  i,j:integer;
  nombrepoints,nombretraces:word;
  nombreseries,nombrelements:byte;
  LePoint:TFixedPoint;
  PointX,PointY:TFixed;
  PointXEntier,PointYEntier:word;
  unbyte:byte;
begin
  p:=0;
  longueur:=0;
  buffer[p]:=chr(ord(cat));
  inc(p);
  buffer[p]:=chr(ord(TypetraitD));
  inc(p);
  buffer[p]:=chr(ord(TypetraceD));
  inc(p);
  buffer[p]:=chr(ord(TyperemplisD)); //4
  inc(p);
  buffer[p]:=chr(ord(Transparent) and 255); //5
  inc(p);
  Stream.Write(Buffer,p);
  Stream.Write(Xd,2);   // 7
  Stream.Write(Yd,2);
  Stream.Write(Xf,2);
  Stream.Write(Yf,2);
  Stream.Write(XC,2);
  Stream.Write(YC,2);
  Stream.Write(RC,2);
  Stream.Write(ep,1);   //20
  Stream.Write(Alignement,1);
  Stream.Write(opaciteD,1);
  Stream.Write(Rotation,4); //single
  Stream.Write(couleurD,4); //couleur
  Stream.Write(couleurFD,4); //couleur
  result:=34;
  if cat=ctGrille then
    begin
      Stream.Write(precision,1);    //1 octet
    end;
  if cat=ctEchelle then
    begin
      nom:=NomFonte;
      p:=Length(nom);
      buffer[0]:=chr(p and 255);
      Stream.Write(buffer,1);
      result:=result+1;
      Stream.Write(Pointer(nom)^,p);
      result:=result+p;
      Stream.Write(CouleurD,4);//comme couleur de fonte
      result:=result+4;
      Stream.Write(TailleFonte,1); // 1 octet
      Stream.Write(StyleFonte,1); // 1 octet
      textaecrire:=NomUnite;
      longueurtexte:=Length(textaecrire);
      Stream.Write(longueurtexte,2); // 2 octets
      result:=result+4;
      Stream.Write(Pointer(textaecrire)^,longueurtexte);
      result:=result+longueurtexte;
      Stream.Write(CoeffEch,4); // single: 4 octets
      result:=result+4;
    end;
  if cat=ctTxt then
    begin
      nom:=NomFonte;
      p:=Length(nom);
      buffer[0]:=chr(p and 255);
      Stream.Write(buffer,1);
      result:=result+1;
      Stream.Write(Pointer(nom)^,p);
      result:=result+p;
      Stream.Write(CouleurD,4);//comme couleur de fonte
      result:=result+4;
      Stream.Write(TailleFonte,1); // 1 octet
      Stream.Write(StyleFonte,1); // 1 octet
      textaecrire:=Texte.Text;
      longueurtexte:=Length(textaecrire);
      Stream.Write(longueurtexte,2); // 2 octets
      result:=result+4;
      Stream.Write(Pointer(textaecrire)^,longueurtexte);
      result:=result+longueurtexte;
    end;
  if cat=ctRemplissage then
    begin
      Stream.Write(CoucheTest,1);
      Stream.Write(PointsVoisinsC,1);
      Stream.Write(PointsVoisinsE,2);
      NombreSeries:=Length(Polycondition);
      Stream.Write(NombreSeries,1);
      For i:=0 to NombreSeries-1 do
        begin
          NombrElements:=Length(Polycondition[i]);
          Stream.Write(NombrElements,1);
          For j:=0 to NombrElements-1 do
            Stream.Write(Polycondition[i][j],7);
        end;
    end;
   if cat=ctRempliContour then
     begin
      Stream.Write(CoucheTest,1);
      Stream.Write(PointsVoisinsC,1);
      Stream.Write(PointsVoisinsE,2);
      NombreSeries:=Length(Polycondition);
      Stream.Write(NombreSeries,1);
      For i:=0 to NombreSeries-1 do
        begin
          NombrElements:=Length(Polycondition[i]);
          Stream.Write(NombrElements,1);
          For j:=0 to NombrElements-1 do
            Stream.Write(Polycondition[i][j],7);
        end;
      unbyte:=ord(Tracel.Closed);
      Stream.Write(unbyte,1);    //1 octet
      Stream.Write(precision,1);   // 0 sauvegarde en TPoints //1: sauvegarde en TFixed
      nombretraces:=Length(tracel.Points);
      Stream.Write(nombretraces,2); // 2 octets
      result:=result+4;
      for I:=0 to nombretraces-1 do
        begin
          nombrepoints:=Length(tracel.Points[I]);
          Stream.Write(nombrepoints,2); // 2 octets
          result:=result+2;
          for J:=0 to nombrepoints-1 do
            begin
              LePoint:=tracel.Points[I][J];
              PointX:=LePoint.X;
              PointY:=LePoint.Y;
              if precision=1 then
                begin
                  Stream.Write(PointX,4); // 4 octets
                  Stream.Write(PointY,4); // 4 octets
                  result:=result+8;
                end
              else
                begin
                  PointXEntier:=Round(PointX/65536);
                  PointYEntier:=Round(PointY/65536);
                  Stream.Write(PointXEntier,2); // 2 octets
                  Stream.Write(PointYEntier,2); // 2 octets
                  result:=result+4;
                end;
            end;
        end;
     end;
  if cat=ctCrayon then
    begin
      unbyte:=ord(Tracel.Closed);
      Stream.Write(unbyte,1);    //1 octet
      Stream.Write(precision,1);   // 0 sauvegarde en TPoints //1: sauvegarde en TFixed
      nombretraces:=Length(tracel.Points);
      Stream.Write(nombretraces,2); // 2 octets
      result:=result+4;
      for I:=0 to nombretraces-1 do
        begin
          nombrepoints:=Length(tracel.Points[I]);
          Stream.Write(nombrepoints,2); // 2 octets
          result:=result+2;
          for J:=0 to nombrepoints-1 do
            begin
              LePoint:=tracel.Points[I][J];
              PointX:=LePoint.X;
              PointY:=LePoint.Y;
              if precision=1 then
                begin
                  Stream.Write(PointX,4); // 4 octets
                  Stream.Write(PointY,4); // 4 octets
                  result:=result+8;
                end
              else
                begin
                  PointXEntier:=Round(PointX/65536);
                  PointYEntier:=Round(PointY/65536);
                  Stream.Write(PointXEntier,2); // 2 octets
                  Stream.Write(PointYEntier,2); // 2 octets
                  result:=result+4;
                end;
            end;
        end;
    end;
end;
procedure TDessin.ReadFromStream(Stream:TStream);
var
  buffer:array[0..48] of Char;
  p:integer;
  nom,textacharger:string;
  couleurfonte:Tcolor32;
  //taillefonte:byte;
  longueurtexte:word;
  nombrepoints,nombretraces:word;
  i,j:integer;
  LePoint:TFixedPoint;
  PointX,PointY:TFixed;
  PointXEntier,PointYEntier:word;
  n:integer;
  unbyte:byte;
  NombreSeries,NombrElements:byte;
begin
  n:=stream.position;
  Stream.Read(Buffer,5);
  p:=0;
  cat:=TCat(ord(buffer[0]));
  TypetraitD:=TTypetrait(ord(buffer[1]));
  TypetraceD:=TTypetrace(ord(buffer[2]));
  TyperemplisD:=TRemplis(ord(buffer[3]));
  Transparent:=(ord(buffer[4])<>0);

  Stream.Read(Xd,2);   // 7
  Stream.Read(Yd,2);
  Stream.Read(Xf,2);
  Stream.Read(Yf,2);
  Stream.Read(XC,2);
  Stream.Read(YC,2);
  Stream.Read(RC,2);
  Stream.Read(ep,1);   //20
  Stream.Read(Alignement,1);
  Stream.Read(opaciteD,1);
  Stream.Read(Rotation,4); //single
  Stream.Read(couleurD,4); //couleur
  Stream.Read(couleurFD,4); //couleur
  if cat=ctGrille then
    begin
      Stream.Read(precision,1);    //1 octet
    end;

  if cat=ctechelle then
    begin
      Stream.Read(buffer,1);
      p:=ord(buffer[0]);   // taille du nom de la fonte
      SetString(nom, nil, p);
      Stream.Read(Pointer(nom)^,p);
      nomfonte:=nom;
      Stream.Read(couleurfonte,4);// 4 octets
      Stream.Read(TailleFonte,1); // 1 octet
      Stream.Read(StyleFonte,1); // 1 octet
      Stream.Read(longueurtexte,2); // 2 octets
      SetString(textacharger, nil,longueurtexte);
      Stream.Read(Pointer(textacharger)^,longueurtexte);
      NomUnite:=textacharger;
      Stream.Read(CoeffEch,4);
    end;
  if cat=ctTxt then
    begin
      Stream.Read(buffer,1);
      p:=ord(buffer[0]);   // taille du nom de la fonte
      SetString(nom, nil, p);
      Stream.Read(Pointer(nom)^,p);
      nomfonte:=nom;
      Stream.Read(couleurfonte,4);// 4 octets
      Stream.Read(TailleFonte,1); // 1 octet
      Stream.Read(StyleFonte,1); // 1 octet
      Stream.Read(longueurtexte,2); // 2 octets
      SetString(textacharger, nil,longueurtexte);
      Stream.Read(Pointer(textacharger)^,longueurtexte);
      Texte.Text:=textacharger;
    end;
   if cat=ctRempliContour then
     begin
      Stream.Read(CoucheTest,1);
      Stream.Read(PointsVoisinsC,1);
      Stream.Read(PointsVoisinsE,2);
      Stream.Read(NombreSeries,1);
      SetLength(Polycondition,NombreSeries);
      For i:=0 to NombreSeries-1 do
        begin
          Stream.Read(NombrElements,1);
          SetLength(Polycondition[i],NombrElements);
          For j:=0 to NombrElements-1 do
            Stream.Read(Polycondition[i][j],7);
        end;
      Stream.Read(unbyte,1);    //1 octet
      if unbyte=0 then tracel.Closed:=False else tracel.Closed:=True;
      Stream.Read(precision,1);    //1 octet
      Stream.Read(nombretraces,2); // 2 octets
      tracel.Clear;
      for I:=0 to nombretraces-1 do
        begin
          if I>0 then tracel.NewLine;
          Stream.Read(nombrepoints,2); // 2 octets
          for J:=0 to nombrepoints-1 do
            begin
              if precision=1 then
                begin
                  Stream.Read(PointX,4);
                  Stream.Read(PointY,4);
                  LePoint.X:=PointX;
                  LePoint.Y:=PointY;
                  tracel.Add(LePoint);
                end
              else
                begin
                  Stream.Read(PointXEntier,2);
                  Stream.Read(PointYEntier,2);
                  LePoint.X:=PointXEntier * 65536;
                  LePoint.Y:=PointYEntier * 65536;
                  tracel.Add(LePoint);
                end;
            end;
        end;
     end;
  if cat=ctRemplissage then
    begin
      Stream.Read(CoucheTest,1);
      Stream.Read(PointsVoisinsC,1);
      Stream.Read(PointsVoisinsE,2);
      Stream.Read(NombreSeries,1);
      SetLength(Polycondition,NombreSeries);
      For i:=0 to NombreSeries-1 do
        begin
          Stream.Read(NombrElements,1);
          SetLength(Polycondition[i],NombrElements);
          For j:=0 to NombrElements-1 do
            Stream.Read(Polycondition[i][j],7);
        end;
    end;
  if cat=ctCrayon then
    begin
      Stream.Read(unbyte,1);    //1 octet
      if unbyte=0 then tracel.Closed:=False else tracel.Closed:=True;
      Stream.Read(precision,1);    //1 octet
      Stream.Read(nombretraces,2); // 2 octets
      tracel.Clear;
      for I:=0 to nombretraces-1 do
        begin
          if I>0 then tracel.NewLine;
          Stream.Read(nombrepoints,2); // 2 octets
          for J:=0 to nombrepoints-1 do
            begin
              if precision=1 then
                begin
                  Stream.Read(PointX,4);
                  Stream.Read(PointY,4);
                  LePoint.X:=PointX;
                  LePoint.Y:=PointY;
                  tracel.Add(LePoint);
                end
              else
                begin
                  Stream.Read(PointXEntier,2);
                  Stream.Read(PointYEntier,2);
                  LePoint.X:=PointXEntier * 65536;
                  LePoint.Y:=PointYEntier * 65536;
                  tracel.Add(LePoint);
                end;
            end;
        end;
{      Stream.Read(nombrepoints,2);
      tracel.Clear;
      for J:=0 to nombrepoints-1 do
        begin
          Stream.Read(PointX,4);
          Stream.Read(PointY,4);
          LePoint.X:=PointX;
          LePoint.Y:=PointY;
          tracel.Add(LePoint);
        end;}
    end;
end;

function TDessin.TraceSur(BitmapTest,Bitmap:Tbitmap32):Boolean;
Var
  Bitmaptp:TBitmap;
  i,j,X,Y:integer;
  Fonte:TFont;
  Contourext:TArrayOfPoint;
begin
  result:=True;
  try
    Case Cat of
      ctCrayon:begin
               TraceLibre(tracel,ep,CouleurD,Bitmap);
               ajustepaisseur;
               BMRepere.DrawMode:=dmBlend;
               if ep>0 then
                 begin
                   Bitmap.Draw(Xd-largepais,Yd-largepais,BMRepere);
                   Bitmap.Draw(Xf-largepais,Yf-largepais,BMRepere);
                 end;
              end;
      ctTrait:tracetrait(Xd,Yd,Xf,Yf,ep,CouleurD,TypetraitD,TypetraceD,Bitmap);
      ctRectangleD:tracerect(Xd,Yd,Xf,Yf,ep,CouleurD,TyperemplisD,TypetraceD,Bitmap);
      ctCercle:tracecercle(XC,YC,RC,ep,CouleurD,TyperemplisD,TypetraceD,Bitmap);
      ctGrille:TraceGrille(Xd,Yd,RC,ep,precision,CouleurD,TypetraceD,Bitmap);
      //ctGomme:
      ctEchelle:begin
              Bitmaptp:=TBitmap.Create;
              Fonte:=TFont.Create;
              Fonte.Name:=NomFonte;
              Fonte.size:=TailleFonte;
              Fonte.Color:=WinColor(CouleurD);
                    //style(octet 1:bold, octet 2:italic, octet 3:underline, octet 4:strikeout)
              fonte.Style:=[];
              if (stylefonte and 1)>0 then fonte.Style:=Fonte.Style+[fsbold];
              if (stylefonte and 2)>0 then fonte.Style:=Fonte.Style+[fsitalic];
              if (stylefonte and 4)>0 then fonte.Style:=Fonte.Style+[fsunderline];
              if (stylefonte and 8)>0 then fonte.Style:=Fonte.Style+[fsstrikeout];
              TraceLegendEch(ep,Nomunite,coeffEch,Fonte,CouleurD,CouleurF,Bitmaptp);
              ColleBitmap(XC,YC,transparent,Bitmaptp,Bitmap);
              Fonte.Free;
              Bitmaptp.free;
            end;
      ctTxt:begin
              Bitmaptp:=TBitmap.Create;
              Fonte:=TFont.Create;
              Fonte.Name:=NomFonte;
              Fonte.size:=TailleFonte;
              Fonte.Color:=WinColor(CouleurD);
                    //style(octet 1:bold, octet 2:italic, octet 3:underline, octet 4:strikeout)
              fonte.Style:=[];
              if (stylefonte and 1)>0 then fonte.Style:=Fonte.Style+[fsbold];
              if (stylefonte and 2)>0 then fonte.Style:=Fonte.Style+[fsitalic];
              if (stylefonte and 4)>0 then fonte.Style:=Fonte.Style+[fsunderline];
              if (stylefonte and 8)>0 then fonte.Style:=Fonte.Style+[fsstrikeout];

              EcritTexte(Fonte,Alignement,CouleurFD,Texte,Bitmaptp);
              ColleBitmap(XC,YC,transparent,Bitmaptp,Bitmap);
              Fonte.Free;
              Bitmaptp.free;
            end;
      ctRempliContour:begin
              SetLength(contourExt,Length(Tracel.Points[0]));
              for i:=0 to Length(Tracel.Points[0])-1 do
                begin
                  contourExt[i]:=Point(Tracel.Points[0][i]);
                end;
              RemplitJusquAuContour(XC,YC,contourExt,SetAlpha(CouleurD,opacite),SetAlpha(CouleurFD,opacite),TyperemplisD,PolyCondition,Bitmaptest,Bitmap);
            end;
      ctRemplissage: begin
              if Couchetest=0 then
                remplitSousCondition(XC,YC,SetAlpha(CouleurD,opaciteD),TyperemplisD,PolyCondition,Bitmaptest,Bitmap)
              else
                remplitSousCondition(XC,YC,SetAlpha(CouleurD,opaciteD),TyperemplisD,PolyCondition,Bitmap,Bitmap);
            end;
//      ctRemplissage:remplitVide(XC,YC,SetAlpha(CouleurD,opacite),TyperemplisD,CondicoulG,Bitmap,Bitmap);
      ctRepere:begin   //s'il n'y a qu'un point ou un figur
               ajustepaisseur;
               BMRepere.DrawMode:=dmBlend;
               Bitmap.Draw(XC-ep,YC-largepais,BMRepere);
             end;
    end;
  except
    result:=False;
  end;
end;
procedure TDessin.ajustepaisseur;
var
  angle:single;
  X,Y:integer;
  i,j:integer;
  XC,YC:integer;
  Coultemp:TColor32;
  Nombremax:integer;
begin
  XC:=13;
  YC:=13;
  BMRepere.Clear($00FFFFFF);
  Coultemp:=CouleurD;
  BMRepere.PixelFS[XC, YC]:=Coultemp;
  Nombremax:=4*ep+1;
  //Nombremax:=1;
  for i:=1 to Nombremax do
    begin
      angle:=(Pi*i)/(2*(nombremax+1));
      for j:=1 to ep do
        begin
          X:=round(j*cos(angle));
          Y:=round(j*sin(angle));
          BMRepere.SetPixelTS(XC+X, YC+Y,Coultemp);
          BMRepere.SetPixelTS(XC-X, YC+Y,Coultemp);
          BMRepere.SetPixelTS(XC+X, YC-Y,Coultemp);
          BMRepere.SetPixelTS(XC-X, YC-Y,Coultemp);
        end;
    end;
  BMRepere.VertLine(XC,YC-ep,YC+ep,Coultemp);
  BMRepere.HorzLine(XC-ep,YC,XC+ep,Coultemp);
end;
procedure TDessin.ColleBitmap(X,Y:integer;transparent:Boolean;Bitmapsc:TBitmap;Bitmapdest:TBitmap32);
var
  BitmapTp:TBitmap32;
begin
//  LegEch.Transparent:=Transparent;
  bitmapTp:=TBitmap32.create;
  try
    Bitmaptp.Assign(Bitmapsc);
    if transparent then
      begin
        Bitmaptp.drawMode:=dmCustom;
        Bitmaptp.OnPixelCombine:=CopieTransp;
      end;
    Bitmaptp.DrawTo(Bitmapdest,X,Y);
  finally
    Bitmaptp.free;
  end;
end;
procedure TDessin.CopieTransp(F: TColor32; var B: TColor32; M: TColor32);
  begin
    if F=CouleurF then B:=$00FFFFFF else B:=F;
 end;


procedure TraceLibre(tracel:Tpolygon32;ep:integer;Color:TColor32;Bitmap:Tbitmap32);
Var
  Outl: TPolygon32;
begin
    if ep=0 then tracel.DrawEdge(Bitmap, Color)
    else
      begin
        Outl :=tracel.Outline; // create an outline
        Outl.Grow(Fixed({1+2*}ep),0).Draw(Bitmap, Color,Color);
        Bitmap.Changed;
      end;
end;
procedure TraceGrille(Xd,Yd,RC,ep:integer;precision:byte;CouleurD:TColor32;TypetraceD:TTypetrace;Bitmap:Tbitmap32);
var
  i,j,Xp,Yp,Xf,Yf,Xj,Yj:integer;
  nbpTirets:integer;
  Nb,NbLignesVert,NbLignesHorz:integer;
  delta:single;
begin
  if precision=1 then delta:=RC/10
  else if precision=2 then delta:=RC/100
  else if precision=3 then delta:=RC/1000
  else delta:=RC;
  Xf:=Bitmap.width-1;
  Yf:=Bitmap.height-1;
  nbpTirets:=4*(ep+1);
  nb:=round(Xd/delta);
  Xp:=Xd-round(nb*delta);
  nb:=round(Yd/delta);
  Yp:=Yd-round(nb*delta);
  NbLignesVert:=Round(Xf/delta);
  NbLignesHorz:=Round(Yf/delta);
  for j:=0 to NbLignesVert do
    begin
      Xj:=Xp+round(j*delta);
      for i:=-ep to ep do
        begin
          try
            if TypetraceD = ttTirete then Bitmap.VertTiretesTS(Xj-i,0,Yf,CouleurD,nbpTirets)
            else Bitmap.VertLineTS(Xj-i,0,Yf,CouleurD);
          except
          end;
      end;
    end;
  for j:=0 to NbLignesHorz do
    begin
      Yj:=Yp+round(j*delta);
      for i:=-ep to ep do
        begin
          try
            if TypetraceD = ttTirete then Bitmap.HorzTiretesTS(0,Yj-i,Xf,CouleurD,nbpTirets)
            else Bitmap.HorzLineTS(0,Yj-i,Xf,CouleurD);
          except
          end;
        end;
    end;
  Bitmap.Changed;
end;
procedure tracecercle(XC,YC,R,ep:integer;Color:TColor32;Typeremplis:TRemplis;Typetrace:TTypetrace;Bitmap:Tbitmap32);
var
  i,j:integer;
  angle:real;
  w,h,Xa,Ya,Xb,Yb:integer;// ,R1,R2
  nombre,total:integer;
  //R1cos,R2cos,R1sin,R2sin:integer;
  Xra,Yra,Xrb,Yrb:single;
  condition:boolean;
  ColorF:TColor32;
  nbpTirets:integer;
begin
  condition:= (Typetrace <> ttTirete) ;
  nombre:=7;
  w:=Bitmap.Width;
  h:=Bitmap.Height;
  //Bitmap.OuterColor:=SetAlpha(Color,0);//$00FFFFFF;

  ColorF:=SetAlpha(color,1);
  nbpTirets:=4*(ep+1);
  //R2:=R+ep;
  total:=nombre*(R+ep);
  if ep=0 then
    begin
      for i:=0 to total-1 do
        begin
          angle:=2*Pi*i/(total);
          Xa:=XC+Round(R*cos(angle));
          Ya:=YC+Round(R*sin(angle));
          try
            if condition or (frac(i/nbpTirets)<0.5) then
              Bitmap.SetPixelTS(Xa,Ya,color)
            else if (Xa>-1) and (ya>-1) and (xa<w) and (ya<h) then Bitmap[Xa,Ya]:=ColorF; //Bitmap.SetPixelTS(Xa,Ya,ColorF);
          except
          end;
        end;
    end
  else
    begin
//      R1:=R-ep;
      For j:=0 to 2*ep-1 do for i:=0 to total-1 do
        begin
          angle:=2*Pi*i/(total);
          Xa:=XC+Round((R+j/2)*cos(angle));
          Ya:=YC+Round((R+j/2)*sin(angle));
          Xb:=XC+Round((R-j/2)*cos(angle));
          Yb:=YC+Round((R-j/2)*sin(angle));
          try
            if condition or (frac(i/nbpTirets)<0.5) then
              begin
                Bitmap.SetPixelTS(Xa,Ya,Color);
                Bitmap.SetPixelTS(Xb,Yb,Color);
              end
            else
              begin
                if (Xa>-1) and (ya>-1) and (xa<w) and (ya<h) then Bitmap[Xa,Ya]:=ColorF; //Bitmap.SetPixelTS(Xa,Ya,ColorF);
                if (Xb>-1) and (yb>-1) and (xb<w) and (yb<h) then Bitmap[Xb,Yb]:=ColorF; //Bitmap.SetPixelTS(Xa,Ya,ColorF);
                //Bitmap.SetPixelTS(Xa,Ya,ColorF);
                //Bitmap.SetPixelTS(Xb,Yb,ColorF);
              end;
          except
          end;
        end;
      for i:=0 to total-1 do //if condition or (frac(i/nbpTirets)<0.5) then
        begin
          angle:=2*Pi*i/(total);
          Xra:=XC+(R+ep)*cos(angle);
          Yra:=YC+(R+ep)*sin(angle);
          Xrb:=XC+(R-ep)*cos(angle);
          Yrb:=YC+(R-ep)*sin(angle);
          try
            if condition or (frac(i/nbpTirets)<0.5) then
              begin
                //Bitmap.SetPixelTS(Round(Xra),Round(Yra),color);
                //Bitmap.SetPixelTS(Round(Xrb),Round(Yrb),color);
                Bitmap.PixelFS[Xra,Yra]:=color;
                Bitmap.PixelFS[Xrb,Yrb]:=color;
              end
            else
              begin
                if (Xra>=0) and (Yra>=0) and (Xra<=w-1) and (Yra<=h-1) then Bitmap[Round(Xra),Round(Yra)]:=ColorF;
                if (Xrb>=0) and (yrb>=0) and (xrb<=w-1) and (yrb<=h-1) then Bitmap[Round(Xb),Round(Yb)]:=ColorF;
                //Bitmap.SetPixelFS(Xra,Yra,ColorF);
                //Bitmap.SetPixelFS(Xrb,Yrb,ColorF);
              end;
          except
          end;
        end;
      Bitmap.Changed;
  end;
  if (R>ep) and (Typeremplis<>teAucun) then
    remplitVide(XC,YC,color,Typeremplis,CondicoulG,bitmap,bitmap);
end;
procedure Tracerect(Xd,Yd,Xf,Yf,ep:integer;Color:TColor32;Typeremplis:TRemplis;Typetrace:TTypetrace;Bitmap:Tbitmap32);
var
  i,Yca,Ycb,Xca,Xcb:integer;
  nbpTirets:integer;
begin
  if Yf<Yd then begin Yca:=Yf;Ycb:=Yd; end
  else begin Yca:=Yd;Ycb:=Yf; end;
  if Xf<Xd then begin Xca:=Xf;Xcb:=Xd; end
  else begin Xca:=Xd;Xcb:=Xf; end;
  nbpTirets:=4*(ep+1);
  for i:=-ep to ep do
    begin
      try
        if Typetrace = ttTirete then Bitmap.HorzTiretesTS(Xca-i, Yca-i, Xcb+i,color,nbpTirets)
        else Bitmap.HorzLineTS(Xca-i, Yca-i, Xcb+i,color);
      except
      end;
      try
        if Typetrace = ttTirete then Bitmap.HorzTiretesTS(Xca-i, Ycb+i, Xcb+i,color,nbpTirets)
        else Bitmap.HorzLineTS(Xca-i, Ycb+i, Xcb+i,color);
      except
      end;
      try
        if Typetrace = ttTirete then Bitmap.VertTiretesTS(Xca-i, Yca-i, Ycb+i,color,nbpTirets)
        else Bitmap.VertLineTS(Xca-i, Yca-i, Ycb+i,color);
      except
      end;
      try
        if Typetrace = ttTirete then Bitmap.VertTiretesTS(Xcb+i, Yca-i, Ycb+i,color,nbpTirets)
        else Bitmap.VertLineTS(Xcb+i, Yca-i, Ycb+i,color);
      except
      end;
    end;
  Bitmap.Changed;
  if (TypeRemplis<>teAucun) and ((ycb-yca)>(2*ep+1)) and ((xcb-xca)>(2*ep+1)) then
    remplitVide(XCa+ep+1,YCa+ep+1,color,Typeremplis,CondicoulG,bitmap,bitmap);
end;
procedure Tracetrait(Xd,Yd,Xf,Yf,ep:integer;Color:TColor32;Typetrait:TTypetrait;Typetrace:TTypetrace;Bitmap:Tbitmap32{;effacer:boolean});
var
  i,nombre:integer;
  epcY,epcX:single;
  ang,alpha:real;
  X,Y,l,w,h:integer;
  Xfc,Yfc:integer;
  contourfleche:TPolygon32;
begin
  if (Xd=Xf) and (Yd=Yf) then exit;
  nombre:=2;
  //if effacer then Bitmap.Clear($00FFFFFF);
  Bitmap.SetStipple([Color,0]);
  Bitmap.StippleStep:=0.5/(ep+1);
  w:=Bitmap.Width;
  h:=Bitmap.Height;
  // teste la sortie du cadre
  if Xf<0 then
    begin
      Xfc:=0;
      Yfc:=Round(Yd+(Yf-Yd)*(Xfc-Xd)/(Xf-Xd));
      if Yfc<0 then
        begin
          Yfc:=0;
          Xfc:=Round(Xd+(Xf-Xd)*(Yfc-Yd)/(Yf-Yd));
        end
      else if Yfc>h then
        begin
          Yfc:=h;
          Xfc:=Round(Xd+(Xf-Xd)*(Yfc-Yd)/(Yf-Yd));
        end;
    end
  else if Xf>=w then
    begin
      Xfc:=w;
      Yfc:=Round(Yd+(Yf-Yd)*(Xfc-Xd)/(Xf-Xd));
      if Yfc<0 then
        begin
          Yfc:=0;
          Xfc:=Round(Xd+(Xf-Xd)*(Yfc-Yd)/(Yf-Yd));
        end
      else if Yfc>h then
        begin
          Yfc:=h;
          Xfc:=Round(Xd+(Xf-Xd)*(Yfc-Yd)/(Yf-Yd));
        end;
    end
  else if Yf<0 then
    begin
      Yfc:=0;
      Xfc:=Round(Xd+(Xf-Xd)*(Yfc-Yd)/(Yf-Yd));
    end
  else if Yf>h then
    begin
      Yfc:=h;
      Xfc:=Round(Xd+(Xf-Xd)*(Yfc-Yd)/(Yf-Yd));
    end
  else
    begin
      Xfc:=Xf;
      Yfc:=Yf;
    end;
  for i:=-ep*nombre to ep*nombre do
    begin
      epcY:=(Xd-Xfc)/sqrt(sqr(Xfc-Xd)+sqr(Yfc-Yd))*i/nombre;
      epcX:=(Yfc-Yd)/sqrt(sqr(Xfc-Xd)+sqr(Yfc-Yd))*i/nombre;
      try
        if Typetrace=ttTirete then
          begin
            Bitmap.StippleCounter:=0;
            Bitmap.TireteFSP(Xd+epcX,Yd+epcY,Xfc+epcX,Yfc+epcY,True);
          end
        else Bitmap.LineFS(Xd+epcX,Yd+epcY,Xfc+epcX,Yfc+epcY,color,True);
      except
      end;
    end;
  Bitmap.Changed;

  if Typetrait=trLigne then exit;
  contourfleche:=TPolygon32.create;
  contourfleche.Closed:=False;
  contourfleche.Antialiased:=True;
  //contourfleche.NewLine;
  ang:=pi/4;
  l:=7+2*ep;
  if Xfc<>Xd then alpha:=Arctan((Yfc-Yd)/(Xfc-Xd)) else
    begin
      if Yfc>Yd then alpha:=Pi/2 else alpha:=-Pi/2;
    end;
  if (Xfc<Xd) then ang :=Pi-ang;
  X:=Xfc+Round(l*cos(alpha+Pi-ang));
  Y:=Yfc+Round(l*sin(alpha+Pi-ang));
  Contourfleche.Add(FixedPoint(X,Y));
  Contourfleche.Add(FixedPoint(Xfc,Yfc));
  X:=Xfc+Round(l*cos(alpha+Pi+ang));
  Y:=Yfc+Round(l*sin(alpha+Pi+ang));
  Contourfleche.Add(FixedPoint(X,Y));
  Bitmap.PenColor:=Color;
  Contourfleche.Outline.Grow(Fixed(ep),1).Draw(Bitmap,color,color);
  if Typetrait=trDoublef then
    begin
      contourfleche.Clear;
      ang :=Pi-ang;
      //contourfleche.NewLine;
      X:=Xd+Round(l*cos(alpha+Pi-ang));
      Y:=Yd+Round(l*sin(alpha+Pi-ang));
      Contourfleche.Add(FixedPoint(X,Y));
      Contourfleche.Add(FixedPoint(Xd,Yd));
      X:=Xd+Round(l*cos(alpha+Pi+ang));
      Y:=Yd+Round(l*sin(alpha+Pi+ang));
      Contourfleche.Add(FixedPoint(X,Y));
      Contourfleche.Outline.Grow(Fixed(ep),1).Draw(Bitmap,color,color);
    end;
  Contourfleche.Free;
end;
procedure TraceLegendEch(ep:integer;unite:string;coeff:single;Font:TFont;Color:TColor32;ColorF:TColor32;Bitmap:TBitmap);
var
  NbPixelsMin,NombrUnites,OrdreGrandeur:integer;
  TexteNombre,TextePuis:string;
  odg:real;
  NombrUnites_r:real;
  i:integer;
  longueurTrait,longueurtexte,longueur,hauteur,decal:integer;
  gauchetexte,debutrait:integer;
  TopTexte,TopTrait:integer;
begin
  if coeff<=0 then exit;
  Bitmap.Canvas.Brush.Color:=WinColor(ColorF);
  Bitmap.Canvas.Pen.Color:=WinColor(ColorF);
  if Bitmap.Width>0 then
    Bitmap.Canvas.Rectangle(0,0,Bitmap.Width,Bitmap.Height);
  Bitmap.Canvas.Font.Assign(Font);
  NbPixelsMin:=Bitmap.Canvas.TextWidth('4000  '+unite);
  NombrUnites_r:=NbPixelsMin*coeff;
  odg:=Log10(NombrUnites_r);
  ordregrandeur:=Trunc(odg);
  if odg<0 then ordregrandeur:=Trunc(odg)-1;
  NombrUnites:=round(NombrUnites_r/IntPower(10,ordregrandeur));
  if (nombrunites>2) and (nombrunites<5) then nombrunites:=5;
  if (nombrunites>5) and (nombrunites<10) then
    begin
      nombrunites:=1;
      ordregrandeur:=ordregrandeur+1;
    end;
  TexteNombre:=IntToStr(nombrunites);
  TextePuis:='';
  if (ordregrandeur>0) and (ordregrandeur<4) then
    for i:=1 to ordregrandeur do TexteNombre:=TexteNombre+'0';
  if (ordregrandeur<0) and (ordregrandeur>-4) then
    begin
      TexteNombre:='0.';
      for i:=ordregrandeur to -2  do TexteNombre:=TexteNombre+'0';
      TexteNombre:=TexteNombre+IntToStr(nombrunites);
    end;
  if (ordregrandeur<-3) or (ordregrandeur>3) then
    begin
      if nombrunites=1 then TexteNombre:='10' else TexteNombre:=IntToStr(nombrunites)+'.10';
      TextePuis:=IntToStr(ordregrandeur);
    end;
  NombrUnites_r:=NombrUnites*IntPower(10,ordregrandeur);
  longueurtrait:= round(NombrUnites_r/coeff);
  longueurTexte:=Bitmap.Canvas.TextWidth(TexteNombre+TextePuis+' '+unite);
  longueur:=longueurtrait+6;
  if (longueurTexte+4)>longueur then longueur:=longueurTexte+4;
  gauchetexte:=(longueur-longueurTexte) div 2;
  debutrait:=(longueur-longueurTrait) div 2;
  decal:=(Bitmap.Canvas.TextHeight(TexteNombre) div 2);
  TopTexte:=0;
  TopTrait:=Round(decal*3.5);
  hauteur:=TopTrait+10;
  Bitmap.Height:=hauteur;
  Bitmap.width:=longueur;
  Bitmap.Canvas.Pen.Color:=Wincolor(Color);
  Bitmap.Canvas.Font.Color:=Wincolor(Color);
  Bitmap.Canvas.Pen.width:=1+2*ep;
  Bitmap.Canvas.MoveTo(debutrait,Toptrait);
  Bitmap.Canvas.LineTo(debutrait,Toptrait+4);
  Bitmap.Canvas.LineTo(debutrait+longueurtrait,Toptrait+4);
  Bitmap.Canvas.LineTo(debutrait+longueurtrait,Toptrait);
  Bitmap.Canvas.TextOut(gauchetexte,TopTexte+decal,TexteNombre);
  gauchetexte:=gauchetexte+Bitmap.Canvas.TextWidth(TexteNombre);
  Bitmap.Canvas.TextOut(gauchetexte,TopTexte,TextePuis);
  gauchetexte:=gauchetexte+Bitmap.Canvas.TextWidth(TextePuis);
  Bitmap.Canvas.TextOut(gauchetexte,TopTexte+decal,' '+Unite);
  Bitmap.Canvas.MoveTo(debutrait,Toptrait);
  Bitmap.Canvas.LineTo(debutrait,Toptrait+4);
  Bitmap.Canvas.LineTo(debutrait+longueurtrait,Toptrait+4);
  Bitmap.Canvas.LineTo(debutrait+longueurtrait,Toptrait);
end;

procedure EcritTexte(Font:TFont;Alignement:integer;ColorF:TColor32;Texte:TStringList;Bitmap:TBitmap);
var
  i,Nombrelignes,p,pa,ppa:integer;
  longueurtexte,largeur,hauteur,htligne:integer;
  largeurligne:Array of integer;
  gauchetexte:integer;
  decalh:integer;
  chaine,souschaine,code1,code2,Code3,code4:string;
  Fonte:TFont;
  trouve:boolean;
  ah:integer;
  coefff:real;
  df:integer;
  condition:boolean;
  procedure EcritSousChaine;
  begin
    if condition then
      begin
        Bitmap.Canvas.TextOut(gauchetexte,htligne*i+1+decalh,SousChaine);
        gauchetexte:=gauchetexte+Bitmap.Canvas.TextWidth(SousChaine);
      end
    else largeurligne[i]:=largeurligne[i]+Bitmap.Canvas.TextWidth(SousChaine);
  end;
begin
  Nombrelignes:=Texte.Count;
  decalh:=0;
  Fonte:=Bitmap.Canvas.Font;
  Fonte.Assign(Font);
  coefff:=Fonte.PixelsPerInch/72;
  ah:=Abs(Font.Size);
  df:=round(ah/6);
  htligne:=Bitmap.Canvas.TextHeight('EAjp')+2;
  hauteur:=htligne*Nombrelignes+4;
  largeur:=0;
  SetLength(largeurligne,Nombrelignes);
  for i:=0 to Nombrelignes-1 do largeurligne[i]:=0;
  for pa:=0 to 1 do
    begin
      condition:=(pa=1);
      if condition then
        begin
          largeur:=largeur+8;
          Bitmap.Width:=largeur;
          Bitmap.Height:=hauteur;
          Bitmap.Canvas.Brush.Color:=WinColor(ColorF);
          Bitmap.Canvas.Pen.Color:=WinColor(ColorF);
          Bitmap.Canvas.Rectangle(0,0,Bitmap.Width,Bitmap.Height);   //efface
        end;
      for i:=0 to Nombrelignes-1 do
        begin
          gauchetexte:=0;
          if condition then
            begin
              Case Alignement of
                0:gauchetexte:=0;
                1:gauchetexte:=(largeur-largeurligne[i]) div 2;
                2:gauchetexte:=largeur-largeurligne[i];
              end;
            end;
          chaine:=Texte.Strings[i];
          trouve:=True;
          while trouve do
            begin
              Trouve:=False;
              p:=pos('<',chaine);
              if p>0 then
                begin
                  code1:=Copy(chaine,p,3);
                  code2:=Copy(chaine,p,4);
                  code3:=Copy(chaine,p,5);
                  code4:=Copy(chaine,p,6);
                  if code1='<b>' then
                    begin
                      souschaine:=Copy(chaine,1,p-1);
                      chaine:=copy(chaine,P+3,length(chaine)-p-2);
                      if SousChaine<>'' then EcritSousChaine;
                      if not (fsBold in Fonte.Style) then  Fonte.Style:=Fonte.Style+[fsBold];
                      Trouve:=True;
                    end;
                  if code1='<i>' then
                    begin
                      souschaine:=Copy(chaine,1,p-1);
                      chaine:=copy(chaine,P+3,length(chaine)-p-2);
                      if SousChaine<>'' then EcritSousChaine;
                      if not (fsItalic in Fonte.Style) then  Fonte.Style:=Fonte.Style+[fsItalic];
                      Trouve:=True;
                    end;
                  if code1='<u>' then
                    begin
                      souschaine:=Copy(chaine,1,p-1);
                      chaine:=copy(chaine,P+3,length(chaine)-p-2);
                      if SousChaine<>'' then EcritSousChaine;
                      if not (fsUnderline in Fonte.Style) then  Fonte.Style:=Fonte.Style+[fsUnderline];
                      Trouve:=True;
                    end;
                  if code3='<sup>' then
                    begin
                      souschaine:=Copy(chaine,1,p-1);
                      chaine:=copy(chaine,P+5,length(chaine)-p-4);
                      if SousChaine<>'' then EcritSousChaine;
                      Fonte.Size:=ah-df;
                      decalh:=-Round(df*coefff);
                      Trouve:=True;
                    end;
                  if code3='<sub>' then
                    begin
                      souschaine:=Copy(chaine,1,p-1);
                      chaine:=copy(chaine,P+5,length(chaine)-p-4);
                      if SousChaine<>'' then EcritSousChaine;
                      Fonte.Size:=ah-df;
                      decalh:=Round(df*coefff*2);
                      Trouve:=True;
                    end;

                  if code2='</b>' then
                    begin
                      souschaine:=Copy(chaine,1,p-1);
                      chaine:=copy(chaine,P+4,length(chaine)-p-3);
                      if SousChaine<>'' then EcritSousChaine;
                      if fsBold in Fonte.Style then  Fonte.Style:=Fonte.Style-[fsBold];
                      Trouve:=True;
                    end;
                  if code2='</i>' then
                    begin
                      souschaine:=Copy(chaine,1,p-1);
                      chaine:=copy(chaine,P+4,length(chaine)-p-3);
                      if SousChaine<>'' then EcritSousChaine;
                      if fsItalic in Fonte.Style then  Fonte.Style:=Fonte.Style-[fsItalic];
                      Trouve:=True;
                    end;
                  if code2='</u>' then
                    begin
                      souschaine:=Copy(chaine,1,p-1);
                      chaine:=copy(chaine,P+4,length(chaine)-p-3);
                      if SousChaine<>'' then EcritSousChaine;
                      if fsUnderline in Fonte.Style then  Fonte.Style:=Fonte.Style-[fsUnderline];
                      Trouve:=True;
                    end;
                  if code4='</sup>' then
                    begin
                      souschaine:=Copy(chaine,1,p-1);
                      chaine:=copy(chaine,P+6,length(chaine)-p-5);
                      if SousChaine<>'' then EcritSousChaine;
                      Fonte.Size:=ah;
                      decalh:=0;
                      Trouve:=True;
                    end;
                  if code4='</sub>' then
                    begin
                      souschaine:=Copy(chaine,1,p-1);
                      chaine:=copy(chaine,P+6,length(chaine)-p-5);
                      if SousChaine<>'' then EcritSousChaine;
                      Fonte.Size:=ah;
                      decalh:=0;
                      Trouve:=True;
                    end;
                  if not trouve then
                    begin
                      souschaine:=Copy(chaine,1,p);
                      chaine:=copy(chaine,p+1,length(chaine)-p);
                      //souschaine:='<';
                      //delete(chaine,1,1);
                      EcritSousChaine;
                      Trouve:=True;
                    end;
                end;
            end;
          if chaine<>'' then
            begin
              if condition then Bitmap.Canvas.TextOut(gauchetexte,htligne*i+1+decalh,Chaine)
              else largeurligne[i]:=Largeurligne[i]+Bitmap.Canvas.TextWidth(Chaine);
            end;
          if (not condition) and(largeurligne[i]>largeur) then largeur:=largeurligne[i];
        end;
    end;
end;

procedure tracemarque(ep:integer;color:Tcolor32;forme:TtypeMarque;Bitmap:TBitmap32);
var
  nombrerayons,XC,YC:integer;
begin
  XC:=13;
  YC:=13;
  Bitmap.Clear($00FFFFFF);
  if (ep>=XC) or (ep>=YC) then exit;
  if forme=tmCercle then
    begin
      tracecercle(XC,YC,ep,1,Color,teAucun,ttContinu,Bitmap);
    end
  else if forme=tmPlus then
    begin
      tracerond(ep,0,color,Bitmap);
    end
  else if forme=tmEtoile then
    begin
      tracerond(ep,1,color,Bitmap);
    end
  else if forme=tmEtoile2 then
    begin
      tracerond(ep,2,color,Bitmap);
    end
  else if forme=tmRond then
    begin
      tracerond(ep,-1,color,Bitmap);
    end
  else if forme=tmTri1 then
    begin
       Bitmap.LineS(XC-ep,YC-ep,XC+ep,YC-ep,Color,True);
       Bitmap.LineS(XC+ep,YC-ep,XC,YC+ep,Color,True);
       Bitmap.LineS(XC-ep,YC-ep,XC,YC+ep,Color,True);
       remplitvide(XC,YC,Color,tePlein,CondicoulG,Bitmap,Bitmap);
    end
  else if forme=tmTri2 then
    begin
       Bitmap.LineS(XC-ep,YC+ep,XC+ep,YC+ep,Color,True);
       Bitmap.LineS(XC+ep,YC+ep,XC,YC-ep,Color,True);
       Bitmap.LineS(XC,YC-ep,XC-ep,YC+ep,Color,True);
       remplitvide(XC,YC,Color,tePlein,CondicoulG,Bitmap,Bitmap);
    end
  else if forme=tmCroix then
    begin
       Bitmap.LineS(XC-ep,YC-ep,XC+ep,YC+ep,Color,True);
       Bitmap.LineS(XC+ep,YC-ep,XC-ep,YC+ep,Color,True);
    end
  else if forme=tmCarre then
    begin
       Bitmap.LineS(XC-ep,YC+ep,XC+ep,YC+ep,Color,True);
       Bitmap.LineS(XC+ep,YC+ep,XC+ep,YC-ep,Color,True);
       Bitmap.LineS(XC-ep,YC-ep,XC+ep,YC-ep,Color,True);
       Bitmap.LineS(XC-ep,YC-ep,XC-ep,YC+ep,Color,True);
       remplitvide(XC,YC,Color,tePlein,CondicoulG,Bitmap,Bitmap);
    end
  else if forme=tmLosange then
    begin
       Bitmap.LineS(XC-ep,YC,XC,YC-ep,Color,True);
       Bitmap.LineS(XC,YC-ep,XC+ep,YC,Color,True);
       Bitmap.LineS(XC+ep,YC,XC,YC+ep,Color,True);
       Bitmap.LineS(XC,YC+ep,XC-ep,YC,Color,True);
       remplitvide(XC,YC,Color,tePlein,CondicoulG,Bitmap,Bitmap);
    end;
end;
procedure tracerond(ep,nombrerayons:integer;color:Tcolor32;Bitmap:TBitmap32);
var
  angle:single;
  X,Y:integer;
  i,j,imax:integer;
  XC,YC:integer;
begin
  XC:=13;
  YC:=13;
  Bitmap.Clear($00FFFFFF);
  if nombrerayons<0 then imax:=4*ep+1 else imax:=nombrerayons;
  Bitmap.PixelFS[XC, YC]:=Color;
  for i:=1 to imax do
    begin
          angle:=(Pi*i)/(2*(imax+1));
          for j:=1 to ep do
            begin
              X:=round(j*cos(angle));
              Y:=round(j*sin(angle));
              Bitmap.SetPixelTS(XC+X, YC+Y,Color);
              Bitmap.SetPixelTS(XC-X, YC+Y,Color);
              Bitmap.SetPixelTS(XC+X, YC-Y,Color);
              Bitmap.SetPixelTS(XC-X, YC-Y,Color);
            end;
    end;
  Bitmap.VertLineS(XC,YC-ep,YC+ep,Color);
  Bitmap.HorzLineS(XC-ep,YC,XC+ep,Color);
end;
function agrandit(UnDessin:TDessin;coeff:single):TDessin;
var
  i:integer;
  UnPoint:TFixedPoint;
  FPI:TFixed;
  cfp:Tfixed;
Begin
  if UnDessin=nil then
    begin
      Result:=nil;
      exit;
    end;
  Result:=TDessin.Create;
  Result.cat:=UnDessin.cat;
  Result.couleurD:=UnDessin.couleurD;
  Result.couleurFD:=UnDessin.CouleurFD;
  Result.Alignement:=UnDessin.Alignement;
  Result.Transparent:=UnDessin.Transparent;
  Result.Rotation:=UnDessin.Rotation;
  Result.opaciteD:=UnDessin.OpaciteD;
  Result.TypetraitD:=UnDessin.TypetraitD;
  Result.TypetraceD:=UnDessin.TypetraceD;
  Result.TyperemplisD:=UnDessin.TyperemplisD;
  Result.NomFonte:=UnDessin.NomFonte;
  Result.StyleFonte:=UnDessin.StyleFonte;
  Result.TailleFonte:=Round(UnDessin.TailleFonte* coeff);;
  Result.Texte:=UnDessin.Texte;
  Result.ep:=Round(UnDessin.ep * coeff);
  if Result.ep>12 then Result.ep:=12;
  Result.Xd:=Round(UnDessin.Xd * coeff);
  Result.Yd:=Round(UnDessin.Yd * coeff);
  Result.Xf:=Round(UnDessin.Xf * coeff);
  Result.Yf:=Round(UnDessin.Yf * coeff);
  Result.XC:=Round(UnDessin.XC * coeff);
  Result.YC:=Round(UnDessin.YC * coeff);
  Result.RC:=Round(UnDessin.RC * coeff);
  If Result.cat=ctCrayon then
    begin
      cfp:=Fixed(Coeff);
      for i:=0 to High(UnDessin.tracel.Points[0]) do
        begin
          FPI:=(UnDessin.tracel.Points[0][i]).X;
          UnPoint.X:=FixedMul(FPI, cfp);
          FPI:=(UnDessin.tracel.Points[0][i]).Y;
          UnPoint.Y:=FixedMul(FPI, cfp);
          Result.tracel.Add(UnPoint);
        end;
    end;
End;
function StyledeFonte(Fonte:TFont):byte;
begin
        //taillefonte:=abs(Fonte.size);
  Result:=0; //style(octet 1:bold, octet 2:italic, octet 3:underline, octet 4:strikeout)
  if (fsbold in fonte.Style) then Result:=1;
  if (fsitalic in fonte.Style) then Result:=Result+2;
  if (fsunderline in fonte.Style) then Result:=Result+4;
  if (fsstrikeout in fonte.Style) then Result:=Result+8;
end;
procedure RendOpacite(ColorF:TColor32;opacite:integer;Bitmap:TBitmap32);
var
  x,y,w,h:integer;
  Couleurtr:TColor32;
  color:TColor32;
begin
  Couleurtr:=ColorF and $00FFFFFF;
  w:=Bitmap.width;
  h:=Bitmap.height;
  for y:=0 to h-1 do
    for x:=0 to w-1 do
      if (Wincolor(Bitmap[x,y])=Wincolor(ColorF)) then Bitmap[x,y]:=couleurtr
      else Bitmap[x,y]:=SetAlpha(Bitmap[x,y],opacite);
end;
procedure RendTransparent(ColorF:TColor32;Bitmap:TBitmap32);
var
  x,y,w,h:integer;
  Couleurtr:TColor32;
begin
  Couleurtr:=ColorF and $00FFFFFF;
  w:=Bitmap.width;
  h:=Bitmap.height;
  for y:=0 to h-1 do
    for x:=0 to w-1 do
      if Wincolor(Bitmap[x,y])=WinColor(ColorF) then Bitmap[x,y]:=couleurtr;
end;
function RechercheEmboites(X,Y:integer;Contourext:TArrayOfPoint;Bitmap:TBitmap32;out Xdep,Ydep:integer):TTableauEntiers;
var
  i,j,w,h,nbp,nbpc,nbemb,numero:integer;
  PointsTest:TArrayOfPoint;
  CopiePointsTest:TArrayOfPoint;
  Xt,Yt,Xd,Yd,Xf,Yf,Xmi,Xma,Ymi,Yma:integer;
  Color:TColor32;
  trouve:boolean;
  identique:Boolean;
  procedure ajouteNumero(num:integer);
  Var
    NonTrouve:boolean;
    itp:integer;
  begin
    NonTrouve:=true;
    for itp:=0 to nbemb-1 do
      begin
        if num=result[itp] then
          begin
            NonTrouve:=false;
            break;
          end;
      end;
    if NonTrouve then
      begin
        Setlength(result,nbemb+1);
        Result[nbemb]:=num;
        inc(nbemb);
      end;
  end;
  procedure tracepoint;
  var
    coultest:TColor32;
    np,n,Alpha:integer;
    numerotest:cardinal;
  begin
    coultest:=Bitmap[Xt,Yt];
    Alpha:=AlphaComponent(CoulTest);
    if Alpha=0 then
      begin
        numerotest:=coultest and $FFFFFF;
        np:=Length(PointsTest);
        bitmap[Xt,Yt]:=SetAlpha(coultest,128);
        SetLength(PointsTest,np+1);
        PointsTest[np].X:=Xt;
        PointsTest[np].Y:=Yt;
        if (numerotest<>numero) and (numerotest>0) then
           ajouteNumero(numerotest-1);
      end
    else if (Alpha=255) and (coultest<>color) then
      begin
        n:=coultest and $00FFFFFF;
        ajouteNumero(n-1);
      end;
  end;
begin
  w:=Bitmap.Width;
  h:=Bitmap.Height;
  nbemb:=0;
  SetLength(Result,0);
  Xdep:=X;
  Ydep:=Y;
  if (Bitmap[X,Y] and $FF000000)>0 then exit;
  numero:=Bitmap[X,Y];
  Color:=SetAlpha(numero,255);
  //Bitmap.PenColor:=Color;
  //Bitmap.MoveTo(Contourext[0].X,Contourext[0].Y);
  Xmi:=w;
  Xma:=0;
  Ymi:=h;
  Yma:=0;
  for i:=0 to Length(Contourext)-1 do   //balise le contour  avec le $FF000000+numero
    begin
      Xt:=Contourext[i].X;
      if Xmi>Xt then Xmi:=Xt;
      if Xma<Xt then Xma:=Xt;
      Yt:=Contourext[i].Y;
      if Ymi>Yt then Ymi:=Yt;
      if Yma<Yt then Yma:=Yt;
      //Bitmap.LineToS(Xt,Yt);
      Bitmap[Xt,Yt]:=Color;
    end;
  if ((Xma-Xmi)<4) or ((Yma-Ymi)<4) then exit;
  // Recherche d'un point de dpart hors du contour
    nbpc:=Length(ContourExt);
    if Bitmap[X,Y]=Color then
    begin
      trouve:=false;
      for i:=0 to nbpc-2 do
        begin
          identique:=false;
          for j:=i+1 to i+nbpc-1 do
            begin
              if (ContourExt[i].X=ContourExt[(j mod nbpc)].X)and(ContourExt[i].Y=ContourExt[(j mod nbpc)].Y) then
                begin
                  identique:=true;
                  break;
                end;
            end;
          if not identique then
            begin
              if (i=0) then trouve:=(ContourExt[nbpc-1].X<>ContourExt[1].X)or(ContourExt[nbpc-1].Y<>ContourExt[1].Y)
              else if i=(nbpc-1) then trouve:=(ContourExt[nbpc-2].X<>ContourExt[0].X)or(ContourExt[nbpc-2].Y<>ContourExt[0].Y)
              else trouve:=(ContourExt[i-1].X<>ContourExt[i+1].X)or(ContourExt[i-1].Y<>ContourExt[i+1].Y);
              if trouve then
                begin
                  trouve:=false;
                  Xd:=ContourExt[i].X;
                  Xf:=ContourExt[(i+1)mod nbpc].X;
                  Yd:=ContourExt[i].Y;
                  Xf:=ContourExt[(i+1)mod nbpc].Y;
                  Xt:=-1;
                  Yt:=-1;
                  if (Xf>Xd) and (Yf>=Yd) then
                    begin
                      Xt:=Xd;
                      Yt:=Yd+1;
                    end
                  else if (Xf<Xd) and (Yf<=Yd) then
                    begin
                      Xt:=Xd;
                      Yt:=Yd-1;
                    end
                  else if (Yf>Yd) and (Xf<=Xd) then
                    begin
                      Xt:=Xd-1;
                      Yt:=Yd;
                    end
                  else if (Yf<Yd) and (Xf>=Xd) then
                    begin
                      Xt:=Xd+1;
                      Yt:=Yd;
                    end;
                  if (Xt>=0)and(Yt>=0)and(Xt<w)and(Yt<h)and (Bitmap[Xt,Yt]=numero) then
                    begin
                      trouve:=True;
                      break;
                    end;
                end;
            end;
        end;
      if Not trouve then Exit;
    end
  else
    begin
      Xt:=X;
      Yt:=Y;
    end;

{  if Bitmap[X,Y]=Color then
    begin
      if (Y<(h-1)) and (Bitmap[X,Y+1]=numero) then
        begin
          Xt:=X;
          Yt:=Y+1;
        end
      else if (X<(w-1)) and (Bitmap[X+1,Y]=numero) then
        begin
          Xt:=X+1;
          Yt:=Y;
        end
      else if (Y>0) and (Bitmap[X,Y-1]=numero) then
        begin
          Xt:=X;
          Yt:=Y-1;
        end
      else if (X>0) and (Bitmap[X-1,Y]=numero) then
        begin
          Xt:=X-1;
          Yt:=Y;
        end
      else
        begin
          trouve:=false;
          for Yd:=Y to h-1 do
            begin
              for Xd:=0 to w-1 do
                if Bitmap[Xd,Yd]=numero then
                  begin
                    trouve:=true;
                    Xt:=Xd;
                    Yt:=Yd;
                    break;
                  end;
              if trouve then break;
            end;
          if not trouve then
            begin
              for Yd:=Y-1 downto 0 do
                begin
                  for Xd:=0 to w-1 do
                    if Bitmap[Xd,Yd]=numero then
                      begin
                        trouve:=true;
                        Xt:=Xd;
                        Yt:=Yd;
                        break;
                      end;
                  if trouve then break;
                end;
              if not trouve then exit;
            end;
        end;
    end
  else
    begin
      Xt:=X;
      Yt:=Y;
    end;}
  Xdep:=Xt;
  Ydep:=Yt;
  SetLength(PointsTest,0);
  tracepoint;
  SetLength(CopiePointsTest,1);
  CopiePointsTest[0]:=Point(Xt,Yt);
  //nbp:=0;
  while Length(CopiePointsTest)>0 do
    begin
      for i:=0 to Length(CopiePointsTest)-1 do
        begin
          if CopiePointsTest[i].X>0 then
            begin
              Xt:=CopiePointsTest[i].X-1;
              Yt:=CopiePointsTest[i].Y;
              tracepoint;
            end;
          if CopiePointsTest[i].Y>0 then
            begin
              Xt:=CopiePointsTest[i].X;
              Yt:=CopiePointsTest[i].Y-1;
              tracepoint;
            end;
          if CopiePointsTest[i].X<(w-1) then
            begin
              Xt:=CopiePointsTest[i].X+1;
              Yt:=CopiePointsTest[i].Y;
              tracepoint;
            end;
          if CopiePointsTest[i].Y<(h-1) then
            begin
              Xt:=CopiePointsTest[i].X;
              Yt:=CopiePointsTest[i].Y+1;
              tracepoint;
           end;
        end;
      SetLength(CopiePointsTest,Length(PointsTest));
      for i:=0 to Length(PointsTest)-1 do
        begin
          CopiePointsTest[i]:=PointsTest[i];
        end;
      SetLength(PointsTest,0);
    end;
  SetLength(CopiePointsTest,0);
  //BytemapTp.Free;
end;
// ***** mthode "suivez le bord" *****
//procedure LigneContour(X,Y:integer;PolyConditions:TTableaudeTableaudeCondicoul;BytemapTp:TBytemap;Bitmaptest{,Bitmaptrav}:TBitmap32;var LargeurContour,HauteurContour,NombredePoints,nombretraces:integer);
function LigneContour(X,Y:integer;Marquer:Boolean;CoulSurf:TColor32;PolyConditions:TTableaudeTableaudeCondicoul;BytemapTp:TBytemap;Bitmaptest,Bitmaptrav:TBitmap32;var Largeurcontour,HauteurContour,NombredePoints,nombretraces:integer):integer;
const
  nombrelimite=1;
var
  nombrepixels:integer;
  NumOuverts:Array of integer;
  pt:integer;
  i,ii,j,jdeb,jj,k,kk,n,n2,n3,w,h,nbp,espace:integer;
  trouve:boolean;
  //EnDouble:boolean;
  //ApresBoucleIncl:Boolean;
  //ApresBoucleCont:Boolean;
  //ApresPointe:Boolean;
  PointsTest:TArrayOfPoint;
  nbpts:integer;
  nbcn:integer; // nombre de canaux d'une image satellitale
  ValCanaux:Array of byte;
  CopiePointsTest:TArrayOfPoint;
  UnPoint:TPoint;
  ByteP,ByteS:byte;
  //DrInclusion:Boolean;
  //DrContour:Boolean;
  Xp,Yp:integer;
  Xt,Yt:integer;
  Xprec,Yprec:integer;
  PointPrec:TPoint;
  PremPoint:TPoint;
  PointPrecI:TPoint;
  XDprec,YDprec:integer;
  jd:integer;
  ideb:integer;
  Xprem,Yprem:integer;
  nouveauxpoints:boolean;
  LeByte:Byte;
  ajoute:boolean;
  valeur:integer;
  nombrecontours:integer;
  LesContours:TArrayOfArrayofPoint;
  XPointDeb,YpointDeb,XPointFin,YpointFin:integer;
  Xmaxi,Xmini,Ymaxi,Ymini:integer;
  deltaX,deltaY,deltaXContour,deltaYContour:integer;
  LaBoucle:TArrayOfPoint;
  //PointsDoubles:TArrayOfPoint;
  //MorceauxCommuns:TArrayOfArrayofPoint;
  erreurtrigo:boolean;
  //tunnel:boolean;
  //sortietunnel:boolean;
  procedure AjoutePointContour(LePoint:Tpoint;var LeTrace:TArrayOfPoint);
  var
    long:integer;
  begin
    long:=Length(LeTrace);
    SetLength(LeTrace,long+1);
    LeTrace[long]:=LePoint;
  end;
  procedure AjoutePoint;
  begin
    n:=Length(PointsTest);
    SetLength(PointsTest,n+1);
    PointsTest[n].X:=Xt;
    PointsTest[n].Y:=Yt;
    if Xmaxi<Xt then Xmaxi:=Xt;
    if Xmini>Xt then Xmini:=Xt;
    if Ymaxi<Yt then Ymaxi:=Yt;
    if Ymini>Yt then Ymini:=Yt;
  end;
{  function testepointcommun:boolean;
  var
    UnByte:byte;
    itp,ntp:integer;
  begin
    if (Xt>-1) and (Yt>-1) then UnByte:=(Bytemaptp.Value[Xt,Yt] and 120)
    else UnByte:=0;
    if (UnByte=56) or (UnByte=88) or (UnByte=104)or (UnByte=112) then //pointe
      begin
        if (XDprec>=0) and (YDprec>=0) and (jD>-1) and (abs(XDprec-Xt)<2) and (abs(YDprec-Yt)<2) then
          begin
            Result:=True;
            ntp:=Length(MorceauxCommuns[jD]);
            AjoutePointContour(PointsTest[i],MorceauxCommuns[jD]);
            for itp:=ntp-1 downto 0 do AjoutePointContour(MorceauxCommuns[jD][itp],MorceauxCommuns[jD]);
            jD:=-1;
          end
        else Result:=False;
      end
    else if (UnByte=80) or (UnByte=40) then    //points communs
      begin
        result:=True;
        if (XDprec<0) or (YDprec<0) or (jD=-1) or (abs(XDprec-Xt)>1)or (abs(YDprec-Yt)>1) then
          begin
            jD:=Length(MorceauxCommuns);
            SetLength(MorceauxCommuns,jD+1);
          end;
        AjoutePointContour(PointsTest[i],MorceauxCommuns[jD]);
        //Bitmaptrav[Xt,Yt]:=Clwhite32;
        XDprec:=Xt;
        YDprec:=Yt;
      end
    else
      begin
        Result:=False;
      end;
  end;}
  function testepoint:boolean;
  var
    itp:integer;
  begin
    if Bytemaptp.Value[Xt,Yt]=6 then
      begin
        Result:=False;
        exit;
      end;
    if nbcn>0 then
      begin
        for itp:=0 to nbcn-1 do
          ValCanaux[itp]:=CopieCanaux[itp].Value[xt,yt];
      end;
    Result:=TestePolyCondicoul(BitmapTest[Xt,Yt],ValCanaux,Polyconditions);
    if Result then
      begin
        if Bytemaptp.Value[Xt,Yt]=0 then
          begin
            Bytemaptp.Value[Xt,Yt]:=valeur;
            nouveauxPoints:=True;
            AjoutePoint;
            inc(nombrepixels);
            {if marquer then} Bitmaptrav[Xt,Yt]:=CoulSurf;
          end;
      end
    else
      begin
        Bytemaptp.Value[Xt,Yt]:=6;
        //Bitmaptrav[Xt,Yt]:=ClRed32;
      end;
  end;
{  procedure coloreBitmap;
  var
    Unbyte:byte;
  begin
    Unbyte:=(Bytemaptp.Value[XP,YP] and 120);
    if UnByte=0 then exit;
    case UnByte of
      8,16,32,64:Bitmaptrav[XP,YP]:=clLime32;
      40,80:Bitmaptrav[XP,YP]:=clAqua32;
      24,96,72,48:Bitmaptrav[XP,YP]:=clfuchsia32;
      else Bitmaptrav[XP,YP]:=clblack32;
    end;
  end;}
  procedure testeSud;
  begin
    Xt:=XP;
    Yt:=YP+1;
    valeur:=4;
    if (Yt<h) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 64;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 64;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  procedure testeOuest;
  begin
    Xt:=XP-1;
    Yt:=YP;
    valeur:=1;
    if (Xt>=0) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 8;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 8;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  procedure testeNord;
  begin
    Xt:=XP;
    Yt:=YP-1;
    valeur:=2;
    if (Yt>=0) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 16;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 16;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  procedure testeEst;
  begin
    Xt:=XP+1;
    Yt:=YP;
    valeur:=3;
    if (Xt<w) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 32;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 32;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  function SontVoisins(Point1,Point2:TPoint):Boolean;
    begin
      Result:=(Abs(Point1.X-Point2.X)<2) and (Abs(Point1.Y-Point2.Y)<2);
    end;
  function EstUnePointe(LePoint:TPoint):boolean;
  var
    UnByte:byte;
    itp,ntp:integer;
  begin
    if (LePoint.X>-1) and (LePoint.Y>-1) then UnByte:=(Bytemaptp.Value[LePoint.X,LePoint.Y] and 120)
    else UnByte:=0;
    Result:=((UnByte=56) or (UnByte=88) or (UnByte=104) or (UnByte=112));
  end;
  function PointEnDouble(LePoint:TPoint):boolean;
  var
    UnByte:byte;
    itp,ntp:integer;
  begin
    if (LePoint.X>-1) and (LePoint.Y>-1) then UnByte:=(Bytemaptp.Value[LePoint.X,LePoint.Y] and 120)
    else UnByte:=0;
    Result:=((UnByte=80) or (UnByte=40));   //points communs
  end;
  function testeboucletrigo(Boucle:TArrayOfPoint;out DX,DY:integer;erreur:boolean):boolean;
  var
    i,iXmin,iXmax,iYmin,iYmax,isuiv,iprec,n,Xmin,Xmax,Ymin,Ymax,YRef:integer;
    arefaire:boolean;
  begin
   result:=false;
   erreur:=false;
   n:=Length(Boucle);
   if (n<3) or (abs(Boucle[0].X-Boucle[n-1].X)>1) or (abs(Boucle[0].Y-Boucle[n-1].Y)>1) then
     begin
       erreur:=True;
       exit;
     end;
   for i:=0 to n-2 do
     if not SontVoisins(Boucle[i],Boucle[i+1]) then
       begin
//ShowMessage('Boucle non conforme');
         erreur:=True;
         exit;
       end;
   iXmin:=0;
   Xmin:=65535;
   iXmax:=0;
   Xmax:=0;
   iYmin:=0;
   Ymin:=65535;
   iYmax:=0;
   Ymax:=0;
   for i:=0 to n-1 do
     begin
       if Boucle[i].X<Xmin then
         begin
           iXmin:=i;
           Xmin:=Boucle[i].X;
         end;
       if Boucle[i].X>Xmax then
         begin
           iXmax:=i;
           Xmax:=Boucle[i].X;
         end;
       if Boucle[i].Y<Ymin then
         begin
           iYmin:=i;
           Ymin:=Boucle[i].Y;
         end;
       if Boucle[i].Y>Ymax then
         begin
           iYmax:=i;
           Ymax:=Boucle[i].Y;
         end;
     end;
   dX:=(Xmax-Xmin);
   dY:=(Ymax-Ymin);
   if (dX<2)  or (dY<2)  then
     begin
       erreur:=True;
       exit;
     end;
     Yref:=Boucle[iXmin].Y;
     isuiv:=(iXmin+1) mod n;
     iprec:=(iXmin-1);
     if iprec<0 then iprec:=n-1;
     arefaire:=True;
     While arefaire=True do
       begin
         if (Yref-Boucle[isuiv].Y)>0 then
           begin
             if (Yref-Boucle[iprec].Y)<=0 then exit
             else if (Boucle[iprec].X)>(Boucle[isuiv].X) then exit
             else if (Boucle[iprec].X)<(Boucle[isuiv].X) then
               begin
                 Result:=True;
                 Exit;
               end
             else if (Boucle[iprec].X)>(Boucle[isuiv].X) then exit
             else   // prcdent et suivant identiques
               begin
                 if ((isuiv-iXmin)> (n div 2)) or ((iXmin-iprec)> (n div 2)) then
                   begin
                     erreur:=true;
                     exit;
                   end;
                 isuiv:=(isuiv +1) mod n;
                 dec(iprec);
                 if iprec<0 then iprec:=n-1;
                 arefaire:=true;
               end;
           end
         else if (Yref-Boucle[isuiv].Y)<0 then
           begin
             if (Yref-Boucle[iprec].Y)>=0 then
               begin
                 Result:=True;
                 exit;
               end
             else if (Boucle[iprec].X)<(Boucle[isuiv].X) then exit
             else if (Boucle[iprec].X)>(Boucle[isuiv].X) then
               begin
                 Result:=True;
                 exit;
               end
             else  // prcdent et suivant identiques
               begin
                 if ((isuiv-iXmin)> (n div 2)) or ((iXmin-iprec)> (n div 2)) then
                   begin
                     erreur:=true;
                     exit;
                   end;
                 isuiv:=(isuiv +1) mod n;
                 dec(iprec);
                 if iprec<0 then iprec:=n-1;
                 arefaire:=true;
               end;
           end
         else // cas d'galit;
           begin
             if ((isuiv-iXmin)> (n div 2)) or ((iXmin-iprec)> (n div 2)) then
               begin
                 erreur:=true;
                 exit;
               end;
             isuiv:=(isuiv +1) mod n;
             dec(iprec);
             if iprec<0 then iprec:=n-1;
             arefaire:=true;
           end;
       end;
  end;
  procedure ChercheSiContour(nbinc:integer;var Boucle:TArrayOfPoint);
  var
    UneBoucle:TArrayOfPoint;
    i:integer;
  begin
    erreurtrigo:=false;
    if not testeboucletrigo(Boucle,DeltaX,DeltaY,erreurtrigo) then
      begin
      if not erreurtrigo then
        begin
          if (DeltaXContour<deltaX) and (DeltaXContour<deltaY) then
            begin
              DeltaXContour:=deltaX;
              DeltaYContour:=deltaY;
              if Length(LeContour)>0 then
                begin
                  ShowMessage('Attention ! Deuxime contour externe '+IntToStr(Length(Boucle)+1)+' points');
                  SetLength(UneBoucle,Length(LeContour));
                  for i:=0 to Length(LeContour)-1 do UneBoucle[i]:=LeContour[i];
                  SetLength(LeContour,Length(Boucle));
                  for i:=0 to Length(Boucle)-1 do LeContour[i]:=Boucle[i];
                  SetLength(Boucle,Length(UneBoucle));
                  for i:=0 to Length(Boucle)-1 do Boucle[i]:=UneBoucle[i];
                  SetLength(UneBoucle,0);
               end
             else
               begin
                  SetLength(LeContour,Length(Boucle));
                  for i:=0 to Length(Boucle)-1 do LeContour[i]:=Boucle[i];
                  SetLength(LesInclusions,nbinc);
               end;
            end;
        end;
      end
    else if (DeltaXContour<deltaX) and (DeltaXContour<deltaY) then
      begin
        DeltaXContour:=deltaX;
        DeltaYContour:=deltaY;
      end;
  end;
  function ChercheComplementEff(Pointfinal:TPoint;var Trace1,Tracesource:TArrayOfPoint):Boolean;
  var
    itp,itp2,nsc,n1:integer;
    LePoint:TPoint;
  begin
    nsc:=Length(TraceSource);
    n1:=Length(Trace1);
    if (nsc=0)or (n1=0) then
      begin
        Result:=False;
        exit;
      end;
    itp:=0;
    while (itp<nsc)and (itp<n1) and SontVoisins(Tracesource[nsc-itp-1],Trace1[n1+itp-1]) and (not SontVoisins(PointFinal,Trace1[n1+itp-1])) do
      begin
        AjoutePointContour(Tracesource[nsc-itp-1],Trace1);
        SetLength(Tracesource,nsc-itp-1);
        inc(itp);
      end;
   n1:=Length(Trace1);
   Result:=SontVoisins(PointFinal,Trace1[n1-1]);
  end;
  function DetacheBoucle(var Trace:TArrayOfPoint):Boolean;
  var
    itp,ntp,jtp,ktp:integer;
    mnx,mxx,mny,mxy:integer;
    erreur:boolean;
    dx,dy:integer;
    Boucle:TArrayOfPoint;
  begin
    Result:=False;
    ntp:=Length(Trace);
    if ntp<4 then exit;
    ktp:=-1;
    mnx:=Trace[ntp-1].X;
    mxx:=Trace[ntp-1].X;
    mny:=Trace[ntp-1].Y;
    mxy:=Trace[ntp-1].Y;
    for itp:=ntp-3 to ntp-2 do
      begin
        if mnx>Trace[itp].X then mnx:=Trace[itp].X;
        if mxx<Trace[itp].X then mxx:=Trace[itp].X;
        if mny>Trace[itp].Y then mny:=Trace[itp].Y;
        if mxy<Trace[itp].Y then mxy:=Trace[itp].Y;
      end;
    for itp:=ntp-4 downto 0 do
      begin
        if mnx>Trace[itp].X then mnx:=Trace[itp].X;
        if mxx<Trace[itp].X then mxx:=Trace[itp].X;
        if mny>Trace[itp].Y then mny:=Trace[itp].Y;
        if mxy<Trace[itp].Y then mxy:=Trace[itp].Y;
        if not SontVoisins(Trace[itp],Trace[itp+1]) then exit;
        if SontVoisins(Trace[itp],Trace[ntp-1]) then
          begin
            ktp:=itp;
            break;
          end;
      end;
    if ktp=-1 then exit;
    SetLength(Boucle,0);
    for itp:=ktp to ntp-1 do AjoutePointContour(Trace[itp],Boucle);
    if testeboucletrigo(Boucle,DX,DY,erreur) then
      if not erreur then
        begin
          if ((mxx-mnx)>1) and ((mxy-mny)>1) then
            begin
              jtp:=Length(LesInclusions);
              SetLength(LesInclusions,jtp+1);
              for itp:=ktp to ntp-1 do AjoutePointContour(Trace[itp],LesInclusions[jtp]);
              SetLength(Trace,ktp);
              Result:=True;
            end;
        end;
    SetLength(Boucle,0);
  end;
  function RechercheIndexMiniX(miniX:integer;boucle:TArrayOfPoint):integer;
  var
    itp:integer;
  begin
    result:=-1;
    for itp:=0 to Length(Boucle)-1 do
      if boucle[itp].X=miniX then
        begin
          Result:=itp;
          Break;
        end;
  end;
  function PointDifferent(Point1,Point2:TPoint):Boolean;
  begin
    Result:=(Point1.x<>Point2.x) or (Point1.y<>Point2.y);
  end;
  function SuitLeFil(Point1,Point2:TPoint;var LeByte:Byte):boolean;
  var
    DX,DY:integer;
  begin
    Result:=false;
    DX:=Point2.x-Point1.x;
    DY:=Point2.y-Point1.y;
    if (Abs(DX)>1) or (Abs(DY)>1)or(Point1.X<0)or(Point1.Y<0) or(Point1.X>w-1)or(Point1.Y>h-1)
      or(Point2.X<0)or(Point2.Y<0) or(Point2.X>w-1)or(Point2.Y>h-1) then  exit;
    LeByte:=Bytemaptp.Value[Point2.x,Point2.y] and 120;
    if ((DX=1) and (DY>=0)) then
      begin
        result:=((Lebyte and 16)=16) //limite N
        //Lebyte:=(Lebyte and 16);
        //result:=(Lebyte=16) //limite N
      end
    else if ((DX=-1) and (DY<=0)) then
      begin
        result:=((Lebyte and 64)=64) //limite S
//        Lebyte:=(Lebyte and 64);
//        result:=(Lebyte=64) //limite S
      end
    else if ((DX>=0) and (DY=-1)) then
      begin
        result:=((Lebyte and 8)=8) //limite O
//        Lebyte:=(Lebyte and 8);
//        result:=(Lebyte=8) //limite O
        end
    else if ((DX<=0) and (DY=1)) then
      begin
        result:=((Lebyte and 32)=32) //limite E
//        Lebyte:=(Lebyte and 32);
//        result:=(Lebyte=32) //limite E
      end;
  end;
  function PointContourSuivant(LeByteP:byte;LePoint:TPoint;var {drprem:boolean;}LeByteS:Byte):TPoint;
  Var
    PX,PY,index,iddeb,idfin,delp:integer;
    PointsEssais:Array[0..7]of TPoint;
    drprem:boolean;
    sens:byte;
    ValeursExclues:Array[0..7]of integer;
    nbve:integer;
    condition:boolean;
    itp,val:integer;
  begin
   // nouveau codage des byteS 1: sens (va vers) N ou NE
   // nouveau codage des bytes 2: sens E ou SE
   // nouveau codage des bytes 4: sens S ou SO
   // nouveau codage des bytes 8: sens O ou NO
   // nouveau codage des bytes 16: obstacle  l'O
   // nouveau codage des bytes 32: obstacle au N
   // nouveau codage des bytes 64: obstacle a l'E
   // nouveau codage des bytes 128: obstacle au S
    PX:=LePoint.x;
    PY:=LePoint.y;
    //if drprem then delp:=1 else delp:=0;
    if (PX>=0) and (PY>=0) then
      begin
        PointsEssais[0]:=Point(PX-1,PY-1);
        PointsEssais[1]:=Point(PX,PY-1);
        PointsEssais[2]:=Point(PX+1,PY-1);
        PointsEssais[3]:=Point(PX+1,PY);
        PointsEssais[4]:=Point(PX+1,PY+1);
        PointsEssais[5]:=Point(PX,PY+1);
        PointsEssais[6]:=Point(PX-1,PY+1);
        PointsEssais[7]:=Point(PX-1,PY);
        for index:=0 to 5 do ValeursExclues[index]:=-1;
        nbve:=0;
        //drprem:=((Lebyte=40) or (LeByte=80));
        if (LeByteP and 1)=1 then
          begin
            iddeb:=0;
            idfin:=6;
          end
        else if (LeByteP and 2)=2 then
          begin
            iddeb:=2;
            idfin:=8;
          end
        else if (LeByteP and 4)=4 then begin iddeb:=4; idfin:=iddeb+6; end
        else if (LeByteP and 8)=8 then  begin iddeb:=6; idfin:=iddeb+6; end;
        if ((LeByteP and 48)=48) then
          begin
            inc(nbve);
            ValeursExclues[nbve-1]:=0;
          end;
        if ((LeByteP and 32)=32) then
          begin
            inc(nbve);
            ValeursExclues[nbve-1]:=1;
          end;
        if ((LeByteP and 96)=96) then
          begin
            inc(nbve);
            ValeursExclues[nbve-1]:=2;
          end;
        if ((LeByteP and 64)=64) then
          begin
            inc(nbve);
            ValeursExclues[nbve-1]:=3;
          end;
        if ((LeByteP and 192)=192) then
          begin
            inc(nbve);
            ValeursExclues[nbve-1]:=4;
          end;
        if ((LeByteP and 128)=128) then
          begin
            inc(nbve);
            ValeursExclues[nbve-1]:=5;
          end;
        if ((LeByteP and 144)=144) then
          begin
            inc(nbve);
            ValeursExclues[nbve-1]:=6;
          end;
        if ((LeByteP and 16)=16) then
          begin
            inc(nbve);
            ValeursExclues[nbve-1]:=7;
          end;
        for index:=iddeb to idfin+6  do
          begin
           condition:=True;
           for itp:=0 to nbve-1 do Condition:=Condition and((index mod 8)<>ValeursExclues[itp]);
           if condition then
              begin
                if SuitLeFil(LePoint,PointsEssais[index mod 8],ByteS) then
                  begin
                    Case (Index mod 8) of
                      1,2:sens:=1;
                      3,4:sens:=2;
                      5,6:sens:=4;
                      7,0:sens:=8;
                    end;
                    ByteS:=2*ByteS+sens;
                    result:=PointsEssais[index mod 8];
                    exit;
                  end;
              end;
          end;
        byteS:=0;
        result:=Point(-2,-2);
      end
    else
      begin
        byteS:=0;
        result:=Point(-2,-2);
      end;
  end;
{  procedure TraiteCommeContour(LePoint:TPoint;verif:boolean);
  begin
    AjoutePointContour(LePoint,LeContour);
    PointPrec:=LePoint;
//    Bitmaptrav[LePoint.x,LePoint.y]:=ClBlue32;
//    Bitmaptrav.Changed;
//    ShowMessage('Contour ('+IntToStr(LePoint.x)+','+IntToStr(LePoint.Y)+')');
    if verif then if PointEnDouble(LePoint) then AjoutePointContour(LePoint,PointsDoubles);
  end;
  procedure TraiteCommeInclusion(LePoint:TPoint;verif:boolean);
  var
    ntp:integer;
  begin
    AjoutePointContour(LePoint,CopiePointsTest);
//    Bitmaptrav[LePoint.x,LePoint.y]:=ClLime32;
//    Bitmaptrav.Changed;
//    ShowMessage('Inclusion ('+IntToStr(LePoint.x)+','+IntToStr(LePoint.Y)+')');
    DrInclusion:= Not DetacheBoucle(CopiePointsTest);
    if Length(CopiePointsTest)>0 then PointPrecI:=CopiePointsTest[Length(CopiePointsTest)-1]
    else PointPrecI:=Point(-2,-2);
    if verif then if PointEnDouble(LePoint) then
      begin
        ntp:=Length(MorceauxCommuns);
        if (ntp>0) and SontVoisins(UnPoint,MorceauxCommuns[ntp-1][Length(MorceauxCommuns[ntp-1])-1]) then
          AjoutePointContour(UnPoint,MorceauxCommuns[ntp-1])
        else
          begin
            SetLength(MorceauxCommuns,ntp+1);
            AjoutePointContour(UnPoint,MorceauxCommuns[ntp]);
          end;
      end;
  end;
  function DecideContour(LePoint,PointP,PointPI:TPoint):Boolean;
  var
    XXP,YYP,XXC,YYC,XXI,YYI:integer;
    ByteP,ByteC,ByteI:byte;
  begin
    XXP:=LePoint.X;
    YYP:=LePoint.Y;
    XXC:=PointP.x;
    YYC:=PointP.y;
    XXI:=PointPI.x;
    YYI:=PointP.y;
    ByteP:=(Bytemaptp.Value[XXP,YYP] and 120);
    ByteC:=(Bytemaptp.Value[XXC,YYC] and 120);
    ByteI:=(Bytemaptp.Value[XXI,YYI] and 120);
    if ByteP=ByteC then result:=true
    else if (ByteP=ByteI) or (ByteP=2*ByteI) or (ByteP=ByteI div 8) then result:=false
    else if ((ByteP=8) and (ByteC=32)) or((ByteC=64) and (ByteP=16)) or((ByteP=64) and (ByteC=16)) or ((ByteP=32) and (ByteC=8)) then result:=false
    else result:=True;
  end;}
begin
  w:=Bitmaptest.Width;
  h:=Bitmaptest.Height;
  nbcn:=Length(CopieCanaux);
  SetLength(ValCanaux,nbcn);
  if nbcn=0 then
    begin
      SetLength(ValCanaux,1);
      ValCanaux[0]:=0;
    end;
  SetLength(LeContour,0);
  SetLength(LesInclusions,0);
  SetLength(PointsTest,0);
  Bytemaptp.Value[X,Y]:=5;
  nombrepixels:=1;
  SetLength(CopiePointsTest,1);
  CopiePointsTest[0]:=Point(X,Y);
  BitMapTrav[x,y]:=CoulSurf;
  nouveauxpoints:=true;
  Xmaxi:=0;
  Xmini:=w;
  Ymaxi:=0;
  Ymini:=h;
  while (nouveauxpoints=true) and (Length(CopiePointsTest)<32000) do
    begin
      nouveauxpoints:=false;
      for i:=0 to Length(CopiePointsTest)-1 do
        begin
          XP:=CopiePointsTest[i].X;
          YP:=CopiePointsTest[i].Y;
          LeByte:=ByteMapTp.Value[XP,YP];
          ajoute:=false;
          if (LeByte and 120)>0 then   //point frontire
            begin
              Xt:=XP;  //recopie le point
              Yt:=YP;
              AjoutePoint;
            end
          else
            begin
              if (LeByte=5) then  // cas du premier point
                begin
                  TesteOuest;
                  TesteNord;
                  TesteEst;
                  TesteSud;
                end
              else if (LeByte=1) then //tester S,O,N
                begin
                  TesteSud;
                  TesteOuest;
                  TesteNord;
//coloreBitmap;
                end
              else if (LeByte=2) then //tester O,N,E
                begin
                  TesteOuest;
                  TesteNord;
                  TesteEst;
//coloreBitmap;
                end
              else if (LeByte=3) then //tester N,E,S
                begin
                  TesteNord;
                  TesteEst;
                  TesteSud;
//coloreBitmap;
                end
              else if (LeByte=4) then //tester E,S,O
                begin
                  TesteEst;
                  TesteSud;
                  TesteOuest;
//coloreBitmap;
                end;
            end;
        end;
      if nouveauxpoints then
        begin
          SetLength(CopiePointsTest,Length(PointsTest));
          for i:=0 to Length(PointsTest)-1 do
            begin
              CopiePointsTest[i]:=PointsTest[i];
            end;
          SetLength(PointsTest,0);
        end
      else SetLength(CopiePointsTest,0);
    end;
    if Length(CopiePointsTest)>0 then
      begin
        ShowMessage('C''est trop compliqu ! J''abandonne');
        exit;
      end;
  // **** sparation de la ligne de contour externe****
  nombretraces:=0;
  nbpts:=Length(PointsTest);
  if nbpts>0 then
    begin
      SetLength(LesContours,0);      //initialisations des variables
      SetLength(LeContour,0);
      DeltaXContour:=0;
      DeltaYContour:=0;
      //SetLength(MorceauxCommuns,0);
      LargeurContour:=Xmaxi-Xmini+1;
      HauteurContour:=Ymaxi-Ymini+1;
      ideb:=RechercheIndexMiniX(Xmini,PointsTest); //Recherche du premier point d'abscisse minimale
      AjoutePointContour(PointsTest[ideb],LeContour);
      PointPrec:=PointsTest[ideb];
      PremPoint:=PointPrec;
      ByteS:=0;
      ByteP:=(Bytemaptp.Value[PremPoint.X,PremPoint.Y]and 120)*2+1;
      UnPoint:=PointContourSuivant(ByteP,PremPoint,ByteS);
      if ByteS=0 then UnPoint:=PremPoint
      else
        begin
          AjoutePointContour(UnPoint,LeContour);
          PointPrec:=UnPoint;
          ByteP:=ByteS;
        end;
      PointPrecI:=Point(-2,-2);
      //DrContour:=True;
      //DrInclusion:=False;
      //SetLength(PointsDoubles,0);
      i:=2;
      While PointDifferent(UnPoint,PremPoint)and (i<30000) do
        begin
          inc(i);
          UnPoint:=PointContourSuivant(ByteP,PointPrec,ByteS);
          if ByteS>0 then
            begin
              AjoutePointContour(UnPoint,LeContour);
              PointPrec:=UnPoint;
              ByteP:=ByteS;
            end
          else
            begin
              ShowMessage('Perte du contour');
              break;
            end;
        end;
      NombreDePoints:=i;
{ amorce  complter pour le contour des inclusions
      jdeb:=0;
      For i:=0 to Length(PointsTest)-1 do
        begin
          k:=-1;
          For j:=jdeb to length(LeContour)-1 do
            begin
              if PointsTest[i]=LeContour[j] then
                begin
                  k=j;
                  if j=jdeb then inc(jdeb);
                  break;
                end;
              if k=-1 then AjoutePointContour(CopiePointsTest);
            end;
        end;
      While (Length(CopiePointsTest)>0) and (nombretraces<10000) do
        begin
          SetLength(LesInclusions,nombretraces+1);
          //copier CopiePointsTest dans Pointstest
          jdeb:=0;
          For i:=0 to Length(PointsTest)-1 do
            begin
              k:=-1;
              For j:=jdeb to length(LesInclusions[nombretraces])-1 do
                begin
                  if PointsTest[i]=LesInclusions[nombretraces][j] then
                    begin
                      k=j;
                      if j=jdeb then inc(jdeb);
                      break;
                    end;
                  if k=-1 then AjoutePointContour(CopiePointsTest);
                end;
            end;
          if Length(LesInclusions[nombretraces])>3 then inc(nombretraces);
          else SetLength(LesInclusions,nombretraces);
        end;
    end;}

SetLength(PointsTest,0);
{      nombretraces:=Length(LesInclusions);
for i:=0 to Length(LesInclusions)-1 do
  begin
    n:=Length(LesInclusions[i]);
    if n>0 then DessinePolyTPoint(clyellow32,LesInclusions[i],Bitmaptrav);
    Bitmaptrav.changed;
//    ShowMessage('Inclusion '+IntToStr(i)+' - P1=('+IntToStr(LesInclusions[i][0].X)+','+IntToStr(LesInclusions[i][0].Y)
//            +') -P'+intToStr(n)+'=('+IntToStr(LesInclusions[i][n-1].X)+','+IntToStr(LesInclusions[i][n-1].Y)+')');
  end;
//  ShowMessage('Le reste');
  DessinePolyTPoint(cllime32,CopiePointsTest,Bitmaptrav);
  Bitmaptrav.changed;
    DessinePolyTPoint(clblue32,LeContour,Bitmaptrav);
    Bitmaptrav.changed;
    n:=Length(LeContour);
//    ShowMessage('Contour - P1=('+IntToStr(LeContour[0].X)+','+IntToStr(LeContour[0].Y)
//            +') -P'+intToStr(n)+'=('+IntToStr(LeContour[n-1].X)+','+IntToStr(LeContour[n-1].Y)+')');}
//exit;
  Result:=nombrepixels;
end;
{portion de methode "suivez le fil" abandonne
      for i:=ideb+1 to ideb+nbpts-1 do
        begin
          UnPoint:=PointsTest[i mod nbpts];
          trouve:=false;
          PointPrec:=LeContour[Length(LeContour)-1];
          if Length(CopiePointsTest)>0 then PointPrecI:=CopiePointsTest[Length(CopiePointsTest)-1]
          else PointPrecI:=Point(-2,-2);
          DrContour:=SuitLeFil(PointPrec,UnPoint,LeByte);
          DrInclusion:=SuitLeFil(PointPrecI,UnPoint,LeByte);
          if DrContour and DrInclusion then
            begin
              TraiteCommeContour(UnPoint,False);
              TraiteCommeInclusion(UnPoint,False);
            end
          else if DrContour then
            TraiteCommeContour(UnPoint,true)
          else if DrInclusion then
            TraiteCommeInclusion(UnPoint,true)
          else
            begin
              if ChercheComplementEff(UnPoint,LeContour,PointsDoubles) then
                PointPrec:=LeContour[Length(LeContour)-1];
              if SuitLeFil(PointPrec,UnPoint,LeByte) then TraiteCommeContour(UnPoint,true)
              else TraiteCommeInclusion(UnPoint,true);
            end;
        end;}
{troisime version d'essai
procedure LigneContour(X,Y:integer;PolyConditions:TTableaudeTableaudeCondicoul;BytemapTp:TBytemap;Bitmaptest,Bitmaptrav:TBitmap32;var nombretraces:integer);
const
  nombrelimite=1;
var
  NumOuverts:Array of integer;
  pt:integer;
  i,ii,j,jj,k,kk,n,n2,n3,w,h,nbp,espace:integer;
  trouve:boolean;
  EnDouble:boolean;
  ApresBoucleIncl:Boolean;
  ApresBoucleCont:Boolean;
  ApresPointe:Boolean;
  PointsTest:TArrayOfPoint;
  CopiePointsTest:TArrayOfPoint;
  UnPoint:TPoint;
  Xp,Yp:integer;
  Xt,Yt:integer;
  Xprec,Yprec:integer;
  XDprec,YDprec:integer;
  jd:integer;
  Xprem,Yprem:integer;
  nouveauxpoints:boolean;
  LeByte:Byte;
  ajoute:boolean;
  valeur:integer;
  nombrecontours:integer;
  LesContours:TArrayOfArrayofPoint;
  XPointDeb,YpointDeb,XPointFin,YpointFin:integer;
  Xmaxi,Xmini,Ymaxi,Ymini:integer;
  deltaX,deltaY,deltaXContour,deltaYContour:integer;
  LaBoucle:TArrayOfPoint;
  MorceauxCommuns:TArrayOfArrayofPoint;
  erreurtrigo:boolean;
  tunnel:boolean;
  sortietunnel:boolean;
  function testeboucletrigo(Boucle:TArrayOfPoint;out DX,DY:integer;erreur:boolean):boolean;
  var
    i,iXmin,iXmax,iYmin,iYmax,isuiv,iprec,n,Xmin,Xmax,Ymin,Ymax,YRef:integer;
    arefaire:boolean;
  begin
   result:=false;
   erreur:=false;
   n:=Length(Boucle);
   if (n<3) or (abs(Boucle[0].X-Boucle[n-1].X)>1) or (abs(Boucle[0].Y-Boucle[n-1].Y)>1) then
     begin
       erreur:=True;
       exit;
     end;
   iXmin:=0;
   Xmin:=65535;
   iXmax:=0;
   Xmax:=0;
   iYmin:=0;
   Ymin:=65535;
   iYmax:=0;
   Ymax:=0;
   for i:=0 to n-1 do
     begin
       if Boucle[i].X<Xmin then
         begin
           iXmin:=i;
           Xmin:=Boucle[i].X;
         end;
       if Boucle[i].X>Xmax then
         begin
           iXmax:=i;
           Xmax:=Boucle[i].X;
         end;
       if Boucle[i].Y<Ymin then
         begin
           iYmin:=i;
           Ymin:=Boucle[i].Y;
         end;
       if Boucle[i].Y>Ymax then
         begin
           iYmax:=i;
           Ymax:=Boucle[i].Y;
         end;
     end;
   dX:=(Xmax-Xmin);
   dY:=(Ymax-Ymin);
   if (dX<2)  or (dY<2)  then
     begin
       erreur:=True;
       exit;
     end;
     Yref:=Boucle[iXmin].Y;
     isuiv:=(iXmin+1) mod n;
     iprec:=(iXmin-1);
     if iprec<0 then iprec:=n-1;
     arefaire:=True;
     While arefaire=True do
       begin
         if (Yref-Boucle[isuiv].Y)>0 then
           begin
             if (Yref-Boucle[iprec].Y)<=0 then exit
             else if (Boucle[iprec].X)>(Boucle[isuiv].X) then exit
             else if (Boucle[iprec].X)<(Boucle[isuiv].X) then
               begin
                 Result:=True;
                 Exit;
               end
             else if (Boucle[iprec].X)>(Boucle[isuiv].X) then exit
             else   // prcdent et suivant identiques
               begin
                 if ((isuiv-iXmin)> (n div 2)) or ((iXmin-iprec)> (n div 2)) then
                   begin
                     erreur:=true;
                     exit;
                   end;
                 isuiv:=(isuiv +1) mod n;
                 dec(iprec);
                 if iprec<0 then iprec:=n-1;
                 arefaire:=true;
               end;
           end
         else if (Yref-Boucle[isuiv].Y)<0 then
           begin
             if (Yref-Boucle[iprec].Y)>=0 then
               begin
                 Result:=True;
                 exit;
               end
             else if (Boucle[iprec].X)<(Boucle[isuiv].X) then exit
             else if (Boucle[iprec].X)>(Boucle[isuiv].X) then
               begin
                 Result:=True;
                 exit;
               end
             else  // prcdent et suivant identiques
               begin
                 if ((isuiv-iXmin)> (n div 2)) or ((iXmin-iprec)> (n div 2)) then
                   begin
                     erreur:=true;
                     exit;
                   end;
                 isuiv:=(isuiv +1) mod n;
                 dec(iprec);
                 if iprec<0 then iprec:=n-1;
                 arefaire:=true;
               end;
           end
         else // cas d'galit;
           begin
             if ((isuiv-iXmin)> (n div 2)) or ((iXmin-iprec)> (n div 2)) then
               begin
                 erreur:=true;
                 exit;
               end;
             isuiv:=(isuiv +1) mod n;
             dec(iprec);
             if iprec<0 then iprec:=n-1;
             arefaire:=true;
           end;
       end;
  end;
  procedure ChercheSiContour(nbinc:integer;var Boucle:TArrayOfPoint);
  var
    UneBoucle:TArrayOfPoint;
    i:integer;
  begin
    erreurtrigo:=false;
    if not testeboucletrigo(Boucle,DeltaX,DeltaY,erreurtrigo) then
      begin
      if not erreurtrigo then
        begin
          if (DeltaXContour<deltaX) and (DeltaXContour<deltaY) then
            begin
              DeltaXContour:=deltaX;
              DeltaYContour:=deltaY;
              if Length(LeContour)>0 then
                begin
                  ShowMessage('Attention ! Deuxime contour externe '+IntToStr(Length(Boucle)+1)+' points');
                  SetLength(UneBoucle,Length(LeContour));
                  for i:=0 to Length(LeContour)-1 do UneBoucle[i]:=LeContour[i];
                  SetLength(LeContour,Length(Boucle));
                  for i:=0 to Length(Boucle)-1 do LeContour[i]:=Boucle[i];
                  SetLength(Boucle,Length(UneBoucle));
                  for i:=0 to Length(Boucle)-1 do Boucle[i]:=UneBoucle[i];
                  SetLength(UneBoucle,0);
               end
             else
               begin
                  SetLength(LeContour,Length(Boucle));
                  for i:=0 to Length(Boucle)-1 do LeContour[i]:=Boucle[i];
                  SetLength(LesInclusions,nbinc);
               end;
            end;
        end;
      end
    else if (DeltaXContour<deltaX) and (DeltaXContour<deltaY) then
      begin
        DeltaXContour:=deltaX;
        DeltaYContour:=deltaY;
      end;
  end;
  procedure AjoutePointContour(LePoint:Tpoint;var LeTrace:TArrayOfPoint);
  var
    long:integer;
  begin
    long:=Length(LeTrace);
    SetLength(LeTrace,long+1);
    LeTrace[long]:=LePoint;
  end;
  procedure AjoutePoint;
  begin
    n:=Length(PointsTest);
    SetLength(PointsTest,n+1);
    PointsTest[n].X:=Xt;
    PointsTest[n].Y:=Yt;
  end;
  function testepointcommun:boolean;
  var
    UnByte:byte;
    itp,ntp:integer;
  begin
    if (Xt>-1) and (Yt>-1) then UnByte:=(Bytemaptp.Value[Xt,Yt] and 120)
    else UnByte:=0;
    if (UnByte=56) or (UnByte=88) or (UnByte=104)or (UnByte=112) then //pointe
      begin
        if (XDprec>=0) and (YDprec>=0) and (jD>-1) and (abs(XDprec-Xt)<2) and (abs(YDprec-Yt)<2) then
          begin
            Result:=True;
            ntp:=Length(MorceauxCommuns[jD]);
            AjoutePointContour(PointsTest[i],MorceauxCommuns[jD]);
            for itp:=ntp-1 downto 0 do AjoutePointContour(MorceauxCommuns[jD][itp],MorceauxCommuns[jD]);
            jD:=-1;
          end
        else Result:=False;
      end
    else if (UnByte=80) or (UnByte=40) then    //points communs
      begin
        result:=True;
        if (XDprec<0) or (YDprec<0) or (jD=-1) or (abs(XDprec-Xt)>1)or (abs(YDprec-Yt)>1) then
          begin
            jD:=Length(MorceauxCommuns);
            SetLength(MorceauxCommuns,jD+1);
          end;
        AjoutePointContour(PointsTest[i],MorceauxCommuns[jD]);
        Bitmaptrav[Xt,Yt]:=Clwhite32;
        XDprec:=Xt;
        YDprec:=Yt;
      end
    else
      begin
        Result:=False;
      end;
  end;
  function testepoint:boolean;
  begin
    if Bytemaptp.Value[Xt,Yt]=6 then
      begin
        Result:=False;
        exit;
      end;
    Result:=TestePolyCondicoul(BitmapTest[Xt,Yt],[0],Polyconditions);
    if Result then
      begin
        if Bytemaptp.Value[Xt,Yt]=0 then
          begin
            Bytemaptp.Value[Xt,Yt]:=valeur;
            nouveauxPoints:=True;
            AjoutePoint;
          end;
      end
    else
      begin
        Bytemaptp.Value[Xt,Yt]:=6;
        Bitmaptrav[Xt,Yt]:=ClRed32;
      end;
  end;
  procedure coloreBitmap;
  var
    Unbyte:byte;
  begin
    Unbyte:=(Bytemaptp.Value[XP,YP] and 120);
    if UnByte=0 then exit;
    case UnByte of
      8,16,32,64:Bitmaptrav[XP,YP]:=clLime32;
      40,80:Bitmaptrav[XP,YP]:=clAqua32;
      24,96,72,48:Bitmaptrav[XP,YP]:=clfuchsia32;
      else Bitmaptrav[XP,YP]:=clblack32;
    end;
  end;
  procedure testeSud;
  begin
    Xt:=XP;
    Yt:=YP+1;
    valeur:=4;
    if (Yt<h) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 64;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 64;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  procedure testeOuest;
  begin
    Xt:=XP-1;
    Yt:=YP;
    valeur:=1;
    if (Xt>=0) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 8;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 8;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  procedure testeNord;
  begin
    Xt:=XP;
    Yt:=YP-1;
    valeur:=2;
    if (Yt>=0) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 16;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 16;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  procedure testeEst;
  begin
    Xt:=XP+1;
    Yt:=YP;
    valeur:=3;
    if (Xt<w) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 32;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=Bytemaptp.Value[XP,YP] or 32;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
begin
  w:=Bitmaptest.Width;
  h:=Bitmaptest.Height;
  SetLength(LeContour,0);
  SetLength(LesInclusions,0);
  SetLength(PointsTest,0);
  Bytemaptp.Value[X,Y]:=5;
  SetLength(CopiePointsTest,1);
  CopiePointsTest[0]:=Point(X,Y);
  nouveauxpoints:=true;
  while nouveauxpoints=true do
    begin
      nouveauxpoints:=false;
      for i:=0 to Length(CopiePointsTest)-1 do
        begin
          XP:=CopiePointsTest[i].X;
          YP:=CopiePointsTest[i].Y;
          LeByte:=ByteMapTp.Value[XP,YP];
          ajoute:=false;
          if (LeByte and 120)>0 then   //point frontire
            begin
              Xt:=XP;  //recopie le point
              Yt:=YP;
              AjoutePoint;
            end
          else
            begin
              if (LeByte=5) then  // cas du premier point
                begin
                  TesteOuest;
                  TesteNord;
                  TesteEst;
                  TesteSud;
                end
              else if (LeByte=1) then //tester S,O,N
                begin
                  TesteSud;
                  TesteOuest;
                  TesteNord;
coloreBitmap;
                end
              else if (LeByte=2) then //tester O,N,E
                begin
                  TesteOuest;
                  TesteNord;
                  TesteEst;
coloreBitmap;
                end
              else if (LeByte=3) then //tester N,E,S
                begin
                  TesteNord;
                  TesteEst;
                  TesteSud;
coloreBitmap;
                end
              else if (LeByte=4) then //tester E,S,O
                begin
                  TesteEst;
                  TesteSud;
                  TesteOuest;
coloreBitmap;
                end;
            end;
        end;
      if nouveauxpoints then
        begin
          SetLength(CopiePointsTest,Length(PointsTest));
          for i:=0 to Length(PointsTest)-1 do
            begin
              CopiePointsTest[i]:=PointsTest[i];
            end;
          SetLength(PointsTest,0);
        end
      else SetLength(CopiePointsTest,0);
    end;
//DessinePolyligne(clblue32,PointsTest,Bitmaptrav);
//exit;
  // **** sparation des lignes de contour ****
  nombretraces:=0;
  if Length(PointsTest)>0 then
    begin
      SetLength(LesContours,1);
      j:=0;
      jD:=0;
      SetLength(LesContours[0],1);
      LesContours[0][0]:=PointsTest[0];
      DeltaXContour:=0;
      DeltaYContour:=0;
      Xprec:=PointsTest[0].X;
      Yprec:=PointsTest[0].Y;
      XDprec:=-2;
      YDprec:=-2;
      SetLength(MorceauxCommuns,0);

      for i:=1 to Length(PointsTest)-1 do
        begin
          Xt:=PointsTest[i].X;// point  tester
          Yt:=PointsTest[i].Y;
          n:=Length(LesContours[j])-1;


          trouve:=false;
      EnDouble:=testepointcommun; // recherche si c'est un point en double
      if not EnDouble then   // *** recherche de boucle ***
        begin
          if (Xprec>-1) and (Yprec>-1) and (n>2) and (abs(Xprec-LesContours[j][0].X)<2) and (abs(Yprec-LesContours[j][0].Y)<2) then
            begin
              jj:=Length(LesInclusions);
              SetLength(LesInclusions,jj+1);
              Xmini:=65535;
              Xmaxi:=0;
              Ymini:=65535;
              Ymaxi:=0;
              for ii:=0 to n do     // vrification de largeur
                begin
                  if Xmini>LesContours[j][ii].X then Xmini:=LesContours[j][ii].X;
                  if Xmaxi<LesContours[j][ii].X then Xmaxi:=LesContours[j][ii].X;
                  if Ymini>LesContours[j][ii].Y then Ymini:=LesContours[j][ii].Y;
                  if Ymaxi<LesContours[j][ii].Y then Ymaxi:=LesContours[j][ii].Y;
                  AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
                end;
                if (Xmaxi>Xmini+1) and (Ymaxi>Ymini+1) then
                  begin
                    SetLength(LesContours[j],0);
                    ChercheSiContour(jj,LesInclusions[jj]);
                    trouve:=True;
                  end
                else SetLength(LesInclusions,jj);
            end;

          if (abs(Xt-Xprec)>1) or (abs(Yt-Yprec)>1) then    // en cas de rupture de continuit
            begin
              if not trouve then
                begin
                  jj:=-1;
                  jD:=-1;
                  for k:=0 to Length(LesContours)-1 do  // recherche dans les morceaux amorcs
                    begin
                      if k<>j then
                        begin
                          n2:=Length(LesContours[k]);
                          if (n2>0) and (abs(Xt-LesContours[k][n2-1].X)<2)
                            and (abs(Yt-LesContours[k][Length(LesContours[k])-1].Y)<2) then
                            begin
                              jj:=k;
                              break;
                            end;
                        end;
                    end;
                  if jj>-1 then  j:=jj
                  else
                    begin
                      j:=Length(LesContours);
                      SetLength(LesContours,j+1);
                    end;
{                  if jj=-1 then   //sinon
                    begin
                      kk:=-1;
                      for k:=Length(MorceauxCommuns)-1 downto 0 do  // recherche dans les morceaux communs
                        begin
                          n2:=Length(MorceauxCommuns[k]);
                          if (n2>0) and (Xprec>0) and (Yprec>0) and (abs(Xt-MorceauxCommuns[k][0].X)<2) and (abs(Yt-MorceauxCommuns[k][0].Y)<2)
                              and (abs(Xprec-MorceauxCommuns[k][n2-1].X)<2) and (abs(Yprec-MorceauxCommuns[k][n2-1].Y)<2) then
                            begin
                              kk:=k;
                              break;
                            end;
                        end;
                      if kk>-1 then  // si trouv
                        begin
                          for k:=n2-1 downto 0 do AjoutePointContour(MorceauxCommuns[kk][k],LesContours[j]);
                          //SetLength(MorceauxCommuns[kk],0);
                          jD:=-1;
                        end
                      else
                        begin
                          j:=Length(LesContours);
                          SetLength(LesContours,j+1);
                        end;
                    end
                  else j:=jj;//
                end;
            end;
          AjoutePointContour(PointsTest[i],LesContours[j]);
          Xprec:=PointsTest[i].X;
          Yprec:=PointsTest[i].Y;
        end;
        end;
      SetLength(PointsTest,0);
      nombretraces:=0;
{for i:=0 to Length(LesContours)-1 do
begin
  n:=Length(LesContours[i]);
  if n>0 then
    begin
    DessinePolyTPoint(clfuchsia32,LesContours[i],Bitmaptrav);
    Bitmaptrav.changed;
    ShowMessage('LesContours '+intToStr(i)+' - P1=('+IntToStr(LesContours[i][0].X)+','+IntToStr(LesContours[i][0].Y)
            +') -P'+intToStr(n)+'=('+IntToStr(LesContours[i][n-1].X)+','+IntToStr(LesContours[i][n-1].Y)+')');
    end;
end;
for i:=0 to Length(LesInclusions)-1 do
  if Length(LesInclusions[i])>0 then DessinePolyTPoint(clyellow32,LesInclusions[i],Bitmaptrav);
for i:=0 to Length(MorceauxCommuns)-1 do
  if Length(MorceauxCommuns[i])>0 then DessinePolyTPoint(clmaroon32,MorceauxCommuns[i],Bitmaptrav);
exit;//
      //**** vrification des contours ****
       for j:=0 to Length(LesContours)-1 do
        begin
          n:=Length(LesContours[j]);
          if (n>0) and((n<4) or (abs(LesContours[j][0].X-LesContours[j][n-1].X)>1)
            or (abs(LesContours[j][0].Y-LesContours[j][n-1].Y)>1)) then
              begin  // dtection et premier traitement des tracs ouverts
                trouve:=false;
                for i:=0 to Length(MorceauxCommuns)-1 do
                  begin
                    n2:=Length(MorceauxCommuns[i]);
                    if (n2>0)and(abs(LesContours[j][0].X-MorceauxCommuns[i][0].X)<2)
                      and (abs(LesContours[j][0].Y-MorceauxCommuns[i][0].Y)<2) then
                        begin
                          if (abs(LesContours[j][n-1].X-MorceauxCommuns[i][n2-1].X)<2)
                            and (abs(LesContours[j][n-1].Y-MorceauxCommuns[i][n2-1].Y)<2) then
                            begin  //l'ensemble est ferm construire la boucle et tester;
                              Xmini:=65535;
                              Xmaxi:=0;
                              Ymini:=65535;
                              Ymaxi:=0;
                              jj:=Length(LesInclusions);
                              SetLength(LesInclusions,jj+1);
                              for ii:=0 to n-1 do     // vrification de largeur
                                begin
                                  if Xmini>LesContours[j][ii].X then Xmini:=LesContours[j][ii].X;
                                  if Xmaxi<LesContours[j][ii].X then Xmaxi:=LesContours[j][ii].X;
                                  if Ymini>LesContours[j][ii].Y then Ymini:=LesContours[j][ii].Y;
                                  if Ymaxi<LesContours[j][ii].Y then Ymaxi:=LesContours[j][ii].Y;
                                  AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
                                end;
                              for ii:=n2-1 downto 0 do
                                begin
                                  if Xmini>MorceauxCommuns[i][ii].X then Xmini:=MorceauxCommuns[i][ii].X;
                                  if Xmaxi<MorceauxCommuns[i][ii].X then Xmaxi:=MorceauxCommuns[i][ii].X;
                                  if Ymini>MorceauxCommuns[i][ii].Y then Ymini:=MorceauxCommuns[i][ii].Y;
                                  if Ymaxi<MorceauxCommuns[i][ii].Y then Ymaxi:=MorceauxCommuns[i][ii].Y;
                                  AjoutePointContour(MorceauxCommuns[i][ii],LesInclusions[jj]);
                                end;
                              if (Xmaxi>Xmini+1) and (Ymaxi>Ymini+1) then
                                begin
                                  SetLength(LesContours[j],0);
                                  ChercheSiContour(jj,LesInclusions[jj]);
                                  //SetLength(MorceauxCommuns[i],0);
                                  trouve:=True;
                                  Break;
                                end
                              else SetLength(LesInclusions,jj);
                            end;
                        end
                      else if (n2>0)and(abs(LesContours[j][0].X-MorceauxCommuns[i][n2-1].X)<2)
                        and (abs(LesContours[j][0].Y-MorceauxCommuns[i][n2-1].Y)<2) then
                        begin
                          if (abs(LesContours[j][n-1].X-MorceauxCommuns[i][0].X)<2)
                            and (abs(LesContours[j][n-1].Y-MorceauxCommuns[i][0].Y)<2) then
                            begin  //l'ensemble est ferm construire la boucle et tester;
                              Xmini:=65535;
                              Xmaxi:=0;
                              Ymini:=65535;
                              Ymaxi:=0;
                              jj:=Length(LesInclusions);
                              SetLength(LesInclusions,jj+1);
                              for ii:=0 to n-1 do     // vrification de largeur
                                begin
                                  if Xmini>LesContours[j][ii].X then Xmini:=LesContours[j][ii].X;
                                  if Xmaxi<LesContours[j][ii].X then Xmaxi:=LesContours[j][ii].X;
                                  if Ymini>LesContours[j][ii].Y then Ymini:=LesContours[j][ii].Y;
                                  if Ymaxi<LesContours[j][ii].Y then Ymaxi:=LesContours[j][ii].Y;
                                  AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
                                end;
                              for ii:=0 to n2-1 do
                                begin
                                  if Xmini>MorceauxCommuns[i][ii].X then Xmini:=MorceauxCommuns[i][ii].X;
                                  if Xmaxi<MorceauxCommuns[i][ii].X then Xmaxi:=MorceauxCommuns[i][ii].X;
                                  if Ymini>MorceauxCommuns[i][ii].Y then Ymini:=MorceauxCommuns[i][ii].Y;
                                  if Ymaxi<MorceauxCommuns[i][ii].Y then Ymaxi:=MorceauxCommuns[i][ii].Y;
                                  AjoutePointContour(MorceauxCommuns[i][ii],LesInclusions[jj]);
                                end;
                              if (Xmaxi>Xmini+1) and (Ymaxi>Ymini+1) then
                                begin
                                  SetLength(LesContours[j],0);
                                  ChercheSiContour(jj,LesInclusions[jj]);
                                  //SetLength(MorceauxCommuns[i],0);
                                  trouve:=True;
                                  Break;
                                end
                              else SetLength(LesInclusions,jj);
                            end;
                        end;
                  end;
                if not trouve then
                  begin
                for i:=0 to Length(LesContours)-1 do
                  begin
                    n2:=Length(LesContours[i]);
                    if (n2>0)and(abs(LesContours[j][0].X-LesContours[i][n2-1].X)<2)
                      and (abs(LesContours[j][0].Y-LesContours[i][n2-1].Y)<2) then
                        begin
                          trouve:=true;
                          if (abs(LesContours[j][n-1].X-LesContours[i][0].X)<2)
                            and (abs(LesContours[j][n-1].Y-LesContours[i][0].Y)<2) then
                            begin  //l'ensemble est ferm construire la boucle et tester;
                              Xmini:=65535;
                              Xmaxi:=0;
                              Ymini:=65535;
                              Ymaxi:=0;
                              jj:=Length(LesInclusions);
                              SetLength(LesInclusions,jj+1);
                              for ii:=0 to n-1 do     // vrification de largeur
                                begin
                                  if Xmini>LesContours[j][ii].X then Xmini:=LesContours[j][ii].X;
                                  if Xmaxi<LesContours[j][ii].X then Xmaxi:=LesContours[j][ii].X;
                                  if Ymini>LesContours[j][ii].Y then Ymini:=LesContours[j][ii].Y;
                                  if Ymaxi<LesContours[j][ii].Y then Ymaxi:=LesContours[j][ii].Y;
                                  AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
                                end;
                              for ii:=0 to n2-1 do
                                begin
                                  if Xmini>LesContours[i][ii].X then Xmini:=LesContours[i][ii].X;
                                  if Xmaxi<LesContours[i][ii].X then Xmaxi:=LesContours[i][ii].X;
                                  if Ymini>LesContours[i][ii].Y then Ymini:=LesContours[i][ii].Y;
                                  if Ymaxi<LesContours[i][ii].Y then Ymaxi:=LesContours[i][ii].Y;
                                  AjoutePointContour(LesContours[i][ii],LesInclusions[jj]);
                                end;
                              if (Xmaxi>Xmini+1) and (Ymaxi>Ymini+1) then
                                begin
                                  SetLength(LesContours[j],0);
                                  ChercheSiContour(jj,LesInclusions[jj]);
                                  SetLength(LesContours[i],0);
                                  trouve:=True;
                                  Break;
                                end
                              else SetLength(LesInclusions,jj);
                            end
                          else
                            begin
                              for k:=0 to n-1 do AjoutePointContour(LesContours[j][k],LesContours[i]);
                              SetLength(LesContours[j],0);
                              break;
                            end;
                        end;
                  end;
                  end;
              end
          else if n>3 then  // contour ferm plus grand que 3
            begin
              jj:=Length(LesInclusions);
              SetLength(LesInclusions,jj+1);
              for ii:=0 to n-1 do AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
              SetLength(LesContours[j],0);
              ChercheSiContour(jj,LesInclusions[jj]);
            end;
        end;
   // traiter les cas qui restent en essayant de les complter avec les morceaux communs
       for j:=0 to Length(LesContours)-1 do
        begin
          n:=Length(LesContours[j]);
          trouve:=false;
          if n>0 then
            begin
                for i:=0 to Length(MorceauxCommuns)-1 do
                  begin
                    n2:=Length(MorceauxCommuns[i]);
                    if (n2>0)and(abs(LesContours[j][0].X-MorceauxCommuns[i][0].X)<2)
                      and (abs(LesContours[j][0].Y-MorceauxCommuns[i][0].Y)<2) then
                        begin
                          if (abs(LesContours[j][n-1].X-MorceauxCommuns[i][n2-1].X)<2)
                            and (abs(LesContours[j][n-1].Y-MorceauxCommuns[i][n2-1].Y)<2) then
                            begin  //l'ensemble est ferm construire la boucle et tester;
                              Xmini:=65535;
                              Xmaxi:=0;
                              Ymini:=65535;
                              Ymaxi:=0;
                              jj:=Length(LesInclusions);
                              SetLength(LesInclusions,jj+1);
                              for ii:=0 to n-1 do     // vrification de largeur
                                begin
                                  if Xmini>LesContours[j][ii].X then Xmini:=LesContours[j][ii].X;
                                  if Xmaxi<LesContours[j][ii].X then Xmaxi:=LesContours[j][ii].X;
                                  if Ymini>LesContours[j][ii].Y then Ymini:=LesContours[j][ii].Y;
                                  if Ymaxi<LesContours[j][ii].Y then Ymaxi:=LesContours[j][ii].Y;
                                  AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
                                end;
                              for ii:=n2-1 downto 0 do
                                begin
                                  if Xmini>MorceauxCommuns[i][ii].X then Xmini:=MorceauxCommuns[i][ii].X;
                                  if Xmaxi<MorceauxCommuns[i][ii].X then Xmaxi:=MorceauxCommuns[i][ii].X;
                                  if Ymini>MorceauxCommuns[i][ii].Y then Ymini:=MorceauxCommuns[i][ii].Y;
                                  if Ymaxi<MorceauxCommuns[i][ii].Y then Ymaxi:=MorceauxCommuns[i][ii].Y;
                                  AjoutePointContour(MorceauxCommuns[i][ii],LesInclusions[jj]);
                                end;
                              if (Xmaxi>Xmini+1) and (Ymaxi>Ymini+1) then
                                begin
                                  SetLength(LesContours[j],0);
                                  ChercheSiContour(jj,LesInclusions[jj]);
                                  //SetLength(MorceauxCommuns[i],0);
                                  trouve:=True;
                                  Break;
                                end
                              else SetLength(LesInclusions,jj);
                            end;
                        end
                      else if (n2>0)and(abs(LesContours[j][0].X-MorceauxCommuns[i][n2-1].X)<2)
                        and (abs(LesContours[j][0].Y-MorceauxCommuns[i][n2-1].Y)<2) then
                        begin
                          if (abs(LesContours[j][n-1].X-MorceauxCommuns[i][0].X)<2)
                            and (abs(LesContours[j][n-1].Y-MorceauxCommuns[i][0].Y)<2) then
                            begin  //l'ensemble est ferm construire la boucle et tester;
                              Xmini:=65535;
                              Xmaxi:=0;
                              Ymini:=65535;
                              Ymaxi:=0;
                              jj:=Length(LesInclusions);
                              SetLength(LesInclusions,jj+1);
                              for ii:=0 to n-1 do     // vrification de largeur
                                begin
                                  if Xmini>LesContours[j][ii].X then Xmini:=LesContours[j][ii].X;
                                  if Xmaxi<LesContours[j][ii].X then Xmaxi:=LesContours[j][ii].X;
                                  if Ymini>LesContours[j][ii].Y then Ymini:=LesContours[j][ii].Y;
                                  if Ymaxi<LesContours[j][ii].Y then Ymaxi:=LesContours[j][ii].Y;
                                  AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
                                end;
                              for ii:=0 to n2-1 do
                                begin
                                  if Xmini>MorceauxCommuns[i][ii].X then Xmini:=MorceauxCommuns[i][ii].X;
                                  if Xmaxi<MorceauxCommuns[i][ii].X then Xmaxi:=MorceauxCommuns[i][ii].X;
                                  if Ymini>MorceauxCommuns[i][ii].Y then Ymini:=MorceauxCommuns[i][ii].Y;
                                  if Ymaxi<MorceauxCommuns[i][ii].Y then Ymaxi:=MorceauxCommuns[i][ii].Y;
                                  AjoutePointContour(MorceauxCommuns[i][ii],LesInclusions[jj]);
                                end;
                              if (Xmaxi>Xmini+1) and (Ymaxi>Ymini+1) then
                                begin
                                  SetLength(LesContours[j],0);
                                  ChercheSiContour(jj,LesInclusions[jj]);
                                  //SetLength(MorceauxCommuns[i],0);
                                  trouve:=True;
                                  Break;
                                end
                              else SetLength(LesInclusions,jj);
                            end;
                        end;
                  end;
            end;
        end;
   {    for j:=0 to Length(LesContours)-1 do
        begin
          n:=Length(LesContours[j]);
          n2:=Length(MorceauxCommuns);
          if n>0 then
            begin
              XPointDeb:=LesContours[j][0].X;
              YpointDeb:=LesContours[j][0].Y;
              XPointFin:=LesContours[j][n-1].X;
              YpointFin:=LesContours[j][n-1].Y;
              for i:=0 to n2-1 do
                begin
                  n3:=Length(LesInclusions[i]);
                  trouve:=false;
                  k:=-1;
                  for ii:=n3-1 downto 0 do
                    if (abs(LesInclusions[i][ii].X-XPointDeb)<2)
                      and (abs(LesInclusions[i][ii].Y-YPointDeb)<2) then
                      begin
                        k:=ii;
                        break;
                      end;
                  if k>-1 then
                    begin
                      kk:=-1;
                      for ii:=k downto 0 do
                        if (abs(LesInclusions[i][ii].X-XPointFin)<2)
                          and (abs(LesInclusions[i][ii].Y-YPointFin)<2) then
                          begin
                            kk:=ii;
                            break;
                          end;
                      if kk>-1 then
                        begin
                          trouve:=true;
                          jj:=Length(LesInclusions);
                          SetLength(LesInclusions,jj+1);
                          for ii:=0 to n-1 do AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
                          for ii:=k downto kk do
                            begin
                              AjoutePointContour(LesInclusions[i][ii],LesInclusions[jj]);
                            end;
                          SetLength(LesContours[j],0);
                          ChercheSiContour(jj,LesInclusions[jj]);
                        end;
                    end;
                  if trouve then break;
                end;
            end;
        end;//
      if (Length(LeContour)=0) and (Length(LesContours)=1) then
        begin
          for ii:=0 to Length(LesContours[0])-1 do AjoutePointContour(LesContours[0][ii],LeContour);
        end
      else if (Length(LeContour)=0) and (Length(LesInclusions)=1) then
        begin
          for ii:=0 to Length(LesContours[0])-1 do AjoutePointContour(LesInclusions[0][ii],LeContour);
       end;
//      else
//        begin
       SetLength(LeReste,0);
          for j:=0 to Length(LesContours)-1 do   // ajouter sans traitement ceux qui restent
            begin
              n:=Length(LesContours[j]);
              if n>0 then
                begin
                  jj:=Length(LeReste);
                  SetLength(LeReste,jj+1);
                  for ii:=0 to n-1 do AjoutePointContour(LesContours[j][ii],LeReste[jj]);
                end;
            end;
//          end;
        //Nombretraces:=Length(LesInclusions);
        for j:=0 to Length(LesInclusions)-1 do  // comptage des tracs
          begin
            if Length(LesInclusions[j])>1then inc(nombretraces);
          end;
    end;
end;}
{// deuxime version d'essai
procedure LigneContour(X,Y:integer;PolyConditions:TTableaudeTableaudeCondicoul;BytemapTp:TBytemap;Bitmaptest,Bitmaptrav:TBitmap32;var nombretraces:integer);
const
  nombrelimite=1;
var
  NumOuverts:Array of integer;
  pt:integer;
  i,ii,j,jj,k,kk,n,n2,n3,w,h,nbp,espace:integer;
  trouve:boolean;
  ApresBoucleIncl:Boolean;
  ApresBoucleCont:Boolean;
  ApresPointe:Boolean;
  PointsTest:TArrayOfPoint;
  CopiePointsTest:TArrayOfPoint;
  UnPoint:TPoint;
  Xp,Yp:integer;
  Xt,Yt:integer;
  Xprec,Yprec:integer;
  Xprem,Yprem:integer;
  nouveauxpoints:boolean;
  LeByte:Byte;
  ajoute:boolean;
  valeur:integer;
  nombrecontours:integer;
  LesContours:TArrayOfArrayofPoint;
  XPointDeb,YpointDeb,XPointFin,YpointFin:integer;
  //Xmaxi,Xmini,Ymaxi,Ymini:integer;
  deltaX,deltaY,deltaXContour,deltaYContour:integer;
  LaBoucle:TArrayOfPoint;
  erreurtrigo:boolean;
  function testeboucletrigo(Boucle:TArrayOfPoint;out DX,DY:integer;erreur:boolean):boolean;
  var
    i,iXmin,iXmax,iYmin,iYmax,isuiv,iprec,n,Xmin,Xmax,Ymin,Ymax,YRef:integer;
    arefaire:boolean;
  begin
   result:=false;
   erreur:=false;
   n:=Length(Boucle);
   if (n<3) or (abs(Boucle[0].X-Boucle[n-1].X)>1) or (abs(Boucle[0].Y-Boucle[n-1].Y)>1) then
     begin
       erreur:=True;
       exit;
     end;
   iXmin:=0;
   Xmin:=65535;
   iXmax:=0;
   Xmax:=0;
   iYmin:=0;
   Ymin:=65535;
   iYmax:=0;
   Ymax:=0;
   for i:=0 to n-1 do
     begin
       if Boucle[i].X<Xmin then
         begin
           iXmin:=i;
           Xmin:=Boucle[i].X;
         end;
       if Boucle[i].X>Xmax then
         begin
           iXmax:=i;
           Xmax:=Boucle[i].X;
         end;
       if Boucle[i].Y<Ymin then
         begin
           iYmin:=i;
           Ymin:=Boucle[i].Y;
         end;
       if Boucle[i].Y>Ymax then
         begin
           iYmax:=i;
           Ymax:=Boucle[i].Y;
         end;
     end;
   dX:=(Xmax-Xmin);
   dY:=(Ymax-Ymin);
   if (dX<2)  or (dY<2)  then
     begin
       erreur:=True;
       exit;
     end;
     Yref:=Boucle[iXmin].Y;
     isuiv:=(iXmin+1) mod n;
     iprec:=(iXmin-1);
     if iprec<0 then iprec:=n-1;
     arefaire:=True;
     While arefaire=True do
       begin
         if (Yref-Boucle[isuiv].Y)>0 then
           begin
             if (Yref-Boucle[iprec].Y)<=0 then exit
             else if (Boucle[iprec].X)>(Boucle[isuiv].X) then exit
             else if (Boucle[iprec].X)<(Boucle[isuiv].X) then
               begin
                 Result:=True;
                 Exit;
               end
             else if (Boucle[iprec].X)>(Boucle[isuiv].X) then exit
             else   // prcdent et suivant identiques
               begin
                 if ((isuiv-iXmin)> (n div 2)) or ((iXmin-iprec)> (n div 2)) then
                   begin
                     erreur:=true;
                     exit;
                   end;
                 isuiv:=(isuiv +1) mod n;
                 dec(iprec);
                 if iprec<0 then iprec:=n-1;
                 arefaire:=true;
               end;
           end
         else if (Yref-Boucle[isuiv].Y)<0 then
           begin
             if (Yref-Boucle[iprec].Y)>=0 then
               begin
                 Result:=True;
                 exit;
               end
             else if (Boucle[iprec].X)<(Boucle[isuiv].X) then exit
             else if (Boucle[iprec].X)>(Boucle[isuiv].X) then
               begin
                 Result:=True;
                 exit;
               end
             else  // prcdent et suivant identiques
               begin
                 if ((isuiv-iXmin)> (n div 2)) or ((iXmin-iprec)> (n div 2)) then
                   begin
                     erreur:=true;
                     exit;
                   end;
                 isuiv:=(isuiv +1) mod n;
                 dec(iprec);
                 if iprec<0 then iprec:=n-1;
                 arefaire:=true;
               end;
           end
         else // cas d'galit;
           begin
             if ((isuiv-iXmin)> (n div 2)) or ((iXmin-iprec)> (n div 2)) then
               begin
                 erreur:=true;
                 exit;
               end;
             isuiv:=(isuiv +1) mod n;
             dec(iprec);
             if iprec<0 then iprec:=n-1;
             arefaire:=true;
           end;
       end;
  end;
  procedure ChercheSiContour(nbinc:integer;var Boucle:TArrayOfPoint);
  var
    UneBoucle:TArrayOfPoint;
    i:integer;
  begin
    erreurtrigo:=false;
    if not testeboucletrigo(Boucle,DeltaX,DeltaY,erreurtrigo) then
      begin
      if not erreurtrigo then
        begin
          if (DeltaXContour<deltaX) and (DeltaXContour<deltaY) then
            begin
              DeltaXContour:=deltaX;
              DeltaYContour:=deltaY;
              if Length(LeContour)>0 then
                begin
                  ShowMessage('Attention ! Deuxime contour externe '+IntToStr(Length(Boucle)+1)+' points');
                  SetLength(UneBoucle,Length(LeContour));
                  for i:=0 to Length(LeContour)-1 do UneBoucle[i]:=LeContour[i];
                  SetLength(LeContour,Length(Boucle));
                  for i:=0 to Length(Boucle)-1 do LeContour[i]:=Boucle[i];
                  SetLength(Boucle,Length(UneBoucle));
                  for i:=0 to Length(Boucle)-1 do Boucle[i]:=UneBoucle[i];
                  SetLength(UneBoucle,0);
               end
             else
               begin
                  SetLength(LeContour,Length(Boucle));
                  for i:=0 to Length(Boucle)-1 do LeContour[i]:=Boucle[i];
                  SetLength(LesInclusions,nbinc);
               end;
            end;
        end;
      end
    else if (DeltaXContour<deltaX) and (DeltaXContour<deltaY) then
      begin
        DeltaXContour:=deltaX;
        DeltaYContour:=deltaY;
      end;
  end;
  procedure AjoutePointContour(LePoint:Tpoint;var LeTrace:TArrayOfPoint);
  var
    long:integer;
  begin
    long:=Length(LeTrace);
    SetLength(LeTrace,long+1);
    LeTrace[long]:=LePoint;
  end;
  procedure AjoutePoint;
  begin
    n:=Length(PointsTest);
    SetLength(PointsTest,n+1);
    PointsTest[n].X:=Xt;
    PointsTest[n].Y:=Yt;
  end;
  function testepoint:boolean;
  begin
    if Bytemaptp.Value[Xt,Yt]=6 then
      begin
        Result:=False;
        exit;
      end;
    Result:=TestePolyCondicoul(BitmapTest[Xt,Yt],[0],Polyconditions);
    if Result then
      begin
        if Bytemaptp.Value[Xt,Yt]=0 then
          begin
            Bytemaptp.Value[Xt,Yt]:=valeur;
            nouveauxPoints:=True;
            AjoutePoint;
          end;
      end
    else
      begin
        Bytemaptp.Value[Xt,Yt]:=6;
        Bitmaptrav[Xt,Yt]:=ClRed32;
      end;
  end;
  procedure testeSud;
  begin
    Xt:=XP;
    Yt:=YP+1;
    valeur:=4;
    if (Yt<h) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=LeByte or 64;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=LeByte or 64;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  procedure testeOuest;
  begin
    Xt:=XP-1;
    Yt:=YP;
    valeur:=1;
    if (Xt>=0) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=LeByte or 8;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=LeByte or 8;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  procedure testeNord;
  begin
    Xt:=XP;
    Yt:=YP-1;
    valeur:=2;
    if (Yt>=0) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=LeByte or 16;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=LeByte or 16;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  procedure testeEst;
  begin
    Xt:=XP+1;
    Yt:=YP;
    valeur:=3;
    if (Xt<w) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=LeByte or 32;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=LeByte or 32;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
begin
  w:=Bitmaptest.Width;
  h:=Bitmaptest.Height;
  SetLength(LeContour,0);
  SetLength(LesInclusions,0);
  SetLength(PointsTest,0);
  Bytemaptp.Value[X,Y]:=5;
  SetLength(CopiePointsTest,1);
  CopiePointsTest[0]:=Point(X,Y);
  nouveauxpoints:=true;
  while nouveauxpoints=true do
    begin
      nouveauxpoints:=false;
      for i:=0 to Length(CopiePointsTest)-1 do
        begin
          XP:=CopiePointsTest[i].X;
          YP:=CopiePointsTest[i].Y;
          LeByte:=ByteMapTp.Value[XP,YP];
          ajoute:=false;
          if (LeByte and 120)>0 then   //point frontire
            begin
              Xt:=XP;  //recopie le point
              Yt:=YP;
              AjoutePoint;
            end
          else
            begin
              if (LeByte=5) then  // cas du premier point
                begin
                  TesteOuest;
                  TesteNord;
                  TesteEst;
                  TesteSud;
                end
              else if (LeByte=1) then //tester S,O,N
                begin
                  TesteSud;
                  TesteOuest;
                  TesteNord;
                end
              else if (LeByte=2) then //tester O,N,E
                begin
                  TesteOuest;
                  TesteNord;
                  TesteEst;
                end
              else if (LeByte=3) then //tester N,E,S
                begin
                  TesteNord;
                  TesteEst;
                  TesteSud;
                end
              else if (LeByte=4) then //tester E,S,O
                begin
                  TesteEst;
                  TesteSud;
                  TesteOuest;
                end;
            end;
        end;
      if nouveauxpoints then
        begin
          SetLength(CopiePointsTest,Length(PointsTest));
          for i:=0 to Length(PointsTest)-1 do
            begin
              CopiePointsTest[i]:=PointsTest[i];
            end;
          SetLength(PointsTest,0);
        end
      else SetLength(CopiePointsTest,0);
    end;

  // **** sparation des lignes de contour ****
  nombretraces:=0;
  if Length(PointsTest)>0 then
    begin
      SetLength(LesContours,1);
      j:=0;
      SetLength(LesContours[0],1);
      LesContours[0][0]:=PointsTest[0];
      DeltaXContour:=0;
      DeltaYContour:=0;
      Xprec:=PointsTest[0].X;
      Yprec:=PointsTest[0].Y;
      ApresBoucleIncl:=false;
      ApresBoucleCont:=false;
      for i:=1 to Length(PointsTest)-1 do
        begin
          Xt:=PointsTest[i].X;// point  tester
          Yt:=PointsTest[i].Y;
          n:=Length(LesContours[j])-1;
          Trouve:=false;
//          if (Bytemaptp[Xt,Yt] and 120)>0 then  // ce test est-il utile ?
//            begin
      // *** recherche de boucle ***
          if (not ApresPointe) then   //or ApresBoucleCont
            begin
              k:=-1;
              for ii:=n-2 downto 0 do
                begin
                  if (abs(Xt-LesContours[j][ii].X)<2) and (abs(Yt-LesContours[j][ii].Y)<2) then
                    begin
                      k:=ii;
                      break;
                    end;
                end;
              if k>-1 then
                begin
                  jj:=Length(LesInclusions);
                  SetLength(LesInclusions,jj+1);
                  for ii:=k to n do AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
                  AjoutePointContour(PointsTest[i],LesInclusions[jj]);
                  erreurtrigo:=false;
                  if testeboucletrigo(LesInclusions[jj],deltaX,deltaY,erreurtrigo) then
                    begin
                      ApresBoucleIncl:=True;
                      SetLength(LesContours[j],k);
                      if k>0 then
                        begin
                          Xprec:=LesContours[j][k-1].X;
                          Yprec:=LesContours[j][k-1].Y;
                        end
                      else
                        begin
                          Xprec:=-2;
                          Yprec:=-2;
                        end;
                      Trouve:=true;
                    end
                  else
                    begin
                      ApresBoucleCont:=True;
                      SetLength(LesInclusions,jj);
                    end;
                end;
            end;
          ApresPointe:=False;
{{          if (not Trouve) and ApresBoucleIncl and ((abs(Xt-Xprec)>1) or (abs(Yt-Yprec)>1))then
            begin
              n2:=Length(LesInclusions);
              if (n2>0) then jj:=Length(LesInclusions[n2-1]);
              if (n2>0) and (jj>0) then
                if (abs(Xt-LesInclusions[n2-1][jj-1].X)<2) and (abs(Yt-LesInclusions[n2-1][jj-1].Y)<2) then
                  begin
                          UnPoint.x:=Xt;
                          UnPoint.y:=Yt;
                          AjoutePointContour(UnPoint,LesInclusions[n2-1]);
                          trouve:=True;
                  end;
            end;}
{          if not Trouve then
            begin
              if (abs(Xt-Xprec)>1) or (abs(Yt-Yprec)>1) then    // en cas de rupture de continuit
                begin
                  trouve:=false;
                  // rechercher si c'est une pointe
                  if (Xprec>0) and (Yprec>0) then LeByte:=Bytemaptp[Xprec,Yprec]
                  else LeByte:=0;
                  if (LeByte=58) or (LeByte=89) or (LeByte=108)or (LeByte=115) then //pointe
                    begin
                      ApresPointe:=True;
                      for ii:=n-1 downto 0 do    // corriger si possible;
                        begin
                          AjoutePointContour(LesContours[j][ii],LesContours[j]);
                          if (abs(Xt-LesContours[j][ii].X)<2) and (abs(Yt-LesContours[j][ii].Y)<2) then
                            begin
                              trouve:=True;
                              break;
                            end;
                        end;
                    end;
                    if ApresBoucleCont then // si c'est une boucle du contour
                      begin
                      n2:=-1;
                      for ii:=k to n-2 do
                        begin
                          if (abs(Xprec-LesContours[j][ii].X)<2) and (abs(Yprec-LesContours[j][ii].Y)<2) then
                            begin
                              n2:=ii;
                              break;
                            end;
                        end;
                      if n2>-1 then
                        begin
                          for ii:=n2 downto k do AjoutePointContour(LesContours[j][ii],LesContours[j]);
                          Trouve:=True;
                        end;
                      end;
                  if not trouve then  //sinon sparer et chercher  raccorder
                    begin
                      ApresBoucleIncl:=false;
                      ApresBoucleCont:=false;
                      //ApresPointe:=false;
                      j:=-1;
                      for k:=0 to Length(LesContours)-1 do
                        if (Length(LesContours[k])>0) and (abs(Xt-LesContours[k][Length(LesContours[k])-1].X)<2)
                          and (abs(Yt-LesContours[k][Length(LesContours[k])-1].Y)<2) then
                            j:=k;
                      if j=-1 then
                        begin
                          j:=Length(LesContours);
                          SetLength(LesContours,j+1);
                        end;
                    end;
                end;
              ApresBoucleIncl:=false;
              ApresBoucleCont:=false;
              //ApresPointe:=False;
              AjoutePointContour(PointsTest[i],LesContours[j]);
              Xprec:=PointsTest[i].X;
              Yprec:=PointsTest[i].Y;
            //end
          //else ShowMessage('Erreur : point <>120 dans la liste');
            end;
        end;
      SetLength(PointsTest,0);
      nombretraces:=0;

      //**** vrification des contours ****
       for j:=0 to Length(LesContours)-1 do
        begin
          n:=Length(LesContours[j]);
          if (n>0) and((n<4) or (abs(LesContours[j][0].X-LesContours[j][n-1].X)>1)
            or (abs(LesContours[j][0].Y-LesContours[j][n-1].Y)>1)) then
              begin  // dtection et premier traitement des tracs ouverts
                trouve:=false;
                for i:=j+1 to Length(LesContours)-1 do
                  begin
                    n2:=Length(LesContours[i]);
                    if (n2>0)and(abs(LesContours[j][0].X-LesContours[i][n2-1].X)<2)
                      and (abs(LesContours[j][0].Y-LesContours[i][n2-1].Y)<2) then
                        begin
                          trouve:=true;
                          if (abs(LesContours[j][n-1].X-LesContours[i][0].X)<2)
                            and (abs(LesContours[j][n-1].Y-LesContours[i][0].Y)<2) then
                            begin  //l'ensemble est ferm construire la boucle et tester;
                              jj:=Length(LesInclusions);
                              SetLength(LesInclusions,jj+1);
                              for ii:=0 to n-1 do AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
                              for ii:=0 to n2-1 do AjoutePointContour(LesContours[i][ii],LesInclusions[jj]);
                              SetLength(LesContours[j],0);
                              SetLength(LesContours[i],0);
                              ChercheSiContour(jj,LesInclusions[jj]);
                              Break;
                            end
                          else for k:=0 to n-1 do AjoutePointContour(LesContours[j][k],LesContours[i]);
                          SetLength(LesContours[j],0);
                          break;
                        end;
                  end;
              end
          else if n>3 then  // contour ferm plus grand que 3
            begin
              jj:=Length(LesInclusions);
              SetLength(LesInclusions,jj+1);
              for ii:=0 to n-1 do AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
              SetLength(LesContours[j],0);
              ChercheSiContour(jj,LesInclusions[jj]);
            end;
        end;
   // traiter les cas qui restent en essayant de les complter avec des portions de boucles prises  l'envers
      for j:=0 to Length(LesContours)-1 do
        begin
          n:=Length(LesContours[j]);
          n2:=Length(LesInclusions);
          if n>0 then
            begin
              XPointDeb:=LesContours[j][0].X;
              YpointDeb:=LesContours[j][0].Y;
              XPointFin:=LesContours[j][n-1].X;
              YpointFin:=LesContours[j][n-1].Y;
              for i:=0 to n2-1 do
                begin
                  n3:=Length(LesInclusions[i]);
                  trouve:=false;
                  k:=-1;
                  for ii:=n3-1 downto 0 do
                    if (abs(LesInclusions[i][ii].X-XPointDeb)<2)
                      and (abs(LesInclusions[i][ii].Y-YPointDeb)<2) then
                      begin
                        k:=ii;
                        break;
                      end;
                  if k>-1 then
                    begin
                      kk:=-1;
                      for ii:=k downto 0 do
                        if (abs(LesInclusions[i][ii].X-XPointFin)<2)
                          and (abs(LesInclusions[i][ii].Y-YPointFin)<2) then
                          begin
                            kk:=ii;
                            break;
                          end;
                      if kk>-1 then
                        begin
                          trouve:=true;
                          jj:=Length(LesInclusions);
                          SetLength(LesInclusions,jj+1);
                          for ii:=0 to n-1 do AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
                          for ii:=k downto kk do
                            begin
                              AjoutePointContour(LesInclusions[i][ii],LesInclusions[jj]);
                            end;
                          SetLength(LesContours[j],0);
                          ChercheSiContour(jj,LesInclusions[jj]);
                        end;
                    end;
                  if trouve then break;
                end;
            end;
        end;
      if (Length(LeContour)=0) and (Length(LesContours)=1) then
        begin
          for ii:=0 to Length(LesContours[0])-1 do AjoutePointContour(LesContours[0][ii],LeContour);
        end
      else if (Length(LeContour)=0) and (Length(LesInclusions)=1) then
        begin
          for ii:=0 to Length(LesContours[0])-1 do AjoutePointContour(LesInclusions[0][ii],LeContour);
        end
      else
        begin
          for j:=0 to Length(LesContours)-1 do   // ajouter sans traitement ceux qui restent
            begin
              n:=Length(LesContours[j]);
              if n>0 then
                begin
                  jj:=Length(LesInclusions);
                  SetLength(LesInclusions,jj+1);
                  for ii:=0 to n-1 do AjoutePointContour(LesContours[j][ii],LesInclusions[jj]);
                end;
            end;
        //Nombretraces:=Length(LesInclusions);
          for j:=0 to Length(LesInclusions)-1 do  // comptage des tracs
            begin
              if Length(LesInclusions[j])>1 then inc(nombretraces);
            end;
        end;
    end;
end;}
// premire version d'essai
{procedure LigneContour(X,Y:integer;PolyConditions:TTableaudeTableaudeCondicoul;BytemapTp:TBytemap;Bitmaptest,Bitmaptrav:TBitmap32;var nombretraces:integer;out LesContours:TArrayOfArrayofPoint);
const
  nombrelimite=1;
var
  NumOuverts:Array of integer;
  pt:integer;
  i,ii,j,k,n,n2,w,h,nbp,espace:integer;
  trouve:boolean;
  PointsTest:TArrayOfPoint;
  CopiePointsTest:TArrayOfPoint;
  Xp,Yp:integer;
  Xt,Yt:integer;
  nouveauxpoints:boolean;
  LeByte:Byte;
  ajoute:boolean;
  valeur:integer;
  nombrecontours:integer;

  procedure AjoutePoint;
  begin
    n:=Length(PointsTest);
    SetLength(PointsTest,n+1);
    PointsTest[n].X:=Xt;
    PointsTest[n].Y:=Yt;
  end;
  function testepoint:boolean;
  begin
    if Bytemaptp.Value[Xt,Yt]=6 then
      begin
        Result:=False;
        exit;
      end;
    Result:=TestePolyCondicoul(BitmapTest[Xt,Yt],[0],Polyconditions);
    if Result then
      begin
        if Bytemaptp.Value[Xt,Yt]=0 then
          begin
            Bytemaptp.Value[Xt,Yt]:=valeur;
            nouveauxPoints:=True;
            AjoutePoint;
          end;
      end
    else
      begin
        Bytemaptp.Value[Xt,Yt]:=6;
        Bitmaptrav[Xt,Yt]:=ClRed32;
      end;
  end;
  procedure testeSud;
  begin
    Xt:=XP;
    Yt:=YP+1;
    valeur:=4;
    if (Yt<h) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=LeByte or 64;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=LeByte or 64;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  procedure testeOuest;
  begin
    Xt:=XP-1;
    Yt:=YP;
    valeur:=1;
    if (Xt>=0) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=LeByte or 8;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=LeByte or 8;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  procedure testeNord;
  begin
    Xt:=XP;
    Yt:=YP-1;
    valeur:=2;
    if (Yt>=0) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=LeByte or 16;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=LeByte or 16;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
  procedure testeEst;
  begin
    Xt:=XP+1;
    Yt:=YP;
    valeur:=3;
    if (Xt<w) then
      begin
        if (not testepoint) then
          begin
            Bytemaptp.Value[XP,YP]:=LeByte or 32;
            if not ajoute then
              begin
                Xt:=Xp;
                Yt:=Yp;
                AjoutePoint;
                ajoute:=true;
              end;
          end;
      end
    else
      begin
        Bytemaptp.Value[XP,YP]:=LeByte or 32;
        if not ajoute then
          begin
            Xt:=Xp;
            Yt:=Yp;
            AjoutePoint;
            ajoute:=true;
          end;
      end;
  end;
begin
  w:=Bitmaptest.Width;
  h:=Bitmaptest.Height;
  SetLength(PointsTest,0);
  Bytemaptp.Value[X,Y]:=5;
  SetLength(CopiePointsTest,1);
  CopiePointsTest[0]:=Point(X,Y);
  nouveauxpoints:=true;
  while nouveauxpoints=true do
    begin
      nouveauxpoints:=false;
      for i:=0 to Length(CopiePointsTest)-1 do
        begin
          XP:=CopiePointsTest[i].X;
          YP:=CopiePointsTest[i].Y;
          LeByte:=ByteMapTp.Value[XP,YP];
          ajoute:=false;
          if (LeByte and 120)>0 then   //point frontire
            begin
              Xt:=XP;  //recopie le point
              Yt:=YP;
              AjoutePoint;
            end
          else
            begin
              if (LeByte=5) then  // cas du premier point
                begin
                  TesteOuest;
                  TesteNord;
                  TesteEst;
                  TesteSud;
                end
              else if (LeByte=1) then //tester S,O,N
                begin
                  TesteSud;
                  TesteOuest;
                  TesteNord;
                end
              else if (LeByte=2) then //tester O,N,E
                begin
                  TesteOuest;
                  TesteNord;
                  TesteEst;
                end
              else if (LeByte=3) then //tester N,E,S
                begin
                  TesteNord;
                  TesteEst;
                  TesteSud;
                end
              else if (LeByte=4) then //tester E,S,O
                begin
                  TesteEst;
                  TesteSud;
                  TesteOuest;
                end;
            end;
        end;
      if nouveauxpoints then
        begin
          SetLength(CopiePointsTest,Length(PointsTest));
          for i:=0 to Length(PointsTest)-1 do
            begin
              CopiePointsTest[i]:=PointsTest[i];
            end;
          SetLength(PointsTest,0);
        end
      else SetLength(CopiePointsTest,0);
    end;
  nombretraces:=0;
  if Length(PointsTest)>0 then    // sparation des lignes de contour
    begin
      SetLength(LesContours,1);
      j:=0;
      SetLength(LesContours[0],1);
      LesContours[0][0]:=PointsTest[0];
      for i:=1 to Length(PointsTest)-1 do
        begin
          Xt:=PointsTest[i].X;
          Yt:=PointsTest[i].Y;
          if (Bytemaptp[Xt,Yt] and 120)>0 then
            begin
              if (abs(Xt-PointsTest[i-1].X)>1) or (abs(Yt-PointsTest[i-1].Y)>1) then
                begin
                  j:=-1;
                  for k:=0 to Length(LesContours)-1 do
                    if (abs(Xt-LesContours[k][Length(LesContours[k])-1].X)<2)
                      and (abs(Yt-LesContours[k][Length(LesContours[k])-1].Y)<2) then
                        j:=k;
                  if j=-1 then
                    begin
                      j:=Length(LesContours);
                      SetLength(LesContours,j+1);
                    end;
                end;
              n:=Length(LesContours[j]);
              SetLength(LesContours[j],n+1);
              LesContours[j][n]:=PointsTest[i];
            end
          else ShowMessage('erreur point<>120');
        end;
      SetLength(PointsTest,0);
      nombretraces:=0;
      // vrification des contours
      SetLength(NumOuverts,0);
      for j:=0 to Length(LesContours)-1 do
        begin
          n:=Length(LesContours[j]);
          if (n<3) or (abs(LesContours[j][0].X-LesContours[j][n-1].X)>1)
            or (abs(LesContours[j][0].Y-LesContours[j][n-1].Y)>1) then
              begin  // dtection et premier traitement des tracs ouverts
                trouve:=false;
                for i:=j+1 to Length(LesContours)-1 do
                  begin
                    n2:=Length(LesContours[i]);
                    if (abs(LesContours[j][0].X-LesContours[i][n2-1].X)<2)
                      and (abs(LesContours[j][0].Y-LesContours[i][n2-1].Y)<2) then
                        begin
                          trouve:=true;
                          for k:=0 to n-1 do
                            begin
                              n2:=Length(LesContours[i]);
                              SetLength(LesContours[i],n2+1);
                              LesContours[i][n2]:=LesContours[j][k];
                            end;
                          SetLength(LesContours[j],0);
                          break;
                        end;
                  end;
                if not trouve then
                  begin
                    n2:=Length(NumOuverts);
                    SetLength(NumOuverts,n2+1);
                    NumOuverts[n2]:=j;
                  end;
              end;
        end;
        // rechercher les boucles internes
        //si rotation sens trigo: sparer comme inclusion
    {  // rechercher  fermer les derniers contours ouverts
      for j:=0 to Length(NumOuverts)-1 do
        begin
          if NumOuverts[j]>-1 then
            begin
              trouve:=false;
              for k:=2 to 20 do
                begin
                  for i:=0 to Length(NumOuverts)-1 do
                    begin
                      if (NumOuverts[i]>-1)and (i<>j)  then if (Length(LesContours[NumOuverts[i]])>2*k)  then
                        begin
                          n2:=Length(LesContours[NumOuverts[i]]);
                          if (abs(LesContours[NumOuverts[j]][0].X-LesContours[NumOuverts[i]][n2-k].X)<2)
                             and (abs(LesContours[NumOuverts[j]][0].Y-LesContours[NumOuverts[i]][n2-k].Y)<2) then
                               begin
                                 SetLength(LesContours[NumOuverts[i]],n2+k-1);
                                 for ii:=0 to k-2 do
                                   LesContours[NumOuverts[i]][n2+ii]:=LesContours[NumOuverts[i]][n2-ii-2];
                                 n2:=Length(LesContours[NumOuverts[i]]);
                                 n:=Length(LesContours[NumOuverts[j]]);
                                 SetLength(LesContours[NumOuverts[i]],n2+n);
                                 for ii:=0 to n-1 do
                                     LesContours[NumOuverts[i]][n2+ii]:=LesContours[NumOuverts[j]][ii];
                                 trouve:=true;
                                 SetLength(LesContours[NumOuverts[j]],0);
                                 NumOuverts[j]:=-1;
                                 if (abs(LesContours[NumOuverts[i]][0].X-LesContours[NumOuverts[i]][n2+n-1].X)<2)
                                   and (abs(LesContours[NumOuverts[i]][0].Y-LesContours[NumOuverts[i]][n2+n-1].Y)<2) then
                                   NumOuverts[i]:=-1;
                                 break;
                               end;
                        end;
                    end;
                  if trouve then break;
                end;
            end;
        end;//

      for j:=0 to Length(LesContours)-1 do  // comptage des tracs
        begin
          if Length(LesContours[j])>nombrelimite then inc(nombretraces);
        end;
    end;}
end;
procedure MesureBoucle(Boucle:TArrayOfPoint;var largboucle,Longboucle,perimetre:single;out PointLongD,PointLongF,PointLarg1D,PointLarg1F,PointLarg2D,PointLarg2F:TPoint);
var
  i,j,ii,n,imax,jmax,maxiX,maxiY,miniX,MiniY,imaxX,imaxY,iminX,iminY:integer;
  maxi,mini,valeur:single;
  PointperpX,PointPerpY:single;
  dy,dx:integer;
  pente,CC,BB:single;
  largboucle1,largboucle2,l:single;
  ibc1,ibc2,Xbc1,Xbc2,Ybc1,Ybc2:integer;
  sensXC:boolean;
  function condition(Y1,Y2:real):boolean;
  begin
    if sensXC then result:=(Y1<Y2) else result:=(Y1>Y2);
  end;
  function carredistance(Point1,Point2:Tpoint):single;
  begin
    Result:=(Point2.x-Point1.x)*(Point2.x-Point1.x)+(Point2.y-Point1.y)*(Point2.y-Point1.y);
  end;
begin
  n:=Length(boucle);
  if n<3 then
    begin
      perimetre:=2;
      largboucle:=0;
      Longboucle:=1;
      exit;
    end;
  dec(n);
  maxi:=0;
  maxiX:=0;
  miniX:=65535;
  maxiY:=0;
  miniY:=65535;
  largBoucle1:=0;
  largBoucle2:=0;
  ibc1:=-1;
  ibc2:=-1;
  for i:=0 to n-1 do
    begin
      perimetre:=perimetre+sqrt(carredistance(Boucle[i],Boucle[(i+1)mod n]));
      if (Boucle[i].Y<MiniY) then
        begin
          MiniY:=Boucle[i].Y;
          iminY:=i;
        end;
      if (Boucle[i].Y>MaxiY) then
        begin
          MaxiY:=Boucle[i].Y;
          imaxY:=i;
        end;
      if (Boucle[i].X<MiniX) then
        begin
          MiniX:=Boucle[i].X;
          iminX:=i;
        end;
      if (Boucle[i].X>MaxiX) then
        begin
          MaxiX:=Boucle[i].X;
          imaxX:=i;
        end;
      for j:=i+1 to Length(Boucle)-1 do
        begin
          valeur:=carredistance(Boucle[i],Boucle[j]);
          if valeur>maxi then
            begin
              maxi:=valeur;
              imax:=i;
              jmax:=j;
            end;
        end;
    end;
  PointLongD:=Boucle[imax];
  PointLongF:=Boucle[jmax];
  dy:=(Boucle[jmax].y-Boucle[imax].y);
  dx:=(Boucle[jmax].x-Boucle[imax].x);
  if (dx<>0) and (dy<>0) then
    begin
      pente:=(Boucle[imax].x-Boucle[jmax].x)/dy;
      BB:=Boucle[imax].y+Boucle[imax].x/pente;
      sensXC:=(dx>0);
      for i:=imax+1 to jmax-1 do
        begin
          if Condition(Boucle[i].y,BB-Boucle[i].x/pente) then
            begin
              CC:=Boucle[i].y-pente*Boucle[i].x;
              PointperpX:=(bb-cc)/(pente+1/pente);
              PointperpY:=PointperpX*pente+CC;
              valeur:=(Boucle[i].x-PointperpX)*(Boucle[i].x-PointperpX)+(Boucle[i].y-PointperpY)*(Boucle[i].y-PointperpY);
              if largBoucle1<valeur then
                begin
                  largBoucle1:=valeur;
                  Xbc1:=Round(PointperpX);
                  Ybc1:=Round(PointperpY);
                  ibc1:=i;
                end;
            end;
        end;
      sensXC:=not sensXC;
      for ii:=jmax+1 to n+imax-2 do  //
        begin
          i:=ii mod n;
          if Condition(Boucle[i].y,BB-Boucle[i].x/pente) then
            begin
              CC:=Boucle[i].y-pente*Boucle[i].x;
              PointperpX:=(bb-cc)/(pente+1/pente);
              PointperpY:=PointperpX*pente+CC;
              valeur:=(Boucle[i].x-PointperpX)*(Boucle[i].x-PointperpX)+(Boucle[i].y-PointperpY)*(Boucle[i].y-PointperpY);
              if largBoucle2<valeur then
                begin
                  largBoucle2:=valeur;
                  Xbc2:=Round(PointperpX);
                  Ybc2:=Round(PointperpY);
                  ibc2:=i;
                end;
            end;
        end;
      if ibc1=-1 then
        begin
          PointLarg1D:=Boucle[imax];
          PointLarg1F:=Boucle[imax];
        end
      else
        begin
          PointLarg1D:=Boucle[ibc1];
          PointLarg1F:=Point(Xbc1,Ybc1);
        end;
      if ibc2=-1 then
        begin
          PointLarg2D:=Boucle[imax];
          PointLarg2F:=Boucle[imax];
        end
      else
        begin
          PointLarg2D:=Boucle[ibc2];
          PointLarg2F:=Point(Xbc2,Ybc2);
        end;
      largboucle:=sqrt(largboucle1)+sqrt(largboucle2);
    end
  else if dx=0 then
    begin
      largBoucle:=MaxiX-MiniX;
      PointLarg1D:=Boucle[iminX];
      PointLarg1F:=Point(Boucle[imaX].X,Boucle[iminX].Y);
      PointLarg2D:=Boucle[iMaxX];
      PointLarg2F:=Point(Boucle[imaX].X,Boucle[imaxX].Y);
    end
  else
    begin
      largBoucle:=MaxiY-MiniY;
      PointLarg1D:=Boucle[iminY];
      PointLarg1F:=Point(Boucle[iminY].X,Boucle[imaX].Y);
      PointLarg2D:=Boucle[iMaxY];
      PointLarg2F:=Point(Boucle[imaxY].X,Boucle[imaX].Y);
    end;
  longboucle:=sqrt(maxi);
end;
procedure MesureMarqueBoucle(Boucle:TArrayOfPoint;Bitmap:TBitmap32;marquer:boolean;Color:Tcolor32;var largboucle,Longboucle,perimetre:single);
var
  i,j,ii,n,imax,jmax,maxiX,maxiY,miniX,MiniY:integer;
  maxi,mini,valeur:single;
  PointperpX,PointPerpY:single;
  dy,dx:integer;
  pente,CC,BB:single;
  largboucle1,largboucle2,l:single;
  ibc1,ibc2,Xbc1,Xbc2,Ybc1,Ybc2:integer;
  sensXC:boolean;
  function condition(Y1,Y2:real):boolean;
  begin
    if sensXC then result:=(Y1<Y2) else result:=(Y1>Y2);
  end;
  function carredistance(Point1,Point2:Tpoint):single;
  begin
    Result:=(Point2.x-Point1.x)*(Point2.x-Point1.x)+(Point2.y-Point1.y)*(Point2.y-Point1.y);
  end;
begin
  n:=Length(boucle);
  if n<3 then
    begin
      perimetre:=2;
      largboucle:=0;
      Longboucle:=1;
      exit;
    end;
  dec(n);
  maxi:=0;
  maxiX:=0;
  miniX:=65535;
  maxiY:=0;
  miniY:=65535;
  largBoucle1:=0;
  largBoucle2:=0;
  ibc1:=-1;
  ibc2:=-1;
  for i:=0 to n-1 do
    begin
      perimetre:=perimetre+sqrt(carredistance(Boucle[i],Boucle[(i+1)mod n]));
      if (Boucle[i].Y<MiniY) then MiniY:=Boucle[i].Y;
      if (Boucle[i].Y>MaxiY) then MaxiY:=Boucle[i].Y;
      if (Boucle[i].X<MiniX) then MiniX:=Boucle[i].X;
      if (Boucle[i].X>MaxiX) then MaxiX:=Boucle[i].X;
      for j:=i+1 to Length(Boucle)-1 do
        begin
          valeur:=carredistance(Boucle[i],Boucle[j]);
          if valeur>maxi then
            begin
              maxi:=valeur;
              imax:=i;
              jmax:=j;
            end;
        end;
    end;
  if marquer then Bitmap.Line(Boucle[imax].x,Boucle[imax].y,Boucle[jmax].x,Boucle[jmax].y,color);
  dy:=(Boucle[jmax].y-Boucle[imax].y);
  dx:=(Boucle[jmax].x-Boucle[imax].x);
  if (dx<>0) and (dy<>0) then
    begin
      pente:=(Boucle[imax].x-Boucle[jmax].x)/dy;
      BB:=Boucle[imax].y+Boucle[imax].x/pente;
      sensXC:=(dx>0);
      for i:=imax+1 to jmax-1 do
        begin
{ShowMessage('Suite Pointperp : '+intToStr(Round(PointperpX))+','+intToStr(Round(PointperpY)));}
          if Condition(Boucle[i].y,BB-Boucle[i].x/pente) then
            begin
              CC:=Boucle[i].y-pente*Boucle[i].x;
              PointperpX:=(bb-cc)/(pente+1/pente);
              PointperpY:=PointperpX*pente+CC;
              valeur:=(Boucle[i].x-PointperpX)*(Boucle[i].x-PointperpX)+(Boucle[i].y-PointperpY)*(Boucle[i].y-PointperpY);
              if largBoucle1<valeur then
                begin
                  largBoucle1:=valeur;
                  Xbc1:=Round(PointperpX);
                  Ybc1:=Round(PointperpY);
                  ibc1:=i;
                end;
            end;
        end;
      sensXC:=not sensXC;
      for ii:=jmax+1 to n+imax-2 do  //
        begin
          i:=ii mod n;
          if Condition(Boucle[i].y,BB-Boucle[i].x/pente) then
            begin
              CC:=Boucle[i].y-pente*Boucle[i].x;
              PointperpX:=(bb-cc)/(pente+1/pente);
              PointperpY:=PointperpX*pente+CC;
              valeur:=(Boucle[i].x-PointperpX)*(Boucle[i].x-PointperpX)+(Boucle[i].y-PointperpY)*(Boucle[i].y-PointperpY);
              if largBoucle2<valeur then
                begin
                  largBoucle2:=valeur;
                  Xbc2:=Round(PointperpX);
                  Ybc2:=Round(PointperpY);
                  ibc2:=i;
                end;
            end;
        end;
      largboucle:=sqrt(largboucle1)+sqrt(largboucle2);
      if marquer then
        begin
          if ibc1>0 then Bitmap.LineS(Boucle[ibc1].x,Boucle[ibc1].y,Xbc1,Ybc1,color);
          if ibc2>0 then Bitmap.LineS(Boucle[ibc2].x,Boucle[ibc2].y,Xbc2,Ybc2,color);
          Bitmap.changed;
        end;
    end
  else if dx=0 then largBoucle:=MaxiX-MiniX
  else largBoucle:=MaxiY-MiniY;
  longboucle:=sqrt(maxi);
end;
function RechercheSiCanaux(Polyconditions:TTableaudeTableaudeCondicoul):Boolean;
Var
  j,k:integer;
begin
  Result:=False;
  for j:=0 to Length(Polyconditions)-1 do
    begin
      for k:=0 to Length(Polyconditions[j])-1 do
        if ord(Polyconditions[j][k].Composante)>9 then
          begin
            Result:=True;
            exit;
          end;
    end;
end;

function direction(Point1,Point2:TPoint):TPointsVoisins;
Var
  DX,DY:integer;
begin
  DX:=Point2.x-Point1.x;
  DY:=Point2.y-Point1.y;
  if (DX=-1)and(dY=0) then result:=pvO
  else if (DX=-1)and(dY=1) then result:=pvSO
  else if (DX=0)and(dY=1) then result:=pvS
  else if (DX=1)and(dY=1) then result:=pvSE
  else if (DX=1)and(dY=0) then result:=pvE
  else if (DX=1)and(dY=-1) then result:=pvNE
  else if (DX=0)and(dY=-1) then result:=pvN
  else if (DX=-1)and(dY=-1) then result:=pvNO
  else if (DX=-2)and(dY=0) then result:=pvOO
  else if (DX=-2)and(dY=1) then result:=pvOSO
  else if (DX=-2)and(dY=2) then result:=pvSSOO
  else if (DX=-1)and(dY=2) then result:=pvSSO
  else if (DX=0)and(dY=2) then result:=pvSS
  else if (DX=1)and(dY=2) then result:=pvSSE
  else if (DX=2)and(dY=2) then result:=pvSSEE
  else if (DX=2)and(dY=1) then result:=pvESE
  else if (DX=2)and(dY=0) then result:=pvEE
  else if (DX=2)and(dY=-1) then result:=pvENE
  else if (DX=2)and(dY=-2) then result:=pvNNEE
  else if (DX=1)and(dY=-2) then result:=pvNNE
  else if (DX=0)and(dY=-2) then result:=pvNN
  else if (DX=-1)and(dY=-2) then result:=pvNNO
  else if (DX=-2)and(dY=-2) then result:=pvNNOO
  else if (DX=-2)and(dY=-1) then result:=pvONO
  else result:=pvErreur;
end;
function Voisin(Point:TPoint;voisinage:TPointsVoisins):TPoint;
Var
  DX,DY:integer;
begin
  if voisinage=pvO then
    begin
      DX:=-1;
      dY:=0;
    end
  else if voisinage=pvSO then
    begin
      DX:=-1;
      dY:=1;
    end
  else if voisinage=pvS then
    begin
      DX:=0;
      dY:=1;
    end
  else if voisinage=pvSE then
    begin
      DX:=1;
      dY:=1;
    end
  else if voisinage=pvE then
    begin
      DX:=1;
      dY:=0;
    end
  else if voisinage=pvNE then
    begin
      DX:=1;
      dY:=-1;
    end
  else if voisinage=pvN then
    begin
      DX:=0;
      dY:=-1;
    end
  else if voisinage=pvNO then
    begin
      DX:=-1;
      dY:=-1;
    end
  else if voisinage=pvOO then
    begin
      DX:=-2;
      dY:=0;
    end
  else if voisinage=pvOSO then
    begin
      DX:=-2;
      dY:=1;
    end
  else if voisinage=pvSSOO then
    begin
      DX:=-2;
      dY:=2;
    end
  else if voisinage=pvSSO then
    begin
      DX:=-1;dY:=2;
    end
  else if voisinage=pvSS then
    begin
      DX:=0;dY:=2;
    end
  else if voisinage=pvSSE then
    begin
      DX:=1;
      dY:=2;
    end
  else if voisinage=pvSSEE then
    begin
      DX:=2;
      dY:=2;
    end
  else if voisinage=pvESE then
    begin
      DX:=2;
      dY:=1;
    end
  else if voisinage=pvEE then
    begin
      DX:=2;
      dY:=0;
    end
  else if voisinage=pvENE then
    begin
      DX:=2;
      dY:=-1;
    end
  else if voisinage=pvNNEE then
    begin
      DX:=2;
      dY:=-2;
    end
  else if voisinage=pvNNE then
    begin
      DX:=1;
      dY:=-2;
    end
  else if voisinage=pvNN then
    begin
      DX:=0;
      dY:=-2;
    end
  else if voisinage=pvNNO then
    begin
      DX:=-1;
      dY:=-2;
    end
  else if voisinage=pvNNOO then
    begin
      DX:=-2;
      dY:=-2;
    end
  else if voisinage=pvONO then
    begin
      DX:=-2;
      dY:=-1;
    end;
  if voisinage=pvErreur then
    begin
      Result.x:=-65535;
      Result.y:=-65535;
    end
  else
    begin
      Result.x:=Point.x+DX;
      Result.y:=Point.y+DY;
    end;
end;
function verifieContact(Boucle:TArrayOfPoint;w,h:integer):boolean;
var
  Xma,Xmi,Yma,Ymi:integer;
  Xp,Yp:integer;
  i,n:integer;
  NG,ND,NH,NB: integer;
  val:integer;
  lg,ht:integer;
  function verifie(valtest,ltp:integer):Boolean;
  var
    valeur:integer;
  begin
    result:=true;
    if ltp<4 then exit;
    valeur:=Round(sin(arccos((ltp/2-1)/(ltp/2)))*ltp);
    Result:=(Valtest<=valeur);
  end;
begin
  Result:=True;
  n:=Length(Boucle);
  if n<4 then exit;
  lg:=w-1;
  ht:=h-1;
  Xma:=0;
  xmi:=w;
  Yma:=0;
  Ymi:=h;
  NG:=0;
  ND:=0;
  NH:=0;
  NB:=0;
  for i:=0 to n-1 do
    begin
      Xp:=Boucle[i].x;
      Yp:=Boucle[i].y;
      if Xp>Xma then Xma:=Xp;
      if Xp<Xmi then Xmi:=Xp;
      if Yp>Yma then Yma:=Yp;
      if Yp<Ymi then
        Ymi:=Yp;
      if Xp=0 then inc(NG)
      else if Xp=lg then inc(ND);
      if Yp=0 then inc(NH)
      else if Yp=ht then inc(NB);
    end;
  if ((NB>0) and (NH>0)) or ((NG>0) and (ND>0)) then exit;
  if (NG>0) or (ND>0) then
    begin
      val:=NG+ND;
      result:=verifie(val,(Yma-Ymi+1));
    end;
  if (NB>0) or (NH>0) then
    begin
      val:=NB+NH;
      result:=result and verifie(val,(Xma-Xmi+1));
    end;
end;
function simplifieBoucle(var Boucle:TArrayOfPoint):real;// la sortie indique le primtre
var
 i,j,dx,dy,n,nbc:integer;
 valeur:integer;
 CBoucle:TArrayOfPoint;
 BoucleS:TArrayOfPoint;
 continuer:boolean;
 DirPS:TPointsVoisins;
 DirPStest:TPointsVoisins;
 function carredistance(Point1,Point2:Tpoint):real;
  begin
    Result:=(Point2.x-Point1.x)*(Point2.x-Point1.x)+(Point2.y-Point1.y)*(Point2.y-Point1.y);
  end;
begin
  Result:=0;
  n:=Length(Boucle);
  if n<5 then exit;
  dx:=0;
  dy:=0;
  i:=0;
  nbc:=1;
  SetLength(CBoucle,1);
  CBoucle[0]:=Boucle[0];
  While (i<n-2) do
    begin
      j:=i+1;
      dx:=Boucle[j].x-Boucle[i].x;
      dy:=Boucle[j].x-Boucle[i].x;
      continuer:=(abs(dx)<2)or(abs(dy)<2);
      While continuer and (j<n-1) do
        begin
          inc(j);
          Valeur:=Boucle[j].x-Boucle[i].x;
          if (abs(Valeur)>1) or (abs(Valeur-dx)>1) then
            begin
              Valeur:=Boucle[j].y-Boucle[i].y;
              if (abs(Valeur)>1) or (abs(Valeur-dy)>1) then continuer:=False;
            end;
        end;
     if j>i+1 then dec(j);
     inc(nbc);
     i:=j+1;
     SetLength(CBoucle,nbc);
     CBoucle[nbc-1]:=Boucle[j];
     Result:=Result+sqrt(carredistance(CBoucle[nbc-1],CBoucle[nbc-2]));
  end;
  n:=Length(Boucle);
  nbc:=1;
  SetLength(BoucleS,nbc);
  BoucleS[0]:=Boucle[0];
  i:=0;
  While i< n-2 do
    begin
      j:=i+1;
      DirPS:=Direction(Boucle[i],Boucle[j]);
      DirPSTest:=Direction(Boucle[j],Boucle[j+1]);
      While (DirPSTest=DirPS) and (DirPS<>pvErreur) and (j<n-2) do
        begin
          inc(j);
          DirPSTest:=Direction(Boucle[j],Boucle[j+1]);
        end;
      SetLength(BoucleS,nbc+1);
      BoucleS[nbc]:=Boucle[j];
      inc(nbc);
      i:=j;
    end;
  n:=Length(BoucleS);
  SetLength(Boucle,n);
  for i:=0 to n-1 do Boucle[i]:=BoucleS[i];
  SetLength(BoucleS,0);
  SetLength(CBoucle,0);
{  n:=Length(CBoucle);
  SetLength(Boucle,n);
  for i:=0 to n-1 do Boucle[i]:=CBoucle[i];
  SetLength(CBoucle,0);}
end;
function RemplitJusquAuContour(X,Y:integer;Contourext:TArrayOfPoint;Color,ColorS:Tcolor32;Typeremplis:TRemplis;PolyConditions:TTableaudeTableaudeCondicoul;Bitmaptest,Bitmaptrav:TBitmap32):integer;
var
  i,j,w,h,nbp,nbemb,nbpc:integer;
  Contourdev:TArrayOfPoint;
  condition,condition2:boolean;
  PointsTest:TArrayOfPoint;
  CopiePointsTest:TArrayOfPoint;
  Xt,Yt,Xd,Yd,Xf,Yf:integer;
  coeff:real;
  Xmi,Xma,Ymi,Yma:integer;
  trouve,identique:boolean;
  BytemapTp:Tbytemap;
  colorF:Tcolor32;
  ValCanaux:Array of Byte;
  nbcn:integer;
  espace:integer;
  procedure MarquEtAjouteContour(Xtp,Ytp:integer);
  begin
    BytemapTp[Xtp,Ytp]:=255;
    Bitmaptrav[Xtp,Ytp]:=color;
    SetLength(ContourDev,nbpc+1);
    ContourDev[nbpc].X:=Xtp;
    ContourDev[nbpc].Y:=Ytp;
    inc(nbpc);
  end;
  procedure tracepoint;
  var
    conditionfond:boolean;
    itp,n:integer;
  begin
    if nbcn>0 then
      begin
        for itp:=0 to nbcn-1 do
          ValCanaux[itp]:=CopieCanaux[itp].Value[xt,yt];
      end;
    if BytemapTp[Xt,Yt]=0 then
      begin
        n:=Length(PointsTest);
        SetLength(PointsTest,n+1);
        PointsTest[n].X:=Xt;
        PointsTest[n].Y:=Yt;
        if TestePolyCondicoul(Bitmaptest[Xt,Yt],ValCanaux,PolyConditions) then
          begin // tester si le point appartient aux dparts prcedents
            case Typeremplis of
              teAucun,tePlein:conditionfond:=True;
              teVertical:conditionfond:=((xt mod espace)=0);
              teHorizontal:conditionfond:=((Yt mod espace)=0);
              teQuadrillage:conditionfond:=((xt mod espace)=0) or ((Yt mod espace)=0);
              teOblique1:conditionfond:=(((xt-yt) mod espace)=0);
              teOblique2:conditionfond:=(((xt+yt) mod espace)=0);
              teQuadroblique:conditionfond:=(((xt-yt) mod espace)=0) or (((xt+yt) mod espace)=0);
            end;
            BytemapTp[Xt,Yt]:=255;
            if conditionfond then Bitmaptrav[Xt,Yt]:=ColorS
            else Bitmaptrav[Xt,Yt]:=colorF;
            inc(result);
          end
        else bytemaptp[Xt,Yt]:=128;
      end;
  end;
begin
  w:=Bitmaptrav.Width;
  h:=Bitmaptrav.Height;
  BytemapTp:=TBytemap.Create;
  BytemapTp.SetSize(w,h);
  BytemapTp.Clear(0);
  nbcn:=Length(CopieCanaux);
  SetLength(ValCanaux,nbcn);
  if nbcn=0 then
    begin
      SetLength(ValCanaux,1);
      ValCanaux[0]:=0;
    end;
  colorF:=SetAlpha(ColorS,1);
  if TypeRemplis>teQuadrillage then espace:=round(ecart_rayures*sqrt(2)) else espace:=ecart_rayures;
  //balisage du contour  avec 255  dans le bytemap
  SetLength(Contourdev,1);
  nbpc:=1;
  Contourdev[0]:=ContourExt[0];
  Xt:=ContourExt[0].X;
  Yt:=ContourExt[0].Y;
  BytemapTp[Xt,Yt]:=255;
  Bitmaptrav[Xt,Yt]:=color;
  if Length(ContourExt)=1 then exit;
  Xmi:=w;
  Xma:=0;
  Ymi:=h;
  Yma:=0;
  for i:=1 to Length(Contourext)-1 do
    begin
      Xd:=Contourext[i-1].X;
      Yd:=Contourext[i-1].Y;
      if Xmi>Xd then Xmi:=Xd;
      if Xma<Xd then Xma:=Xd;
      if Ymi>Yd then Ymi:=Yd;
      if Yma<Yd then Yma:=Yd;
      Xf:=Contourext[i].X;
      Yf:=Contourext[i].Y;
      if abs(Yf-Yd)> abs(Xf-Xd) then
        begin
          if Yd>Yf then
            begin
              coeff:=(Xf-Xd)/(Yf-Yd);
              for j:=1 to (Yd-Yf) do
                begin
                  Xt:=Xd-round(j*coeff);
                  Yt:=Yd-j;
                  MarquEtAjouteContour(Xt,Yt);
                end;
            end
          else if Yd=Yf then BytemapTp[Xd,Yd]:=255
          else
            begin
              coeff:=(Xf-Xd)/(Yf-Yd);
              for j:=1 to (Yf-Yd) do
                begin
                  Xt:=Xd+round(j*coeff);
                  Yt:=Yd+j;
                  MarquEtAjouteContour(Xt,Yt);
                end;
            end;
        end
      else
        begin
          if Xd>Xf then
            begin
              coeff:=(Yf-Yd)/(Xf-Xd);
              for j:=1 to (Xd-Xf) do
                begin
                  Xt:=Xd-j;
                  Yt:=Yd-round(j*coeff);
                  MarquEtAjouteContour(Xt,Yt);
                end;
            end
          else if Xd=Xf then BytemapTp[Xd,Yd]:=255
          else
            begin
              coeff:=(Yf-Yd)/(Xf-Xd);
              for j:=1 to (Xf-Xd) do
                begin
                  Xt:=Xd+j;
                  Yt:=Yd+round(j*coeff);
                  MarquEtAjouteContour(Xt,Yt);
                end;
            end;
        end;
    end;
  Xt:=X;
  Yt:=Y;
  if ((Yma-Ymi)<3) or ((Xma-Xmi)<3) then exit;
  //si X,Y fait partie du contour, recherche d'un point de dpart ne faisant pas partie du contour
  // il est  droite du trace du contour (par rapport  la direction de trac)
  //  ct d'un point prsent une seule fois et qui n'est pas un point de rebroussement
  // (entour de deux points identiques);
  // vrifier que le voisin ainsi dfini ne fait pas partie du contour
  if Bytemaptp[X,Y]=255 then
    begin
      trouve:=false;
      for i:=0 to nbpc-2 do
        begin
          identique:=false;
          for j:=i+1 to i+nbpc-1 do
            begin
              if (ContourDev[i].X=ContourDev[(j mod nbpc)].X)and(ContourDev[i].Y=ContourDev[(j mod nbpc)].Y) then
                begin
                  identique:=true;
                  break;
                end;
            end;
          if not identique then
            begin
              if (i=0) then trouve:=(ContourDev[nbpc-1].X<>ContourDev[1].X)or(ContourDev[nbpc-1].Y<>ContourDev[1].Y)
              else if i=(nbpc-1) then trouve:=(ContourDev[nbpc-2].X<>ContourDev[0].X)or(ContourDev[nbpc-2].Y<>ContourDev[0].Y)
              else trouve:=(ContourDev[i-1].X<>ContourDev[i+1].X)or(ContourDev[i-1].Y<>ContourDev[i+1].Y);
              if trouve then
                begin
                  trouve:=false;
                  Xd:=ContourDev[i].X;
                  Xf:=ContourDev[(i+1)mod nbpc].X;
                  Yd:=ContourDev[i].Y;
                  Xf:=ContourDev[(i+1)mod nbpc].Y;
                  Xt:=-1;
                  Yt:=-1;
                  if (Xf>Xd) and (Yf>=Yd) then
                    begin
                      Xt:=Xd;
                      Yt:=Yd+1;
                    end
                  else if (Xf<Xd) and (Yf<=Yd) then
                    begin
                      Xt:=Xd;
                      Yt:=Yd-1;
                    end
                  else if (Yf>Yd) and (Xf<=Xd) then
                    begin
                      Xt:=Xd-1;
                      Yt:=Yd;
                    end
                  else if (Yf<Yd) and (Xf>=Xd) then
                    begin
                      Xt:=Xd+1;
                      Yt:=Yd;
                    end;
                  if (Xt>=0)and(Yt>=0)and(Xt<w)and(Yt<h)and (Bytemaptp[Xt,Yt]<>255) then
                    begin
                      trouve:=True;
                      break;
                    end;
                end;
            end;
        end;
      if Not trouve then Exit;
    end
  else
    begin
      Xt:=X;
      Yt:=Y;
    end;
  SetLength(PointsTest,0);
  tracepoint;
  SetLength(CopiePointsTest,1);
  CopiePointsTest[0]:=Point(Xt,Yt);
  while Length(CopiePointsTest)>0 do
    begin
      for i:=0 to Length(CopiePointsTest)-1 do
        begin
          if CopiePointsTest[i].X>0 then
            begin
              Xt:=CopiePointsTest[i].X-1;
              Yt:=CopiePointsTest[i].Y;
              tracepoint;
            end;
          if CopiePointsTest[i].Y>0 then
            begin
              Xt:=CopiePointsTest[i].X;
              Yt:=CopiePointsTest[i].Y-1;
              tracepoint;
            end;
          if CopiePointsTest[i].X<(w-1) then
            begin
              Xt:=CopiePointsTest[i].X+1;
              Yt:=CopiePointsTest[i].Y;
              tracepoint;
            end;
          if CopiePointsTest[i].Y<(h-1) then
            begin
              Xt:=CopiePointsTest[i].X;
              Yt:=CopiePointsTest[i].Y+1;
              tracepoint;
           end;
        end;
      SetLength(CopiePointsTest,Length(PointsTest));
      for i:=0 to Length(PointsTest)-1 do
        begin
          CopiePointsTest[i]:=PointsTest[i];
        end;
      SetLength(PointsTest,0);
    end;
  SetLength(CopiePointsTest,0);
  For i:=0 to Length(ContourDev)-1 do
    Bitmaptrav[ContourDev[i].X,ContourDev[i].Y]:=Color;
  Bitmaptrav.Changed;
  BytemapTp.Free;
end;

function remplitSousCondition(X,Y:integer;Color:Tcolor32;Typeremplis:TRemplis;PolyConditions:TTableaudeTableaudeCondicoul;Bitmaptest,Bitmaptrav:TBitmap32):integer;
var
  i,n,w,h,nbp,espace:integer;
  condition,condition2:boolean;
  PointsTest:TArrayOfPoint;
  CopiePointsTest:TArrayOfPoint;
  Xt,Yt:integer;
  colorF:Tcolor32;
  ValCanaux:Array of Byte;
  nbcn:integer;
  BytemapTp:Tbytemap;
  procedure tracepoint;
  var
    conditionfond:boolean;
    itp:integer;
  begin
    if nbcn>0 then
      begin
        for itp:=0 to nbcn-1 do
          ValCanaux[itp]:=CopieCanaux[itp].Value[xt,yt];
      end;
    if TestePolyCondicoul(Bitmaptest[Xt,Yt],ValCanaux,PolyConditions) and(BytemapTp[Xt,Yt]=0) then
      begin
        case Typeremplis of
          teAucun,tePlein:conditionfond:=True;
          teVertical:conditionfond:=((xt mod espace)=0);
          teHorizontal:conditionfond:=((Yt mod espace)=0);
          teQuadrillage:conditionfond:=((xt mod espace)=0) or ((Yt mod espace)=0);
          teOblique1:conditionfond:=(((xt-yt) mod espace)=0);
          teOblique2:conditionfond:=(((xt+yt) mod espace)=0);
          teQuadroblique:conditionfond:=(((xt-yt) mod espace)=0) or (((xt+yt) mod espace)=0);
        end;
        BytemapTp[Xt,Yt]:=255;
        if conditionfond then Bitmaptrav[Xt,Yt]:=Color
        else Bitmaptrav[Xt,Yt]:=colorF;
        n:=Length(PointsTest);
        SetLength(PointsTest,n+1);
        PointsTest[n].X:=Xt;
        PointsTest[n].Y:=Yt;
        inc(result);
      end;
  end;
begin
  w:=Bitmaptrav.Width;
  h:=Bitmaptrav.Height;
  BytemapTp:=TBytemap.Create;
  BytemapTp.SetSize(w,h);
  BytemapTp.Clear(0);
  nbcn:=Length(CopieCanaux);
  SetLength(ValCanaux,nbcn);
  if nbcn=0 then
    begin
      SetLength(ValCanaux,1);
      ValCanaux[0]:=0;
    end;

  colorF:=SetAlpha(Color,1);
  if TypeRemplis>teQuadrillage then espace:=round(ecart_rayures*sqrt(2)) else espace:=ecart_rayures;
  Xt:=X;
  Yt:=Y;
  SetLength(PointsTest,0);

  tracepoint;
  SetLength(CopiePointsTest,1);
  CopiePointsTest[0]:=Point(X,Y);
  result:=0;
  //nbp:=0;
  while Length(CopiePointsTest)>0 do
    begin
      for i:=0 to Length(CopiePointsTest)-1 do
        begin
          if CopiePointsTest[i].X>0 then
            begin
              Xt:=CopiePointsTest[i].X-1;
              Yt:=CopiePointsTest[i].Y;
              tracepoint;
            end;
          if CopiePointsTest[i].Y>0 then
            begin
              Xt:=CopiePointsTest[i].X;
              Yt:=CopiePointsTest[i].Y-1;
              tracepoint;
            end;
          if CopiePointsTest[i].X<(w-1) then
            begin
              Xt:=CopiePointsTest[i].X+1;
              Yt:=CopiePointsTest[i].Y;
              tracepoint;
            end;
          if CopiePointsTest[i].Y<(h-1) then
            begin
              Xt:=CopiePointsTest[i].X;
              Yt:=CopiePointsTest[i].Y+1;
              tracepoint;
           end;
        end;
      SetLength(CopiePointsTest,Length(PointsTest));
      for i:=0 to Length(PointsTest)-1 do
        begin
          CopiePointsTest[i]:=PointsTest[i];
        end;
      SetLength(PointsTest,0);
    end;
  Bitmaptrav.Changed;
  BytemapTp.Free;
end;

function remplitVide(X,Y:integer;Color:Tcolor32;Typeremplis:TRemplis;Condicoul:TCondicoul;Bitmaptest,Bitmaptrav:TBitmap32):integer;
var
  i,n,w,h,nbp,espace:integer;
  condition,condition2:boolean;
  PointsTest:TArrayOfPoint;
  CopiePointsTest:TArrayOfPoint;
  //LigneContour:TArrayOfPoint;
  //test:integer;
  Xt,Yt:integer;
  colorF:Tcolor32;
  procedure tracepoint;
  var
    conditionfond:boolean;
  begin
    if conditionCouleur(Condicoul,Bitmaptest[Xt,Yt]) and(AlphaComponent(Bitmaptrav[Xt,Yt])=0) then
      begin
        case Typeremplis of
          teAucun,tePlein:conditionfond:=True;
          teVertical:conditionfond:=((xt mod espace)=0);
          teHorizontal:conditionfond:=((Yt mod espace)=0);
          teQuadrillage:conditionfond:=((xt mod espace)=0) or ((Yt mod espace)=0);
          teOblique1:conditionfond:=(((xt-yt) mod espace)=0);
          teOblique2:conditionfond:=(((xt+yt) mod espace)=0);
          teQuadroblique:conditionfond:=(((xt-yt) mod espace)=0) or (((xt+yt) mod espace)=0);
        end;
        if conditionfond then Bitmaptrav[Xt,Yt]:=Color
        else Bitmaptrav[Xt,Yt]:=colorF;
        n:=Length(PointsTest);
        SetLength(PointsTest,n+1);
        PointsTest[n].X:=Xt;
        PointsTest[n].Y:=Yt;
        inc(result);
      end;
  end;
begin
  w:=Bitmaptrav.Width;
  h:=Bitmaptrav.Height;
  colorF:=SetAlpha(Color,1);
  if TypeRemplis>teQuadrillage then espace:=round(ecart_rayures*sqrt(2)) else espace:=ecart_rayures;
  Xt:=X;
  Yt:=Y;
  SetLength(PointsTest,0);
  tracepoint;
  SetLength(CopiePointsTest,1);
  CopiePointsTest[0]:=Point(X,Y);
  result:=0;
  //nbp:=0;
  while Length(CopiePointsTest)>0 do
    begin
      for i:=0 to Length(CopiePointsTest)-1 do
        begin
          if CopiePointsTest[i].X>0 then
            begin
              Xt:=CopiePointsTest[i].X-1;
              Yt:=CopiePointsTest[i].Y;
              tracepoint;
            end;
          if CopiePointsTest[i].Y>0 then
            begin
              Xt:=CopiePointsTest[i].X;
              Yt:=CopiePointsTest[i].Y-1;
              tracepoint;
            end;
          if CopiePointsTest[i].X<(w-1) then
            begin
              Xt:=CopiePointsTest[i].X+1;
              Yt:=CopiePointsTest[i].Y;
              tracepoint;
            end;
          if CopiePointsTest[i].Y<(h-1) then
            begin
              Xt:=CopiePointsTest[i].X;
              Yt:=CopiePointsTest[i].Y+1;
              tracepoint;
           end;
        end;
      SetLength(CopiePointsTest,Length(PointsTest));
      for i:=0 to Length(PointsTest)-1 do
        begin
          CopiePointsTest[i]:=PointsTest[i];
        end;
      SetLength(PointsTest,0);
    end;
  Bitmaptrav.Changed;
end;
function conditionCouleur(Condicoul:TCondicoul;color:Tcolor32):boolean;
begin
  result:=true;
  with Condicoul do
    begin
      if (AlphaComponent(Color)>Amax) or (AlphaComponent(Color)<Amin) then result:=false;
      if (BlueComponent(Color)>Bmax) or (BlueComponent(Color)<Bmin) then result:=false;
      if (GreenComponent(Color)>Gmax) or (GreenComponent(Color)<Gmin) then result:=false;
      if (RedComponent(Color)>Rmax) or (RedComponent(Color)<Rmin) then result:=false;
    end;
end;

function TesteCondicoul(Color:TColor32;ValCanaux:Array of byte;Condition:TCondicoulElem):Boolean;
Var
  Hint,Sint,Lint,Tint,Vint,S2int:word;
  numcan:integer;
  procedure ConvertitHSL;
  var
    H,S,L:single;
  begin
     RGBtoHSL(Color,H, S, L);
     Hint:=Round(H*360);
     Sint:=Round(S*255);
     Lint:=Round(L*255);
     //if Condition.ValeurMin<0 then if Hint>=(360+Condition.ValeurMin) then Dec(Hint,360);
  end;
  procedure ConvertitHSV;
  var
    H,S,V:double;
  begin
     RGBtoHSV (RedComponent(Color),GreenComponent(Color),BlueComponent(Color),H,S,V);
     Tint:=Round(H);
     S2int:=Round(S);
     Vint:=Round(V);
     //if Condition.ValeurMin<0 then if Tint>=(360+Condition.ValeurMin) then Dec(Tint,360);
  end;
begin
  Result:=True;
  with Condition do
    begin
      Case Composante of
        cpRouge:if(RedComponent(Color)>ValeurMax) or (RedComponent(Color)<ValeurMin) then result:=false;
        cpVerte:if(GreenComponent(Color)>ValeurMax) or (GreenComponent(Color)<ValeurMin) then result:=false;
        cpBleue:if(BlueComponent(Color)>ValeurMax) or (BlueComponent(Color)<ValeurMin) then result:=false;
        cpAlpha:if(AlphaComponent(Color)>ValeurMax) or (AlphaComponent(Color)<ValeurMin) then result:=false;
        cpTeinte:begin
                   ConvertitHSL;
                   if (ValeurMax>=ValeurMin) and ((Hint>ValeurMax) or (Hint<ValeurMin))
                      or (ValeurMax<ValeurMin) and ((Hint>ValeurMax) and (Hint<ValeurMin)) then Result:=False;
                 end;
        cpSaturation:begin
                       ConvertitHSL;
                       if (Sint>ValeurMax) or (Sint<ValeurMin) then Result:=False;
                     end;
        CpLumin:begin
                  ConvertitHSL;
                  if (Lint>ValeurMax) or (Lint<ValeurMin) then Result:=False;
                end;
        cpTeint2:begin
                   ConvertitHSV;
                   if (ValeurMax>=ValeurMin) and ((Tint>ValeurMax) or (Tint<ValeurMin))
                      or (ValeurMax<ValeurMin) and ((Tint>ValeurMax) and (Tint<ValeurMin)) then Result:=False;
                   //if (Tint>ValeurMax) or (Tint<ValeurMin) then Result:=False;
                 end;
        cpSat2:begin
                   ConvertitHSV;
                   if (S2int>ValeurMax) or (S2int<ValeurMin) then Result:=False;
                 end;
        cpValeur:begin
                   ConvertitHSV;
                   if (Vint>ValeurMax) or (Vint<ValeurMin) then Result:=False;
                 end;
        else begin
               numcan:=ord(Composante)-10;
               if numcan<Length(ValCanaux) then
                 begin
                   if (ValCanaux[numcan]>ValeurMax) or (ValCanaux[numcan]<ValeurMin) then Result:=False;
                 end
               else result:=false;
             end;
      end;
    end;
end;
function TesteSerieCondicoul(Color:TColor32;ValCanaux:Array of byte;Conditions:TTableaudeCondicoul):Boolean;
var
  i,n:integer;
begin
  n:=Length(Conditions);
  if n=0 then begin result:=False; exit;end;
  Result:=TesteCondicoul(Color,ValCanaux,Conditions[0]);
  for i:=1 to n-1 do
    Case Conditions[i-1].Lien of
      lnOu:Result:=Result or TesteCondicoul(Color,ValCanaux,Conditions[i]);
      lnEt:Result:=Result and TesteCondicoul(Color,ValCanaux,Conditions[i]);
      lnXor:Result:=Result xor TesteCondicoul(Color,ValCanaux,Conditions[i]);
      lnNon:Result:=Result and (not TesteCondicoul(Color,ValCanaux,Conditions[i]));
    end;
end;

function TestePolyCondicoul(Color:TColor32;ValCanaux:Array of byte;PolyConditions:TTableaudeTableaudeCondicoul):Boolean;
Var
 i,n,p:integer;
begin
  n:=Length(PolyConditions);
  if n=0 then begin result:=False; exit;end;
  Result:=TesteSerieCondicoul(Color,ValCanaux,PolyConditions[0]);
  for i:=1 to n-1 do
    begin
      p:=Length(PolyConditions[i-1])-1;
      if p>=0 then
      Case PolyConditions[i-1][p].Lien of
        lnOu:Result:=Result or TesteSerieCondicoul(Color,ValCanaux,PolyConditions[i]);
        lnEt:Result:=Result and TesteSerieCondicoul(Color,ValCanaux,PolyConditions[i]);
        lnXor:Result:=Result xor TesteSerieCondicoul(Color,ValCanaux,PolyConditions[i]);
        lnNon:Result:=Result and (not TesteSerieCondicoul(Color,ValCanaux,PolyConditions[i]));
      end;
    end;
end;
procedure DessinePolyTPoint(color:TColor32;UnContour:TArrayofPoint;Bitmap:TBitmap32);
var
  i:integer;
begin
  for i:=0 to Length(Uncontour)-1 do
      Bitmap[UnContour[i].X,UnContour[i].Y]:=color;
//  for i:=1 to Length(Uncontour)-1 do
//    Bitmap.Line(UnContour[i-1].X,UnContour[i-1].Y,UnContour[i].X,UnContour[i].Y,color,true);
end;
procedure DessinePolyligne(color:TColor32;UnContour:TArrayofPoint;Bitmap:TBitmap32);
var
  i:integer;
  descolor32:Array[0..9] of Tcolor32;
begin
  descolor32[0]:=Clolive32;
  descolor32[1]:=Clblue32;
  descolor32[2]:=ClFuchsia32;
  descolor32[3]:=ClYellow32;
  descolor32[4]:=ClMaroon32 ;
  descolor32[5]:=Clwhite32;
  descolor32[6]:=clLime32;
  descolor32[7]:=Clnavy32;
  descolor32[8]:=Clblack32;
  descolor32[9]:=Clgray32;
  for i:=1 to Length(Uncontour)-1 do
    Bitmap.Line(UnContour[i-1].X,UnContour[i-1].Y,UnContour[i].X,UnContour[i].Y,descolor32[i mod 10]{,true});
end;
procedure DessinePolyTPointmulticol(UnContour:TArrayofPoint;Bitmap:TBitmap32);
var
  i,j:integer;
  descolor32:Array[0..9] of Tcolor32;
begin
  descolor32[0]:=Clolive32;
  descolor32[1]:=Clblue32;
  descolor32[2]:=ClFuchsia32;
  descolor32[3]:=ClYellow32;
  descolor32[4]:=ClMaroon32 ;
  descolor32[5]:=Clwhite32;
  descolor32[6]:=clLime32;
  descolor32[7]:=Clnavy32;
  descolor32[8]:=Clblack32;
  descolor32[9]:=Clgray32;

  for i:=0 to Length(Uncontour)-1 do
      Bitmap[UnContour[i].X,UnContour[i].Y]:=descolor32[i mod 10];
//  for i:=1 to Length(Uncontour)-1 do
//    Bitmap.Line(UnContour[i-1].X,UnContour[i-1].Y,UnContour[i].X,UnContour[i].Y,color,true);
end;

{version ancienne
function TDessin.WriteToStream(Stream:TStream):integer;
var
  buffer:array[0..2048] of Char;
  longueur,p:integer;
  nom,textaecrire:string;
  couleurfonte:Tcolor32;
  taillefonte:byte;
  stylefonte:byte;
  longueurtexte:word;
  j:integer;
  nombrepoints:word;
  LePoint:TFixedPoint;
  PointX,PointY:Word;
  Rotent:Word;
  procedure ecritcouleur(c32:Tcolor32);
  var
    octet:byte;
  begin
    octet:=BlueComponent(C32);
    buffer[0]:=Chr(octet);
    Stream.Write(buffer,1);
    octet:=GreenComponent(C32);
    buffer[0]:=Chr(octet);
    Stream.Write(buffer,1);
    octet:=RedComponent(C32);
    buffer[0]:=Chr(octet);
    Stream.Write(buffer,1);
    octet:=AlphaComponent(C32);
    buffer[0]:=Chr(octet);
    Stream.Write(buffer,1);
  end;
begin
  p:=0;
  longueur:=0;
  buffer[p]:=chr(ord(cat));
  inc(p);
  buffer[p]:=chr(ord(TypetraitD));
  inc(p);
  buffer[p]:=chr(ord(TypetraceD));
  inc(p);
  buffer[p]:=chr(ord(TyperemplisD));
  inc(p);
  buffer[p]:=chr(Xd and 255); // 5
  inc(p);
  buffer[p]:=chr(Xd div 256); //6
  inc(p);
  buffer[p]:=chr(Yd and 255); // 7
  inc(p);
  buffer[p]:=chr(Yd div 256); //8
  inc(p);
  buffer[p]:=chr(Xf and 255); // 9
  inc(p);
  buffer[p]:=chr(Xf div 256); //10
  inc(p);
  buffer[p]:=chr(Yf and 255); // 11
  inc(p);
  buffer[p]:=chr(Yf div 256); // 12
  inc(p);
  buffer[p]:=chr(XC and 255); // 13
  inc(p);
  buffer[p]:=chr(XC div 256); // 14
  inc(p);
  buffer[p]:=chr(YC and 255); // 15
  inc(p);
  buffer[p]:=chr(YC div 256); // 16
  inc(p);
  buffer[p]:=chr(RC and 255); // 17
  inc(p);
  buffer[p]:=chr(RC div 256); // 18
  inc(p);
  buffer[p]:=chr(ep and 255); // 19
  inc(p);
  buffer[p]:=chr(Alignement and 255); //20
  inc(p);
  buffer[p]:=chr(opaciteD and 255); //21
  inc(p);
  buffer[p]:=chr(ord(Transparent) and 255); //22
  inc(p);
  Rotent:=Round(100*Rotation);
  buffer[p]:=chr(Rotent and 255); // 23
  inc(p);
  buffer[p]:=chr(Rotent div 256); // 24
  inc(p);
  Stream.Write(Buffer,p);

  ecritcouleur(couleurD);// 4 octets
  ecritcouleur(couleurFD);// 4 octets
  result:=32;
  if cat=ctechelle then
    begin
      nom:=NomFonte;
      p:=Length(nom);
      buffer[0]:=chr(p and 255);
      Stream.Write(buffer,1);
      result:=result+1;
      Stream.Write(Pointer(nom)^,p);
      result:=result+p;
      couleurfonte:=CouleurD;
      ecritcouleur(couleurfonte);// 4 octets
      result:=result+4;
      p:=0;
      buffer[p]:=Chr(TailleFonte); // 1
      inc(p);
      buffer[p]:=Chr(StyleFonte); // 2
      inc(p);
      textaecrire:=NomUnite;
      longueurtexte:=Length(textaecrire);
      buffer[p]:=chr(longueurtexte and 255); // 3
      inc(p);
      buffer[p]:=chr(longueurtexte div 256); // 4
      Stream.Write(Buffer,4);
      result:=result+4;
      Stream.Write(Pointer(textaecrire)^,longueurtexte);
      result:=result+longueurtexte;
      Rotent:=Round(100*CoeffEch);
      buffer[0]:=chr(Rotent and 255); // 1
      buffer[1]:=chr(Rotent div 256); // 2
      Stream.Write(Buffer,2);
    end;
  if cat=ctTxt then
    begin
      nom:=NomFonte;
      p:=Length(nom);
      buffer[0]:=chr(p and 255);
      Stream.Write(buffer,1);
      result:=result+1;
      Stream.Write(Pointer(nom)^,p);
      result:=result+p;
      couleurfonte:=CouleurD;
      ecritcouleur(couleurfonte);// 4 octets
      result:=result+4;
      p:=0;
      buffer[p]:=Chr(TailleFonte); // 1
      inc(p);
      buffer[p]:=Chr(StyleFonte); // 2
      inc(p);
      textaecrire:=Texte.Text;
      longueurtexte:=Length(textaecrire);
      buffer[p]:=chr(longueurtexte and 255); // 3
      inc(p);
      buffer[p]:=chr(longueurtexte div 256); // 4
      Stream.Write(Buffer,4);
      result:=result+4;
      Stream.Write(Pointer(textaecrire)^,longueurtexte);
      result:=result+longueurtexte;
    end;
  if cat=ctCrayon then
    begin
      nombrepoints:=High(tracel.Points[0])+1;
      buffer[0]:=Chr(nombrepoints and 255);
      buffer[1]:=Chr(nombrepoints div 256);
      Stream.Write(Buffer,2);
      result:=result+2;
      for J:=0 to nombrepoints-1 do
        begin
          LePoint:=tracel.Points[0][J];
          PointX:=Round(LePoint.X / 65536);
          PointY:=Round(LePoint.Y / 65536);
          p:=0;
          buffer[p]:=chr(PointX and 255); // 1
          inc(p);
          buffer[p]:=chr(PointX div 256); // 2
          inc(p);
          buffer[p]:=chr(PointY and 255); // 3
          inc(p);
          buffer[p]:=chr(PointY div 256); // 4
          Stream.Write(buffer,4);
          result:=result+4;
        end;
    end;
end;
procedure TDessin.ReadFromStream(Stream:TStream);
var
  buffer:array[0..2048] of Char;
  p:integer;
  nom,textacharger:string;
  couleurfonte:Tcolor32;
  longueurtexte:word;
  nombrepoints:word;
  i,j:integer;
  LePoint:TFixedPoint;
  PointX,PointY:Word;
  Rotent:Word;
  n:integer;
  procedure litcouleur(var c32:Tcolor32);
  var
    octetb,octetg,octetr,octeta:byte;
  begin
    Stream.Read(buffer,1);
    octetb:=Ord(buffer[0]);
    Stream.Read(buffer,1);
    octetg:=Ord(buffer[0]);
    Stream.Read(buffer,1);
    octetr:=Ord(buffer[0]);
    Stream.Read(buffer,1);
    octeta:=Ord(buffer[0]);
    C32:=color32(octetr,octetg,octetb,octeta);
  end;
begin
  n:=stream.position;
  Stream.Read(Buffer,24);
  p:=0;
  cat:=TCat(ord(buffer[p]));
  inc(p);
  TypetraitD:=TTypetrait(ord(buffer[p]));
  inc(p);
  TypetraceD:=TTypetrace(ord(buffer[p]));
  inc(p);
  TyperemplisD:=TRemplis(ord(buffer[p]));
  inc(p);
  Xd:=ord(buffer[p])+256*ord(buffer[p+1]);
  inc(p);inc(p);
  Yd:=ord(buffer[p])+256*ord(buffer[p+1]);
  inc(p);inc(p);
  Xf:=ord(buffer[p])+256*ord(buffer[p+1]);
  inc(p);inc(p);
  Yf:=ord(buffer[p])+256*ord(buffer[p+1]);
  inc(p);inc(p);
  XC:=ord(buffer[p])+256*ord(buffer[p+1]);
  inc(p);inc(p);
  YC:=ord(buffer[p])+256*ord(buffer[p+1]);
  inc(p);inc(p);
  RC:=ord(buffer[p])+256*ord(buffer[p+1]);
  inc(p);inc(p);
  ep:=ord(buffer[p]);
  inc(p);
  Alignement:=ord(buffer[p]);
  inc(p);
  opaciteD:=ord(buffer[p]);
  inc(p);
  Transparent:=(ord(buffer[p])<>0);
  inc(p);
  Rotent:=ord(buffer[p])+256*ord(buffer[p+1]);
  Rotation:=Rotent/100;

  litcouleur(couleurD);// 4 octets
  litcouleur(couleurFD);// 4 octets
  if cat=ctechelle then
    begin
      Stream.Read(buffer,1);
      p:=ord(buffer[0]);   // taille du nom de la fonte
      SetString(nom, nil, p);
      Stream.Read(Pointer(nom)^,p);
      nomfonte:=nom;

      litcouleur(couleurfonte);// 4 octets

      Stream.Read(Buffer,4);
      p:=0;
      TailleFonte:=Ord(buffer[p]); // 1 octet
      inc(p);
      StyleFonte:=Ord(buffer[p]); // 1 octet
      inc(p);

      longueurtexte:=Ord(buffer[p])+256*Ord(buffer[p+1]);// 3 et 4
      SetString(textacharger, nil,longueurtexte);
      Stream.Read(Pointer(textacharger)^,longueurtexte);
      NomUnite:=textacharger;
      Stream.Read(Buffer,2);
      Rotent:=ord(buffer[0])+256*ord(buffer[1]);
      CoeffEch:=Rotent/100;
    end;
  if cat=ctTxt then
    begin
      Stream.Read(buffer,1);
      p:=ord(buffer[0]);   // taille du nom de la fonte
      SetString(nom, nil, p);
      Stream.Read(Pointer(nom)^,p);
      nomfonte:=nom;

      litcouleur(couleurfonte);// 4 octets

      Stream.Read(Buffer,4);
      p:=0;
      TailleFonte:=Ord(buffer[p]); // 1 octet
      inc(p);
      StyleFonte:=Ord(buffer[p]); // 1 octet
      inc(p);

      longueurtexte:=Ord(buffer[p])+256*Ord(buffer[p+1]);// 3 et 4
      SetString(textacharger, nil,longueurtexte);
      Stream.Read(Pointer(textacharger)^,longueurtexte);
      Texte.Text:=textacharger;
    end;
  if cat=ctCrayon then
    begin
      Stream.Read(Buffer,2);
      nombrepoints:=ord(buffer[0])+256*ord(Buffer[1]);
      tracel.Clear;
      for J:=0 to nombrepoints-1 do
        begin
          Stream.Read(buffer,2);
          PointX:=ord(buffer[0])+256*ord(Buffer[1]);
          Stream.Read(Buffer,2);
          PointY:=ord(buffer[0])+256*ord(Buffer[1]);
          LePoint.X:=Round(PointX*65536);
          LePoint.Y:=Round(PointY*65536);
          tracel.Add(LePoint);
        end;
    end;
end;
}
end.
